program hist

implicit none
!integer,parameter          :: row = 13616 ,row_m=1000, bt_ob=37, row_dat =12880
!real,dimension(row,4)      :: dat_t
!real,dimension(row_m,3)    :: dat_m
!real,dimension(35)         :: lev
!real,dimension(row)        :: level_ob,ht_ob,time_ob,T_ob,qv_ob,cld_ob
!real,dimension(row_m)      :: level_m,rh_m,time_m,T_m 
!integer                    :: i,j,k,n,tt
!real,dimension(40)         :: lev_mod,pres_mod,ht_mod,ht_m
!real,dimension(368,bt_ob)  :: T_intrp
!real                       :: T_int,cld_int
!real,dimension(368,bt_ob)  :: tem_ob

integer                    :: row_obs, row_acm, bt_acm, bt_obs, i, j, k, kn
parameter(row_obs = 1000, row_acm = 40, bt_acm = 40, bt_obs=row_obs)
real, dimension(row_obs,7) :: data_obs
real, dimension(row_obs)   :: pres_obs, temp_obs, ht_obs, prs_ob, ht_ob, temp_ob
real, dimension(row_acm)   :: pres_acm, temp_acm, ht_acm 
real                       :: T_int, p_surf_hpa = 990., p_top_hpa = 109.

OPEN(unit= 10,file ='/home/deepak/OUTPUT/ACAPEX/MODEL/INITIAL_MODEL_TEMP_ACAPEX',action="READ")
!OPEN(unit= 11,file ='lev_temp_tim_acm',status='old')
OPEN(unit= 12,file ="/home/deepak/OUTPUT/ACAPEX/Matlab_scripts/ACAPEX_INPUT_SOUNDING",action="READ")

!!!! Reading data
!n = 40
          do i = 1,row_acm
                    read(10,*) ht_acm(i), pres_acm(i), temp_acm(i)
                    pres_acm(i) = pres_acm(i)/100.
                    !print*,ht_acm(i), pres_acm(i), temp_acm(i)
          enddo

          do i = 1,row_obs
                    read(12,*)(data_obs(i,k),k=1,7)
                        pres_obs(i)  = data_obs(i,1)
                        temp_obs(i)  = data_obs(i,2)
                        ht_obs(i)    = data_obs(i,7) 
                        !print*,pres_obs(i), temp_obs(i), ht_obs(i), i      
          enddo

          kn = 1
          do i = 1, row_obs
                    if (pres_obs(i) < p_top_hpa) then
                              exit
                    elseif (pres_obs(i) < P_SURF_hpa) then
                              prs_ob(kn) = pres_obs(i)
                              ht_ob(kn)  = ht_obs(i)
                              temp_ob(kn) = temp_obs(i)
                              kn = kn+1                              
                    endif
          enddo
          
          k=1
          do i = 1, row_acm-1
                    do j = 1, row_obs
                              !print*,'pres_obs(j),pres_acm(i)',pres_obs(j),pres_acm(i)+1
                              if(pres_acm(i) < pres_obs(j) .and. pres_acm(i)+1 > pres_obs(j) )then
                                        print*,pres_obs(k), ht_obs(k),temp_obs(k)
                                        k=k+1
                              endif
                    enddo
                    !stop 8767
          enddo
          stop 879
          kn = kn-1	
          !print*,'kn',kn
          !stop 8987
          !open(unit= 99,file ='temp_interpolate11111.txt',action="WRITE")
                    !do i = 1,663!row_obs,!bt_ob
                              do k = 1,row_acm
                                        call POLAT(temp_ob(1:kn),prs_ob(1:kn),T_int,pres_acm(k),bt_obs)
                                        !write(99,*) T_int,ht_acm(k)
                                        write(*,*) T_int,ht_acm(k),pres_acm(k)!,pres_obs
                                        !print*,'t_int',T_int,time_ob(i),pres_mod(k)
                              enddo	
                    !enddo   
          !close(99)

stop 

end program hist

SUBROUTINE POLAT(XV, PV, X, P, plev)

! 	INTERPOLATES XV TO PRESSURE P.
   	IMPLICIT NONE
	INTEGER, INTENT(in) :: plev


! 	Arguments:

   	REAL, INTENT(in) ::&
      	p       !
   	REAL, INTENT(in) ::&
      	XV(PLEV),    &! DATA AT RESOLUTION N
      	PV(PLEV)      ! PRESSURE AT N LEVELS
   	REAL, INTENT(out) ::&
      	X       ! DATA AT PRESSURE P

! 	Local variables:

   	INTEGER ::&
      	i, Ne, NM1
!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1
   
!       WRITE(6,2) P

!	PRINT *, "P",P
!	PRINT *, "PV(1)",PV(1)
!	PRINT *, "PV(ne)",PV(ne)
       	IF(P .LE. PV(1)) THEN
!       	WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
          	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF

       	IF(P .GE. PV(ne)) THEN
!       	WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
 
      	DO 10 I=1,NM1
    
!      	PRINT *, "PV(i+1)",PV(i+1)
!      	PRINT *, "PV(i)",PV(i)
       
	       	IF((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
!       		WRITE(6,2) P
		2     	FORMAT(2X,'POLATE P=',E12.5)
!       		write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
!       	 	PRINT *, "X_in",X
! 			PRINT *, "P_in",P
!		     	PRINT *, "XV_in",XV
!      			PRINT *, "PV_in",PV
        		X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
        		X=X*(P-PV(I+1))+XV(I+1)
!			PRINT *, "X_out",X
!       		PRINT *, "P out",P
!       		PRINT *, "XV out",XV
!       		PRINT *, "PV out",PV 
        	GO TO 1
       		ENDIF

 	10    CONTINUE
 	1     CONTINUE

END SUBROUTINE polat
