
  
        program hist

	use netcdf

        implicit none

        integer                  :: i,j, t, lifetime,   ist, bt, ew, ns,tt,n_temp_bin, n_bin_tt
	parameter(bt = 40, ew = 180, ns = 40, n_bin_tt = 17)!31)
        real, dimension(bt)      :: model_z, ni_ave_int, obs_z
        integer, allocatable     :: iav(:,:)
        integer 	             :: i_ens, nrec, k, is, ik,grid,cloud,ntest,bin_temp,min_temp
        real,dimension(n_bin_tt) :: temp_ord, lwc_cld_av_t, lwc_rain_av_t, lwc_ice_av_t, &
                                    lwc_graup_av_t, lwc_snow_av_t, temp_tt
                                    
        real, allocatable        :: RRB(:,:,:,:), W(:,:,:,:), HEIGHT(:,:,:,:), TEMP(:,:,:,:), QRAIN(:,:,:,:), &
                                    QSNOW(:,:,:,:), QGRAUP(:,:,:,:), QCLOUD(:,:,:,:), QICE(:,:,:,:), tot_cld(:,:,:,:)
                                  
        INTRINSIC 	             :: TRIM, REAL, ABS

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)

	!bin_temp = 3.
	!min_temp = -19 
	!min_temp = min_temp * -1
	n_temp_bin = 30
	bin_temp = 1.
	min_temp = 30. !-20 

!
!==========================================================================================
!		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!

		
        allocate( RRB(ew,ns,bt,ist), W(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist), TEMP(ew,ns,bt,ist), QRAIN(ew,ns,bt,ist), &
                  QSNOW(ew,ns,bt,ist), QICE(ew,ns,bt,ist), QGRAUP(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist)) 
                         
        call read_wrf4d_output('RRB',3 , RRB)
        call read_wrf4d_output('W', 1 , W)
        call read_wrf4d_output('HEIGHT',6 , HEIGHT)
        call read_wrf4d_output('TEMP',4 , TEMP)
        call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
        call read_wrf4d_output('QRAIN', 5 , QRAIN)
        call read_wrf4d_output('QICE',4 , QICE)
        call read_wrf4d_output('QSNOW',5 , QSNOW)
        call read_wrf4d_output('QGRAUP',6,QGRAUP)


	
	!do tt = 1,n_temp_bin,bin_temp
	!	temp_ord(tt) =  -1.*real(tt)
	!	print*,'temp_ord(tt)',temp_ord(tt)
	!enddo

!temp_ord(1:n_bin_tt)  = (/ 20., 18., 16., 14., 12., 10.,      &
!                           8., 6., 4., 2., 0., -2.,           &
!                          -4., -6., -8., -10., -12., -14.,    &
!                          -16., -18., -20., -22., -24., -26., &
!                          -28., -30., -32., -34., -36., -38., &
!                          -40./)

temp_ord(1:n_bin_tt)  = (/20., 16., 12., 8., 4.,       &
                          0., -4., -8., -12., -16.,    &
                         -20., -24., -28., -32., -36., &
                         -40., -44./); 
 do tt = 1, n_bin_tt
 print*,'temp_ord(tt)',temp_ord(tt)
 enddo
 

!
!=======================================================================
!			Temperature Dependency
!		Output Data written in NI200um_T_percm3
!=======================================================================
!
          do tt = 1, n_bin_tt-1 !min_temp,bin_temp
                     lwc_cld_av_t(tt) = 0.; lwc_rain_av_t(tt) = 0.; lwc_ice_av_t(tt) = 0.; 
                     lwc_snow_av_t(tt) = 0.; lwc_graup_av_t(tt) = 0.; temp_tt(tt) = 0.; ik = 0.;
                              do k=1,bt
                                        do is=1,ist
                                                  do i=1,ew
                                                            do j=1,ns
                                                                      tot_cld(i,j,k,is) = rrb(i,j,k,is)*(QCLOUD(i,j,k,is)+QICE(i,j,k,is))
                                                                      if((TEMP(i,j,k,is) < temp_ord(tt)) .and. (TEMP(i,j,k,is) > temp_ord(tt+1))) then
                                                                                if(tot_cld(i,j,k,is) > 1.e-6 .and. (W(i,j,k,is)) > 1. ) then
                                                                                          lwc_cld_av_t(tt)   = lwc_cld_av_t(tt)  + rrb(i,j,k,is)*QCLOUD(i,j,k,is)
                                                                                          lwc_rain_av_t(tt)  = lwc_rain_av_t(tt) + rrb(i,j,k,is)*QRAIN(i,j,k,is)
                                                                                          lwc_ice_av_t(tt)   = lwc_ice_av_t(tt)  + rrb(i,j,k,is)*QICE(i,j,k,is)
                                                                                          lwc_snow_av_t(tt)  = lwc_snow_av_t(tt) + rrb(i,j,k,is)*QSNOW(i,j,k,is)
                                                                                          lwc_graup_av_t(tt) = lwc_graup_av_t(tt)+ rrb(i,j,k,is)*QGRAUP(i,j,k,is)
                                                                                       
                                                                                             temp_tt(tt)  = temp_tt(tt)  + TEMP(i,j,k,is)
                                                                                          ik = ik + 1
                                                                                endif
                                                                      endif
                                                            enddo
                                                  enddo
                                        enddo
                              enddo

                              if(ik > 0) then
                                               lwc_cld_av_t(tt)   = 1.e3*lwc_cld_av_t(tt)/real(ik)      ! kg/m3  
                                               lwc_rain_av_t(tt)  = 1.e3*lwc_rain_av_t(tt)/real(ik)     ! kg/m3
                                               lwc_ice_av_t(tt)   = 1.e3*lwc_ice_av_t(tt)/real(ik)      ! kg/m3
                                               lwc_snow_av_t(tt)  = 1.e3*lwc_snow_av_t(tt)/real(ik)     ! kg/m3
                                               lwc_graup_av_t(tt) = 1.e3*lwc_graup_av_t(tt)/real(ik)    ! kg/m3 
                                               temp_tt(tt) = temp_tt(tt)/real(ik)
                              else
                                               lwc_cld_av_t(tt)   = -999.
                                               lwc_ice_av_t(tt)   = -999.
                                               lwc_snow_av_t(tt)  = -999.
                                               lwc_graup_av_t(tt) = -999.    
                                               lwc_rain_av_t(tt)  = -999.
                                               temp_tt(tt) = -999.
                              endif
          enddo

!stop 97867

          open(2,file='LWC_CLD_RAIN_ICE_SNOW_GRAUP_kgperm3',form="formatted", access="sequential",status="unknown")
                    do tt = 1, n_bin_tt-1 !min_temp,bin_temp	
                              write(2,90) temp_ord(tt), lwc_cld_av_t(tt), lwc_rain_av_t(tt), lwc_ice_av_t(tt), lwc_snow_av_t(tt), lwc_graup_av_t(tt)
                              write(*,90) temp_ord(tt), lwc_cld_av_t(tt), lwc_rain_av_t(tt), lwc_ice_av_t(tt), lwc_snow_av_t(tt), lwc_graup_av_t(tt)
                    enddo
          close(2)
          print*,''
          
          

stop
90 format(f9.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3)



        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2015-02-07_19:15:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output

       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	do 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check


 
	end
