          
  
        program hist
	use netcdf

        implicit none
        integer                :: i,j, t, lifetime,   ist, bt, ew, ns,tt,ist_part,n_temp_bin
	parameter(bt=40, ew=180, ns=40, n_temp_bin = 31)
 	real, dimension(bt)    :: model_z, ni_ave_int, obs_z
 	integer, allocatable   :: iav(:,:)
        integer                  :: i_ens, nrec, k, is, ik,grid,cloud,ntest,bin_temp,min_temp
        real                     :: ni_grid_tot, ni_grid_av(80), ni_grid,temp_ord(31),diam_av_t(31)
        real, allocatable        :: D_CW(:,:,:,:), tau_vis(:,:,:,:), ni_av(:), w(:,:,:,:), QCLOUD(:,:,:,:),	&
		                RRB(:,:,:,:), rho(:,:), nw(:,:,:,:),height(:,:,:,:), 				&
			      T_av(:),nw_av(:), QICE(:,:,:,:), tot_cld(:,:,:,:),TEMP(:,:,:,:), 		&	
			      temporary(:,:,:,:)

  	CHARACTER *2   char_smooth
    	CHARACTER *3   char_num, char_buf3
    	CHARACTER *6   char_buf
    	CHARACTER *7   char_buf7
    	CHARACTER *5   char_buf5
    	CHARACTER *7   char_buf2
    	CHARACTER *19  char_in19
    	CHARACTER *60  char_in
    	character *50  var_name
    	CHARACTER *100 char_in_big

	logical 	      :: split


        INTRINSIC :: TRIM, REAL, ABS
	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)

	!bin_temp = 3.
	!min_temp = -19 
	!min_temp = min_temp * -1
	bin_temp   = 1.
	min_temp   = -30 



!
!==========================================================================================
!			Mean Cloud Droplet Diameter (mt)
!==========================================================================================
!

        allocate   ( nw(ew,ns,bt,ist), D_CW(ew,ns,bt,ist), tau_vis(ew,ns,bt,ist),T_av(bt), ni_av(bt),rho(bt,ist),   &
                     RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), w(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist),                &
		 QICE(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist),TEMP(ew,ns,bt,ist),temporary(ew,ns,bt,61) )

	          call read_wrf4d_output('D_CW',4 , D_CW)
	          call read_wrf4d_output('TAU_VIS',7 , tau_vis)	
  	  	call read_wrf4d_output('RRB',3 , RRB)
		call read_wrf4d_output('W',1 , W)
  	  	call read_wrf4d_output('QCLOUD', 6 ,QCLOUD)
	 	call read_wrf4d_output('QICE', 4 , QICE)
  		call read_wrf4d_output('NW', 2 , NW)
		call read_wrf4d_output('HEIGHT',6 , HEIGHT)
		call read_wrf4d_output('TEMP',4 , TEMP)



	!D_CW = D_CW*1.e6
	
	
	do k=1,bt
		obs_z(k) = 0.25+REAL(k-1)*0.35  	! MARCO FORMENTON 0.35 12/21/2012 FOR STEPS because the atmosphere is more shallow.
		model_z(k) = sum(HEIGHT(2:ew-1,2:ns-1,k,2:ist-2))/real((ist-3)*(ew-2)*(ns-2)*1000.)
	enddo

	obs_z = obs_z + 0.3150				! Deepak 07-07-2020 the ground level is at 0.315 mt for MC3E!!!


        do k = 1, bt
                do is = 1, ist
                        rho(k, is) = sum(RRB(:,:,k,is))/real(ew*ns)
                end do
        end do
	
	!do tt = 1,n_temp_bin,bin_temp
	!	temp_ord(tt) =  -1.*real(tt)
	!	!print*,'temp_ord(tt)',temp_ord(tt)
	!enddo

temp_ord  = (/ 20.,18.,16.,14.,12., &
               10.,8.,6.,4.,2.,0.,  &
              -2.,-4.,-6.,-8.,-10., &
              -12.,-14.,-16.,-18.,  &
              -20.,-22.,-24.,-26.,  &
              -28.,-30.,-32.,-34.,  &
              -36.,-38.,-40. /)
 do tt = 1,n_temp_bin
 print*,'temp_ord(tt)',temp_ord(tt)
 enddo
          
! DEPENDENCE ON TEMPERATURE

          do tt=1,n_temp_bin-1
                    diam_av_t(tt) = 0.
                    ik          = 0
                              do k=1,bt
                                        do is=1,ist
                                                  do i=1,ew
                                                            do j=1,ns
                                                                      if((TEMP(i,j,k,is) .lt. temp_ord(tt)) .and. (TEMP(i,j,k,is) .gt. temp_ord(tt + bin_temp))) then
                                                                                if((nw(i,j,k,is)*rrb(i,j,k,is)/1.e6) > 5. .and. W(i,j,k,is) > 1. .and. D_CW(i,j,k,is)*1.e6 < 30. ) then !.AND. (tot_cld(i,j,k,is) .gt. 1.e-6)) then
                                                                                          diam_av_t(tt) = diam_av_t(tt) + D_CW(i,j,k,is)!*rrb(i,j,k,is)
                                                                                                   ik = ik + 1
                                                                                endif
                                                                      endif
                                                            enddo
                                                  enddo
                                        enddo
                              enddo
                              if(ik > 0) then
                                        diam_av_t(tt) = diam_av_t(tt)/REAL(ik)
                              else
                                        diam_av_t(tt) = -999.
                              endif
          enddo








	open(2,file='drop_diameter_T_um',form="formatted", access="sequential",status="unknown")

	do tt=1,n_temp_bin-1 !n_temp_bin,bin_temp
		write(2,*) diam_av_t(tt),temp_ord(tt) - bin_temp*0.5             ! meter to µm
		write(*,*) diam_av_t(tt),temp_ord(tt) - bin_temp*0.5		
	enddo
	close(2)


stop 210800
 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)
                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2015-02-07_19:15:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        

       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check


 
	end
