
  
        program hist
	use netcdf

        implicit none
        integer                    :: i,j, t, lifetime,   ist, bt, ew, ns,tt,ist_part,n_temp_bin
	parameter(bt = 40, ew=180, ns=40)
 	real, dimension(bt)      :: model_z, nw_ave_int, obs_z
 	real, dimension(16)      :: temp_ord
 	integer, allocatable     :: iav(:,:)
        integer                    :: i_ens, nrec, k, is, ik,grid,cloud,ntest,bin_temp,min_temp
        real                       :: ni_grid_tot, ni_grid_av(80), ni_grid,nw_av_t(16),sigma_nw_av_t(16)
        real, allocatable          :: ni(:,:,:,:), D_CW(:,:,:,:), tau_vis(:,:,:,:), ni_av(:), w(:,:,:,:), QCLOUD(:,:,:,:),	&
			        RRB(:,:,:,:), rho(:,:), nw(:,:,:,:),height(:,:,:,:), ni100(:,:,:,:), &
			        T_av(:), nw_av(:) ,TEMP(:,:,:,:),tot_cld(:,:,:,:), QICE(:,:,:,:)
			        
                INTRINSIC          :: TRIM, REAL, ABS
                			        
  	CHARACTER *2   char_smooth
    	CHARACTER *3   char_num, char_buf3
    	CHARACTER *6   char_buf
    	CHARACTER *7   char_buf7
    	CHARACTER *5   char_buf5
    	CHARACTER *7   char_buf2
    	CHARACTER *19  char_in19
    	CHARACTER *60  char_in
    	character *50  var_name
    	CHARACTER *100 char_in_big

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)



	n_temp_bin = 20
	bin_temp = 1.
	min_temp = -20 	 


!
!==========================================================================================
!			DROPLET NUMBER CONCENTRATION
!==========================================================================================
!

        allocate(nw(ew,ns,bt,ist), D_CW(ew,ns,bt,ist), ni(ew,ns,bt,ist), tau_vis(ew,ns,bt,ist), T_av(bt), &
                    nw_av(bt),rho(bt,ist), RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), w(ew,ns,bt,ist),      &
                    HEIGHT(ew,ns,bt,ist), TEMP(ew,ns,bt,ist),tot_cld(ew,ns,bt,ist), ni100(ew,ns,bt,ist),  &
                    QICE(ew,ns,bt,ist))


        	call read_wrf4d_output('NW',2 , nw)
         	call read_wrf4d_output('D_CW', 4, D_CW)
         	call read_wrf4d_output('TAU_VIS',7 , TAU_VIS)
       	call read_wrf4d_output('RRB',3 , RRB)
        	call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
        	call read_wrf4d_output('W', 1 , W)
	call read_wrf4d_output('HEIGHT',6 , HEIGHT)
	call read_wrf4d_output('TEMP',4 , TEMP)
        	call read_wrf4d_output('NI100',2 , ni100)
        	call read_wrf4d_output('QICE',4 , QICE)



	do k=1,bt
		obs_z(k) = 0.25+REAL(k-1)*0.35  	! MARCO FORMENTON 0.35 12/21/2012 FOR STEPS because the atmosphere is more shallow.
		model_z(k) = sum(HEIGHT(2:ew-1,2:ns-1,k,2:ist-2))/real((ist-3)*(ew-2)*(ns-2)*1000.)
	enddo

	obs_z = obs_z + 0.315		          ! Deepak 03/09/2020 the ground level is at 0.315 mt for mc3e!!!

        do k = 1, bt
                do is = 1, ist
                        rho(k, is) = sum(RRB(:,:,k,is))/real(ew*ns)
                end do
        end do
	
	!do k = 1,bt
	!DO Tt=1,n_temp_bin,bin_temp
	!	temp_ord(tt) =  -1.*real(tt)
	!enddo
	
temp_ord  = (/ 20.,16.,12.,     &
               8.,4.,0.,       &
              -4.,-8.,-12.,     &
              -16.,-20.,-24.,    &
              -28.,-32.,-36.,-40. /)
 do tt = 1,16
 print*,'temp_ord(tt)',temp_ord(tt)
 enddo
 

	DO Tt=1,15 !n_temp_bin,bin_temp
			nw_av_t(tt) = 0.
			ik = 0
		do k=1,bt
			do is= 1,ist
				do i= 60,130!1,ew
					do j=1,ns
					tot_cld(i,j,k,is) = QCLOUD(i,j,k,is)*rrb(i,j,k,is)
						IF((TEMP(i,j,k,is) .lt. temp_ord(tt)) .and. (TEMP(i,j,k,is) .gt. temp_ord(tt + 1))) then
						          if((W(i,j,k,is)) < 8.)then
							          if((nw(i,j,k,is)*rrb(i,j,k,is)/1.e6) > 5. .and. tot_cld(i,j,k,is) > 1.e-6 .and. &
							             (W(i,j,k,is)) > 1. .and. D_CW(i,j,k,is) < 30.e-6 .and. ni100(i,j,k,is) < 500.) then
								          nw_av_t(tt) = nw_av_t(tt) + nw(i,j,k,is)*rrb(i,j,k,is)                ! perkg to perm3
								          ik = ik + 1
							          endif
							endif
						endif
					enddo
				enddo
			enddo
		enddo
		if(ik > 0) then
			nw_av_t(tt) = nw_av_t(tt)/REAL(ik)

		else
			nw_av_t(tt) = -999.
		endif
	ENDDO





	open(2,file='drop_num_conc_T_percm3',form="formatted", access="sequential",status="unknown")

	!do tt=1,20	
	DO Tt=1,16 !n_temp_bin ,bin_temp	
		write(2,*) nw_av_t(tt)/1.e6,temp_ord(tt) - bin_temp*0.5               ! perm3 to percm3
		print*,nw_av_t(tt)/1.e6,temp_ord(tt) - bin_temp*0.5
	enddo
	close(2)



stop
 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)
                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2015-02-07_19:15:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output



       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check


 
	end
