
  
          program hist
          use netcdf

          implicit none
          integer                       :: i,j, t, lifetime,   ist, bt, ew, ns, t28col, t28raw, bin_num,ist_part
          ! parameter ( ist=100, bt = 40, ew=80, ns=80, t28raw=20, t28col=5036, bin_num = 54 )
          parameter(ew = 180, ns = 40, bt = 40, t28raw = 20, t28col = 5036, bin_num = 120)
          real, dimension(bt)           :: model_z, nw_ave_int, obs_z
          integer, allocatable          :: iav(:,:)
          integer                       :: i_ens, nrec, k, is, ik,grid,cloud,ntest,length_data
          real                          :: ni_grid_tot, ni_grid_av(80), ni_grid
          real ( kind = 8 )             :: bin_min,bin_max
          real, allocatable             :: ni(:,:,:,:), tot_cld(:,:,:,:), ni_av(:), w(:,:,:,:), QCLOUD(:,:,:,:),	&
		                       RRB(:,:,:,:), rho(:,:), QICE(:,:,:,:),height(:,:,:,:), &
	                                 nw_av(:), ZREFLH(:,:,:,:),TEMP(:,:,:,:)
          REAL, DIMENSION(20,5306)      :: LWC_DMT,TIME,T28W
          REAL, DIMENSION(200000)       :: raw_in,test
          REAL, DIMENSION(bin_num)      :: final_hist,final_bins,hist_cum
          CHARACTER *2 char_smooth
          CHARACTER *3 char_num, char_buf3
          CHARACTER *6 char_buf
          CHARACTER *7 char_buf7
          CHARACTER *5 char_buf5
          CHARACTER *7 char_buf2
          CHARACTER *19 char_in19
          logical :: split
          CHARACTER *60 char_in
          character*50 var_name
          CHARACTER *100 char_in_big
          
          INTRINSIC :: TRIM, REAL, ABS
          
          open(10,file='ist',status="unknown")
                    read(10,*) ist
          close (10)

	bin_min = 1.	!minimum value for updrafts
	bin_max = 4.
	length_data = 1
	raw_in = 0.
	test = 0.	
	split = .false.
	!if(ist_part < 80.) then
	!	split = .true.
	!endif

!
!==========================================================================================
!			Vertical Velocity Histogram Profile
!==========================================================================================
!

        allocate(QICE(ew,ns,bt,ist), ni(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist), nw_av(bt),rho(bt,ist),  &
                 RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), w(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist), &
		  ZREFLH(ew,ns,bt,ist),TEMP(ew,ns,bt,ist))
		  
          if(split .eq. .true. ) then
                    call read_wrf4d_output_1('W',1 , w)
                    call read_wrf4d_output_1('RRB',3 , rrb)
                    call read_wrf4d_output_1('QCLOUD',6 , QCLOUD)
                    call read_wrf4d_output_1('QICE',4 , QICE)	
                    call read_wrf4d_output_1('HEIGHT',6 , HEIGHT)
                    call read_wrf4d_output_1('ZREFLH',6 , ZREFLH)
                    call read_wrf4d_output_2('W',1 , w)
                    call read_wrf4d_output_2('RRB',3 , rrb)
                    call read_wrf4d_output_2('QCLOUD',6 , QCLOUD)
                    call read_wrf4d_output_2('QICE',4 , QICE)	
                    call read_wrf4d_output_2('HEIGHT',6 , HEIGHT)
                    !call read_wrf4d_output_2('ZREFLH',6 , ZREFLH)
          else
                    call read_wrf4d_output('W',1 , w)
                    call read_wrf4d_output('RRB',3 , RRB)
                    call read_wrf4d_output('QCLOUD',6 , QCLOUD)
                    call read_wrf4d_output('QICE',4 , QICE)	
                    call read_wrf4d_output('HEIGHT',6 , HEIGHT)
                    !call read_wrf4d_output('ZREFLH',6 , ZREFLH)
                    call read_wrf4d_output('TEMP',4 , TEMP)		
          endif



	ik = 1

	do k=1,40
		do is=1,ist
			do i=1,ew
				do j=1,ns
					!if(HEIGHT(i,j,k,is) < 8000. .and. HEIGHT(i,j,k,is) > 3000.)then
					if(TEMP(i,j,k,is) < -5. .and. TEMP(i,j,k,is) > -36.) THEN
						tot_cld(i,j,k,is) = (QCLOUD(i,j,k,is) + QICE(i,j,k,is)) * RRB(i,j,k,is)	!From kg/kg to kg/m3
						          if(w(i,j,k,is) > bin_min .and. tot_cld(i,j,k,is) .gt. 1.e-6) then  
						          !if(w(i,j,k,is) > bin_min .and. ZREFLH(i,j,k,is) .le. 30.) THEN
							          raw_in(ik) = w(i,j,k,is)
							          ik = ik + 1
						          endif
					endif
				enddo
			enddo
		enddo
	enddo
	
	length_data = ik	
	bin_max = 30. !max(14.37,MAXVAL(raw_in))

	call my_hist(raw_in,bin_min,bin_max,bin_num,length_data,final_hist,final_bins)

	hist_cum(bin_num) = final_hist(bin_num)
	do i= bin_num-1,1,-1
		hist_cum(i) = final_hist(i) + hist_cum(i+1)		!Calculate the cumulative distribution
	enddo



	open(4, file ='test_hist_w_wrf_ACAPEX.txt', status = 'UNKNOWN')
	if(maxval(hist_cum) > 0.) then
		do i= 1,bin_num	
			write(4,*) 100.*hist_cum(i)/maxval(hist_cum),final_bins(i)
		enddo
	else
		do i= 1,bin_num	
			write(4,*) 0.,final_bins(i)
		enddo

	endif
	
	close(4)

	
	stop



        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)
                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2015-02-07_19:15:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        SUBROUTINE read_wrf4d_output_1(var, nvar, WRFVAR)
                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2011-05-10_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                real , Dimension(ew,ns,bt,ist_part):: TEMPORARY	
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, TEMPORARY) )
		WRFVAR(:,:,:,1:61) =temporary(:,:,:,1:61) 

        end subroutine read_wrf4d_output_1

        SUBROUTINE read_wrf4d_output_2(var, nvar, WRFVAR)
                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2011-05-10_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                real , Dimension(ew,ns,bt,ist_part):: TEMPORARY			
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, TEMPORARY) )
		WRFVAR(:,:,:,62:121) =temporary(:,:,:,2:61) 
        end subroutine read_wrf4d_output_2



       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check


 
	end
