
  
        program hist

	use netcdf

        implicit none

        integer                :: i,j, k, is, ew, ns, bt, ist, ik
	parameter(ew = 40, ns = 40, bt = 40)

        real, allocatable      :: ZREFL(:,:,:,:), RRB(:,:,:,:), QCLOUD(:,:,:,:), QICE(:,:,:,:),   &
                                  W(:,:,:,:), HEIGHT(:,:,:,:), TEMP(:,:,:,:), PB(:,:,:,:),        &
                                  P(:,:,:,:), refl_avg(:,:), ht_avg(:), temp_avg(:), pres_avg(:), &
                                  zrefl_avg(:,:), tot_cld(:,:,:,:), NI(:,:,:,:), NSNOW(:,:,:,:),  &
                                  NGRAUP(:,:,:,:), N_DUST_ACT(:,:,:,:), n_ice_av(:,:),            &
                                  n_dust_av(:,:), q_cld_av(:,:)
                                  
        INTRINSIC 	           :: TRIM, REAL, ABS
        

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)
 

!
!==========================================================================================
!		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!
          
          allocate(ZREFL(ew,ns,bt,ist), RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), QICE(ew,ns,bt,ist),   &
                   W(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist), TEMP(ew,ns,bt,ist), PB(ew,ns,bt,ist),        &
                   P(ew,ns,bt,ist), ht_avg(bt), temp_avg(bt), pres_avg(bt), zrefl_avg(bt,ist),         &
                   tot_cld(ew,ns,bt,ist), NI(ew,ns,bt,ist), NSNOW(ew,ns,bt,ist), NGRAUP(ew,ns,bt,ist), &
                   N_DUST_ACT(ew,ns,bt,ist), n_ice_av(bt,ist), n_dust_av(bt,ist), q_cld_av(bt,ist))
                   
          call read_wrf4d_output('ZREFL',5 , ZREFL)        
          call read_wrf4d_output('RRB',3 , RRB)
          call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
          call read_wrf4d_output('QICE', 4 , QICE)
          call read_wrf4d_output('W', 1 , W)
          call read_wrf4d_output('HEIGHT',6 , HEIGHT)
          call read_wrf4d_output('TEMP',4 , TEMP)
          call read_wrf4d_output('PB',2 , PB)
          call read_wrf4d_output('P',1 , P)
          call read_wrf4d_output('NI',2,NI)
          call read_wrf4d_output('NSNOW',5,NSNOW)
          call read_wrf4d_output('NGRAUP',6,NGRAUP)
          call read_wrf4d_output('N_DUST_ACT', 10 , N_DUST_ACT)


          do k = 1, bt
                    do is = 1, ist
                              n_ice_av(k,is) = 0.; n_dust_av(k,is) = 0.; q_cld_av(k,is) = 0.; ik = 0;
                              do i = 1, ew
                                        do j = 1, ns 
                                                  tot_cld(i,j,k,is) = rrb(i,j,k,is)*(QCLOUD(i,j,k,is)+QICE(i,j,k,is))
                                                  if(abs(W(i,j,k,is)) < 1. .and. tot_cld(i,j,k,is) > 1.e-6)then
                                                            n_ice_av(k,is) = n_ice_av(k,is) + rrb(i,j,k,is)*(NI(i,j,k,is)+NSNOW(i,j,k,is)+NGRAUP(i,j,k,is))
                                                            n_dust_av(k,is) = n_dust_av(k,is) + rrb(i,j,k,is)*N_DUST_ACT(i,j,k,is)
                                                            q_cld_av(k,is) = q_cld_av(k,is) + rrb(i,j,k,is)*QCLOUD(i,j,k,is)
                                                            ik = ik + 1
                                                  endif
                                        enddo
                              enddo
                              
                              if(ik > 1)then
                                        n_ice_av(k,is)  = n_ice_av(k,is)/real(ik)
                                        n_dust_av(k,is) = n_dust_av(k,is)/real(ik)
                                        q_cld_av(k,is) = 1.e3*q_cld_av(k,is)/real(ik)
                              else
                                        n_ice_av(k,is)  = -999.
                                        n_dust_av(k,is) = -999.
                                        q_cld_av(k,is) = -999.  
                              endif
                    enddo
          enddo

          do k = 1, bt
          ht_avg(k) = 0.; temp_avg(k) = 0.; pres_avg(k) = 0.; ik = 0;
                    do is = 1, ist
                              do i = 1, ew
                                        do j = 1, ns
                                                  ht_avg(k)   = ht_avg(k) + HEIGHT(i,j,k,is)
                                                  pres_avg(k) = pres_avg(k) + (PB(i,j,k,is)+P(i,j,k,is))
                                                  temp_avg(k) = temp_avg(k) + TEMP(i,j,k,is)
                                                  ik = ik + 1
                                        enddo
                              enddo
                    enddo
                    if(ik > 1)then
                              ht_avg(k)   = ht_avg(k)/real(ik)
                              pres_avg(k) = pres_avg(k)/real(ik)
                              temp_avg(k) = temp_avg(k)/real(ik)
                    else
                              ht_avg(k)   = -999.
                              pres_avg(k) = -999.
                              temp_avg(k) = -999.
                    endif
          enddo

          open(2,file='NUM_TOT_ICE_HT_APPRAISE_percm3',form="formatted", access="sequential",status="unknown")
                    do k = 1, bt
                              do is = 1, ist	
                                        write(2,*) n_ice_av(k,is)/1.e6
                              enddo	   
                    enddo
          close(2)
          
          open(2,file='NUM_DUST_ACT_HT_APPRAISE_percm3',form="formatted", access="sequential",status="unknown")
                    do k = 1, bt
                              do is = 1, ist	
                                        write(2,*) n_dust_av(k,is)/1.e6
                              enddo	   
                    enddo
          close(2)
          
          open(2,file='CLD_LIQ_HT_APPRAISE_kgperm3',form="formatted", access="sequential",status="unknown")
                    do k = 1, bt
                              do is = 1, ist	
                                        write(2,*) q_cld_av(k,is)
                              enddo	   
                    enddo
          close(2)
          
          open(2,file='MEAN_HT_PRES_TEMP_APPRAISE',form="formatted", access="sequential",status="unknown")

          do k = 1, bt	
                    write(2,*) ht_avg(k), pres_avg(k), temp_avg(k)
          enddo
          
          
          open(2,file='TIME_HRS_APPRAISE',form="formatted", access="sequential",status="unknown")

          do is = 1, ist	
                    write(2,*) 47.+is*10./(24.*60.)
                    write(*,*) 47.+is*10./(24.*60.)
          enddo
          close(2)

stop
 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2009-02-17_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check
        
       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat




 
	end
