
  
        program hist

	use netcdf

        implicit none

        integer                :: i,j, k, is, ew, ns, bt, ist, ik, jk, kk, tt, ntemp, is_start, is_end
	parameter(ew = 40, ns = 40, bt = 40, ntemp = 17)

        real, dimension(ntemp) :: temp_bin, qcld_avg, qice_avg, temp_avg, ht_avg
        real, allocatable      :: ZREFL(:,:,:,:), RRB(:,:,:,:), QCLOUD(:,:,:,:), QICE(:,:,:,:),   &
                                  W(:,:,:,:), HEIGHT(:,:,:,:), TEMP(:,:,:,:), PB(:,:,:,:),        &
                                  P(:,:,:,:), refl_avg(:,:), tot_cld(:,:,:,:), q_cld(:,:,:,:),    &
                                  q_ice(:,:,:,:)
        real                   :: dt_prim, w_prim, vt_rain, dnfbydT_Xx, dTbydz                      
        INTRINSIC 	           :: TRIM, REAL, ABS
        

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)
 

!
!==========================================================================================
!		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!
          
          allocate(ZREFL(ew,ns,bt,ist), RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), QICE(ew,ns,bt,ist), &
                   W(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist), TEMP(ew,ns,bt,ist), PB(ew,ns,bt,ist),      &
                   P(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist), q_cld(ew,ns,bt,ist), q_ice(ew,ns,bt,ist))
          
          call read_wrf4d_output('ZREFL',5 , ZREFL)        
          call read_wrf4d_output('RRB',3 , RRB)
          call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
          call read_wrf4d_output('QICE', 4 , QICE)
          call read_wrf4d_output('W', 1 , W)
          call read_wrf4d_output('HEIGHT',6 , HEIGHT)
          call read_wrf4d_output('TEMP',4 , TEMP)
          call read_wrf4d_output('PB',2 , PB)
          call read_wrf4d_output('P',1 , P)

dt_prim = 2.; w_prim = 3.; vt_rain = 2.; dnfbydT_Xx = 2.; dTbydz = -0.2 !9.8
print*,max(0.0, dt_prim * (w_prim - vt_rain)*dnfbydT_Xx*dTbydz)
print*,dt_prim*min((w_prim - vt_rain)*dTbydz,0.)*dnfbydT_Xx
stop 9090
temp_bin = (/0., -2., -4., -6., -8., -10., -12., -14., -16., -18., -20., -22., -24., -26., -28., -30., -32./);

is_start = 144; is_end = ist

          do tt = 1, ntemp-1
          qcld_avg(tt) = 0.; qice_avg(tt) = 0.; 
          temp_avg(tt) = 0.; ht_avg(tt) = 0.; 
          ik = 0; jk = 0; kk = 0;
                    do is = is_start, is_end !1, ist
                              do i = 1, ew
                                        do j = 1, ns
                                                  do k = 1, bt
                                                            if(TEMP(i,j,k,is) <= temp_bin(tt) .and. TEMP(i,j,k,is) >= temp_bin(tt+1))then
                                                                      if(QCLOUD(i,j,k,is) > 1.E-06)then
                                                                                qcld_avg(tt) = qcld_avg(tt) + QCLOUD(i,j,k,is)
                                                                                ik = ik + 1
                                                                      endif
                                                                      
                                                                      if(QICE(i,j,k,is) > 1.E-06)then
                                                                                qice_avg(tt) = qice_avg(tt) + QICE(i,j,k,is)
                                                                                jk = jk + 1
                                                                      endif
                                                                      temp_avg(tt) = temp_avg(tt) + TEMP(i,j,k,is)
                                                                      ht_avg(tt)   = ht_avg(tt) + HEIGHT(i,j,k,is)
                                                                      kk = kk + 1
                                                            endif
                                                  enddo
                                        enddo
                              enddo
                    enddo
                                        
                    if(ik > 0)then
                              qcld_avg(tt) = qcld_avg(tt)/real(ik)
                    else
                              qcld_avg(tt) = -999.
                    endif
                    
                    if(jk > 0)then
                              qice_avg(tt) = qice_avg(tt)/real(jk)
                    else
                              qice_avg(tt) = -999.
                    endif
                    
                    if(kk > 0)then
                              temp_avg(tt) = temp_avg(tt)/real(kk)
                              ht_avg(tt)   = ht_avg(tt)/real(kk)
                    else
                              temp_avg(tt) = -999.
                              ht_avg(tt)   = -999.
                    endif
          enddo


          open(2,file='qcloud_gperkg_appraise',form="formatted", access="sequential",status="unknown")

          do tt = 1, ntemp-1
                    write(2,*)temp_bin(tt),ht_avg(tt),qcld_avg(tt)*1.e3          ! g/g to g/kg	   
          enddo
          close(2)
          
          print*,''
          
          open(2,file='qice_gperkg_appraise',form="formatted", access="sequential",status="unknown")

          do tt = 1, ntemp-1	
                    write(2,*)temp_bin(tt),ht_avg(tt),qice_avg(tt)*1.e3          ! g/g to g/kg
          enddo
          close(2)                   
stop
 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2009-02-17_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check
        
       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat




 
	end
