
  
        program hist

	use netcdf

        implicit none

        integer                :: i,j, k, is, t, ik, lifetime, ist, bt, ew, ns, tt, nt, nht,is_start, is_end
	parameter(ew = 40, ns = 40, bt = 40, nt = 22, nht = 21)
        !real,dimension(nt)     :: temp_ord, ni100_av_t, ni_tot_av_t, ht_acm 
        real,dimension(nt)      :: temp_ord, ni100_av_t, ni_tot_av_t, ht_acm, n_inp_dust, n_inp_so, n_inp_bc, &
                                   n_inp_bio, n_inp_alg, n_inp_bct, n_inp_dts, n_inp_fng, n_inp_pln, n_tot_prim
        real                   :: bin_temp

        real, allocatable      :: nw(:,:,:,:), NI100UM(:,:,:,:), NSNOW200um(:,:,:,:), NGRAUP200um(:,:,:,:),        &
                                  NI(:,:,:,:), NSNOW(:,:,:,:), NGRAUP(:,:,:,:), tau_vis(:,:,:,:), ni_av(:),        &
                                  rho(:,:), RRB(:,:,:,:), QCLOUD(:,:,:,:), w(:,:,:,:), HEIGHT(:,:,:,:),            &
			    QICE(:,:,:,:), tot_cld(:,:,:,:), TEMP(:,:,:,:), temp_tt(:), D_CI(:,:,:,:),       &
                                  D_SNOW(:,:,:,:), D_GRAUP(:,:,:,:), ht_bin(:), N_DUST_ACT(:,:,:,:),               &
                                  N_sO_ACT(:,:,:,:), N_BC_ACT(:,:,:,:), N_BIO_ACT(:,:,:,:), N_ALG_ACT(:,:,:,:),    &
                                  N_BCT_ACT(:,:,:,:), N_DTS_ACT(:,:,:,:), N_FNG_ACT(:,:,:,:), N_PLN_ACT(:,:,:,:),  &
                                  N_sO_IN_ACT(:,:,:,:), N_ICE_PRIM(:,:,:,:), N_SNOW_PRIM(:,:,:,:)
                                  
        INTRINSIC 	         :: TRIM, REAL, ABS
        
	bin_temp = 1.

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)
 

!
!==========================================================================================
!		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!

        allocate(nw(ew,ns,bt,ist), NI100UM(ew,ns,bt,ist), NSNOW200um(ew,ns,bt,ist), NGRAUP200um(ew,ns,bt,ist),       &
                 NI(ew,ns,bt,ist), NSNOW(ew,ns,bt,ist), NGRAUP(ew,ns,bt,ist), tau_vis(ew,ns,bt,ist), ni_av(bt),      &
                 rho(bt,ist), RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), W(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist),        &
                 QICE(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist),TEMP(ew,ns,bt,ist), temp_tt(nt), D_CI(ew,ns,bt,ist),      &
                 D_SNOW(ew,ns,bt,ist), D_GRAUP(ew,ns,bt,ist), ht_bin(nht), N_DUST_ACT(ew,ns,bt,ist),                 &
                 N_sO_ACT(ew,ns,bt,ist), N_BC_ACT(ew,ns,bt,ist), N_BIO_ACT(ew,ns,bt,ist), N_ALG_ACT(ew,ns,bt,ist),   &
                 N_BCT_ACT(ew,ns,bt,ist), N_DTS_ACT(ew,ns,bt,ist), N_FNG_ACT(ew,ns,bt,ist), N_PLN_ACT(ew,ns,bt,ist), &
                 N_sO_IN_ACT(ew,ns,bt,ist), N_ICE_PRIM(ew,ns,bt,ist), N_SNOW_PRIM(ew,ns,bt,ist))

          call read_wrf4d_output('NI100UM',7,NI100UM) 
          call read_wrf4d_output('NSNOW200UM',10,NSNOW200UM)
          call read_wrf4d_output('NGRAUP200UM',11,NGRAUP200UM) 
          call read_wrf4d_output('NI',2,NI) 
          call read_wrf4d_output('NSNOW',5,NSNOW)
          call read_wrf4d_output('NGRAUP',6,NGRAUP)
          call read_wrf4d_output('TAU_VIS',7 ,TAU_VIS)
          call read_wrf4d_output('RRB',3 , RRB)
          call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
          call read_wrf4d_output('QICE', 4 , QICE)
          call read_wrf4d_output('W', 1 , W)
          call read_wrf4d_output('HEIGHT',6 , HEIGHT)
          call read_wrf4d_output('TEMP',4 , TEMP)
          call read_wrf4d_output ('N_DUST_ACT',10, N_DUST_ACT)	
          !call read_wrf4d_output ('N_sO_ACT',8, N_sO_ACT)				
          call read_wrf4d_output ('N_BC_ACT',8, N_BC_ACT)				
          call read_wrf4d_output ('N_BIO_ACT',9, N_BIO_ACT)	
          call read_wrf4d_output ('N_ALG_ACT',9, N_ALG_ACT)				
          call read_wrf4d_output ('N_BCT_ACT',9, N_BCT_ACT)				
          call read_wrf4d_output ('N_DTS_ACT',9, N_DTS_ACT)				
          call read_wrf4d_output ('N_FNG_ACT',9, N_FNG_ACT)				
          call read_wrf4d_output ('N_PLN_ACT',9, N_PLN_ACT)				
          call read_wrf4d_output ('N_sO_IN_ACT',11, N_sO_IN_ACT)			
          call read_wrf4d_output ('N_ICE_prim',10, N_ICE_prim)				
          call read_wrf4d_output ('N_SNOW_prim',11, N_SNOW_prim)

!temp_ord(1:nt)  = (/ 20.,16.,12.,      &
!                     8.,4.,0.,         &
!                    -4.,-8.,-12.,      &
!                    -16.,-20.,-24.,    &
!                    -28.,-32.,-36.,-40., -44., -48. /)

temp_ord(1:nt) = -1.*(/0., 1., 2., 3., 4., 5., 6., 7., 8., 9., 10.,      &
                       11., 12., 13., 14., 15., 16., 17., 18., 19., 20., &
                       21./)

ht_bin(1:nht)  = (/300., 600., 900., 1200., 1500., 1800., 2100., 2400., 2700., 3000.,    &
                   3300., 3600., 3900., 4200., 4500., 4800., 5100., 5400., 5700., 6000., &
                   6300./);
 do tt = 1,nt
 print*,'temp_ord(tt)',temp_ord(tt)
 enddo
 
!
!=======================================================================
!			Temperature Dependency
!		Output Data written in NI100UM_T_percm3
!=======================================================================
!

is_start = 144; is_end = ist
          !do tt = 1,nt-1 !min_temp,bin_temp 
          do tt = 1,nt-1 
          ni100_av_t(tt) = 0.; ni_tot_av_t(tt)  = 0.; ht_acm(tt) = 0.; n_inp_sO(tt) = 0.; n_tot_prim(tt) = 0. ; ik = 0;
                    do k=1,bt
                              do is= is_start, is_end !1,ist
                                        do i=1,ew
                                                  do j=1,ns
                                                            tot_cld(i,j,k,is) = rrb(i,j,k,is)*(QCLOUD(i,j,k,is)+QICE(i,j,k,is))
                                                            !if(HEIGHT(i,j,k,is) > ht_bin(tt) .and. HEIGHT(i,j,k,is) < ht_bin(tt+1))then
                                                            if((TEMP(i,j,k,is) .lt. temp_ord(tt)) .and. (TEMP(i,j,k,is) .gt. temp_ord(tt + 1))) then
                                                                      if(tot_cld(i,j,k,is) > 1.e-6 .and. abs(W(i,j,k,is)) < 1) then
                                                                                
                                                                                n_inp_dust(tt) = n_inp_dust(tt) + rrb(i,j,k,is)*N_DUST_ACT(i,j,k,is)
                                                                                n_inp_bc(tt)   = n_inp_bc(tt)   + rrb(i,j,k,is)*N_BC_ACT(i,j,k,is)
                                                                                n_inp_alg(tt)  = n_inp_alg(tt)  + rrb(i,j,k,is)*N_ALG_ACT(i,j,k,is)
                                                                                n_inp_bct(tt)  = n_inp_bct(tt)  + rrb(i,j,k,is)*N_BCT_ACT(i,j,k,is)
                                                                                n_inp_dts(tt)  = n_inp_dts(tt)  + rrb(i,j,k,is)*N_DTS_ACT(i,j,k,is)
                                                                                n_inp_fng(tt)  = n_inp_fng(tt)  + rrb(i,j,k,is)*N_FNG_ACT(i,j,k,is)
                                                                                n_inp_pln(tt)  = n_inp_pln(tt)  + rrb(i,j,k,is)*N_PLN_ACT(i,j,k,is)
                                                                                n_inp_sO(tt)  = n_inp_sO(tt)  + rrb(i,j,k,is)*N_sO_IN_ACT(i,j,k,is)
                                                                                n_tot_prim(tt) = n_tot_prim(tt) + rrb(i,j,k,is)*(N_ICE_PRIM(i,j,k,is)+N_SNOW_PRIM(i,j,k,is))
                                                                                ik = ik + 1
                                                                      endif
                                                                                !temp_tt(tt)  = temp_tt(tt)  + TEMP(i,j,k,is)
                                                                                !ht_acm(tt)   = ht_acm(tt) + HEIGHT(i,j,k,is)
                                                                      !endif
                                                            endif
                                                  enddo
                                        enddo
                              enddo
                    enddo

                    if(ik > 0) then
                              n_inp_dust(tt) = n_inp_dust(tt)/real(ik)
                              n_inp_bc(tt)   = n_inp_bc(tt)/real(ik)   
                              n_inp_alg(tt)  = n_inp_alg(tt)/real(ik)  
                              n_inp_bct(tt)  = n_inp_bct(tt)/real(ik)  
                              n_inp_dts(tt)  = n_inp_dts(tt)/real(ik)  
                              n_inp_fng(tt)  = n_inp_fng(tt)/real(ik) 
                              n_inp_pln(tt)  = n_inp_pln(tt)/real(ik) 
                              n_inp_sO(tt)   = n_inp_sO(tt)/real(ik) 
                              n_tot_prim(tt) = n_tot_prim(tt)/real(ik) 
                    else
                              n_inp_dust(tt) = -999. 
                              n_inp_bc(tt)   = -999.    
                              n_inp_alg(tt)  = -999.
                              n_inp_bct(tt)  = -999.
                              n_inp_dts(tt)  = -999.
                              n_inp_fng(tt)  = -999.
                              n_inp_pln(tt)  = -999.
                              n_inp_sO(tt)   = -999. 
                              n_tot_prim(tt) = -999. 
                    endif
          enddo

!stop 97867


          open(2,file='N_INP_ACT_SPECIES_T_perm3',form="formatted", access="sequential",status="unknown")
          do tt = 1,nt-1 !min_temp,bin_temp	
                    write(2,90) temp_ord(tt), n_inp_dust(tt), n_inp_bc(tt), n_inp_alg(tt), n_inp_bct(tt), n_inp_dts(tt), n_inp_fng(tt), n_inp_pln(tt), n_inp_sO(tt)
                    write(*,90) temp_ord(tt), n_inp_dust(tt), n_inp_bc(tt), n_inp_alg(tt), n_inp_bct(tt), n_inp_dts(tt), n_inp_fng(tt), n_inp_pln(tt), n_inp_sO(tt)	   
          enddo
          close(2)

          print*,''
          
          open(2,file='N_PRIMARY_ICE_T_perm3',form="formatted", access="sequential",status="unknown")
          do tt = 1,nt-1 !min_temp,bin_temp	
                    write(2,90) temp_ord(tt), n_tot_prim(tt)
                    write(*,90) temp_ord(tt), n_tot_prim(tt)/1.e6	   
          enddo
          close(2)
stop
90 format(f9.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3)

 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2009-02-17_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check
        
       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat




 
	end
