
  
        program hist

	use netcdf

        implicit none

        integer                :: i,j, k, is, ew, ns, bt, ist, ik, jk, is_start, is_end
	parameter(ew = 40, ns = 40, bt = 40)

        real, allocatable      :: ZREFL(:,:,:,:), RRB(:,:,:,:), QCLOUD(:,:,:,:), QICE(:,:,:,:),   &
                                  W(:,:,:,:), HEIGHT(:,:,:,:), TEMP(:,:,:,:), PB(:,:,:,:),        &
                                  P(:,:,:,:), refl_avg(:,:), ht_avg(:), temp_avg(:), pres_avg(:), &
                                  lwc_avg(:,:), iwc_avg(:,:), tot_cld(:,:,:,:), q_cld(:,:,:,:),   &
                                  q_ice(:,:,:,:)
                                  
        INTRINSIC 	           :: TRIM, REAL, ABS
        

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)
 

!
!==========================================================================================
!		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!
          
          allocate(ZREFL(ew,ns,bt,ist), RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), QICE(ew,ns,bt,ist), &
                   W(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist), TEMP(ew,ns,bt,ist), PB(ew,ns,bt,ist),      &
                   P(ew,ns,bt,ist), ht_avg(bt), temp_avg(bt), pres_avg(bt), lwc_avg(bt,ist),         &
                   iwc_avg(bt,ist), tot_cld(ew,ns,bt,ist), q_cld(ew,ns,bt,ist), q_ice(ew,ns,bt,ist))
          
          call read_wrf4d_output('ZREFL',5 , ZREFL)        
          call read_wrf4d_output('RRB',3 , RRB)
          call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
          call read_wrf4d_output('QICE', 4 , QICE)
          call read_wrf4d_output('W', 1 , W)
          call read_wrf4d_output('HEIGHT',6 , HEIGHT)
          call read_wrf4d_output('TEMP',4 , TEMP)
          call read_wrf4d_output('PB',2 , PB)
          call read_wrf4d_output('P',1 , P)

is_start = 144; is_end = ist
          do k = 1, bt
                    do is = 1, ist
                              lwc_avg(k,is) = 0.; ik = 0; iwc_avg(k,is) = 0.; jk = 0;
                              do i = 1, ew
                                        do j = 1, ns
                                        q_cld(i,j,k,is) = rrb(i,j,k,is)*QCLOUD(i,j,k,is)
                                        q_ice(i,j,k,is) = rrb(i,j,k,is)*QICE(i,j,k,is)
                                                  if(q_cld(i,j,k,is) > 1.E-06)then
                                                            lwc_avg(k,is) = lwc_avg(k,is) + QCLOUD(i,j,k,is)
                                                            ik = ik + 1
                                                  endif
                                                  
                                                  if(q_ice(i,j,k,is) > 1.E-06)then
                                                            iwc_avg(k,is) = iwc_avg(k,is) + QICE(i,j,k,is)
                                                            jk = jk + 1
                                                  endif
                                        enddo
                              enddo
                              
                              if(ik > 1)then
                                        lwc_avg(k,is) = lwc_avg(k,is)/real(ik)
                              else
                                        lwc_avg(k,is) = -999.
                              endif
                              
                              if(jk > 1)then
                                        iwc_avg(k,is) = iwc_avg(k,is)/real(jk)
                              else
                                        iwc_avg(k,is) = -999.
                              endif
                    enddo
          enddo


          open(2,file='qcloud_ht_time_appraise',form="formatted", access="sequential",status="unknown")

          do k = 1, bt
                    do is = 1, ist	
                              write(2,*) lwc_avg(k,is)
                    enddo	   
          enddo
          close(2)
 
          open(2,file='qice_ht_time_appraise',form="formatted", access="sequential",status="unknown")

          do k = 1, bt
                    do is = 1, ist	
                              write(2,*) iwc_avg(k,is)
                    enddo	   
          enddo
          close(2)                   
stop
 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2009-02-17_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check
        
       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat




 
	end
