
  
        program hist

	use netcdf

        implicit none

        integer                :: i,j, k, is, t, ik, lifetime, ist, bt, ew, ns, tt, nt
	parameter(ew = 80, ns = 80, bt = 40, nt = 13)
        real,dimension(nt)     :: temp_ord, ni100_av_t, ni_tot_av_t, ht_acm
        real                   :: bin_temp

        real, allocatable      :: nw(:,:,:,:), NI100UM(:,:,:,:), NSNOW200um(:,:,:,:), NGRAUP200um(:,:,:,:),        &
                                  NI(:,:,:,:), NSNOW(:,:,:,:), NGRAUP(:,:,:,:), tau_vis(:,:,:,:), ni_av(:),        &
                                  rho(:,:), RRB(:,:,:,:), QCLOUD(:,:,:,:), w(:,:,:,:), HEIGHT(:,:,:,:),            &
			    QICE(:,:,:,:), tot_cld(:,:,:,:), TEMP(:,:,:,:), temp_tt(:), D_CI(:,:,:,:),       &
                                  D_SNOW(:,:,:,:), D_GRAUP(:,:,:,:), RELHUM(:,:,:,:)

        INTRINSIC 	         :: TRIM, REAL, ABS
        
	bin_temp = 1.

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)
 

!
!==========================================================================================
!		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!

        allocate(nw(ew,ns,bt,ist), NI100UM(ew,ns,bt,ist), NSNOW200um(ew,ns,bt,ist), NGRAUP200um(ew,ns,bt,ist),   &
                 NI(ew,ns,bt,ist), NSNOW(ew,ns,bt,ist), NGRAUP(ew,ns,bt,ist), tau_vis(ew,ns,bt,ist), ni_av(bt),  &
                 rho(bt,ist), RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), w(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist),    &
                 QICE(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist),TEMP(ew,ns,bt,ist), temp_tt(nt), D_CI(ew,ns,bt,ist),  &
                 D_SNOW(ew,ns,bt,ist), D_GRAUP(ew,ns,bt,ist), RELHUM(ew,ns,bt,ist))

        call read_wrf4d_output('NI100UM',7,NI100UM) 
        call read_wrf4d_output('NSNOW200UM',10,NSNOW200UM)
        call read_wrf4d_output('NGRAUP200UM',11,NGRAUP200UM) 
        call read_wrf4d_output('NI',2,NI) 
        call read_wrf4d_output('NSNOW',5,NSNOW)
        call read_wrf4d_output('NGRAUP',6,NGRAUP)
        call read_wrf4d_output('TAU_VIS',7 ,TAU_VIS)
        call read_wrf4d_output('RRB',3 , RRB)
!        call read_wrf4d_output('NW',2 , nw)
        call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
        call read_wrf4d_output('QICE', 4 , QICE)
        call read_wrf4d_output('W', 1 , W)
        call read_wrf4d_output('HEIGHT',6 , HEIGHT)
        call read_wrf4d_output('TEMP',4 , TEMP)
        call read_wrf4d_output('D_CI', 4 , D_CI)
        call read_wrf4d_output('D_SNOW',6 , D_SNOW)
        call read_wrf4d_output('D_GRAUP',7 , D_GRAUP)
        call read_wrf4d_output('RELHUM',6 , RELHUM)


!temp_ord(1:nt)  = (/ 20.,16.,12.,      &
!                     8.,4.,0.,         &
!                    -4.,-8.,-12.,      &
!                    -16.,-20.,-24.,    &
!                    -28.,-32.,-36.,-40., -44., -48. /)

temp_ord(1:nt) = -1.*(/0., 1., 2., 3., 4., 5., 6., 7., 8., 9., 10.,      &
                       11., 12./);!, 13., 14., 15., 16., 17., 18., 19., 20., &
                       !21./)
 do tt = 1,nt
 print*,'temp_ord(tt)',temp_ord(tt)
 enddo
 

          do k = 1, bt
                    do is = 1, ist
                              do i = 1, ew
                                        do j = 1, ns
                                                  rh_obs(k,is) = rh(i,j,k,is)
                                        enddo
                              enddo
                    enddo
          enddo


          open(2,file='N_ICE_100um_T_percm3',form="formatted", access="sequential",status="unknown")
          do tt = 1,nt-1 !min_temp,bin_temp	
                    write(2,*) ni100_av_t(tt)/1.e6,temp_ord(tt),ht_acm(tt)! - bin_temp*0.5
                    write(*,*) ni100_av_t(tt)/1.e6,temp_ord(tt),ht_acm(tt)! - bin_temp*0.5	   
          enddo
          close(2)

          print*,''
          
          !open(2,file='N_ICE_TOT_T_percm3',form="formatted", access="sequential",status="unknown")
          !do tt = 1,nt-1 !min_temp,bin_temp	
          !          write(2,*) ni_tot_av_t(tt)/1.e6,temp_ord(tt),ht_acm(tt)! - bin_temp*0.5
          !          write(*,*) ni_tot_av_t(tt)/1.e6,temp_ord(tt),ht_acm(tt)! - bin_temp*0.5	   
          !enddo
          !close(2)
	!DO tt = 1,61 !min_temp,bin_temp	
	!  write(*,*) ni100_av_t(tt)/1.e6,temp_tt(tt)
	!enddo

stop
 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2009-02-17_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check
        
       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat




 
	end
