
  
        program hist

	use netcdf

        implicit none

        integer                :: i,j, k, is, t, ik, lifetime, ist, bt, ew, ns, tt, nt
	parameter(ew = 40, ns = 40, bt = 40, nt = 18)

        real, allocatable      :: TEMP(:,:,:,:), PB(:,:,:,:), P(:,:,:,:), QVAPOR(:,:,:,:),     &       
                                  RELHUM(:,:,:,:), HEIGHT(:,:,:,:), RRB(:,:,:,:), temp_avg(:), &
                                  ht_avg(:), pres_avg(:), qv_avg(:), rh_avg(:), rho_avg(:)

        INTRINSIC 	         :: TRIM, REAL, ABS


	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)
 

!
!==========================================================================================
!		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!

        allocate(TEMP(ew,ns,bt,ist), PB(ew,ns,bt,ist), P(ew,ns,bt,ist), QVAPOR(ew,ns,bt,ist), &
                 RELHUM(ew,ns,bt,ist), RRB(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist), temp_avg(bt), &
                 ht_avg(bt), pres_avg(bt), qv_avg(bt), rh_avg(bt), rho_avg(bt))

        call read_wrf4d_output('TEMP',4,TEMP) 
        call read_wrf4d_output('PB',2,PB)
        call read_wrf4d_output('P',1,P)  
        call read_wrf4d_output('QVAPOR',6,QVAPOR)
        call read_wrf4d_output('RELHUM',6,RELHUM)
        call read_wrf4d_output('RRB',3,RRB)
        call read_wrf4d_output('HEIGHT',6 , HEIGHT)


          do k = 1, bt
          !print*,'pres, temp',PB(23,23,j,is)+P(i,j,k,is),TEMP(i,k,j,is)
                    temp_avg(k) = 0.; pres_avg(k) = 0.; ht_avg(k)  = 0.; 
                    qv_avg(k)   = 0.; rh_avg(k)   = 0.; rho_avg(k) = 0.; 
                    ik = 0;
                    do is = 1, 1
                              do i = 1, ew
                                        do j = 1, ns
                                                  temp_avg(k) = temp_avg(k) + TEMP(i,j,k,is)
                                                  pres_avg(k) = pres_avg(k) + (PB(i,j,k,is)+P(i,j,k,is))
                                                  qv_avg(k)   = qv_avg(k) + QVAPOR(i,j,k,is)
                                                  rh_avg(k)   = rh_avg(k) + RELHUM(i,j,k,is)
                                                  rho_avg(k)  = rho_avg(k)+ RRB(i,j,k,is)
                                                  ht_avg(k)   = ht_avg(k) + HEIGHT(i,j,k,is)
                                                  ik = ik + 1
                                        enddo
                              enddo
                    enddo
                    if(ik > 0)then
                              temp_avg(k) = temp_avg(k)/real(ik)
                              pres_avg(k) = pres_avg(k)/real(ik)
                              qv_avg(k)   = qv_avg(k)/real(ik)
                              rh_avg(k)   = rh_avg(k)/real(ik)
                              rho_avg(k)  = rho_avg(k)/real(ik)
                              ht_avg(k)   = ht_avg(k)/real(ik)
                    else
                              temp_avg(k) = -999.
                              pres_avg(k) = -999.
                              qv_avg(k)   = -999.
                              rh_avg(k)   = -999.
                              rho_avg(k)  = -999. 
                              ht_avg(k)   = -999.
                    endif
          enddo


          open(2,file='INITIAL_SOUNDING_APPRAISE_ACM',form="formatted", access="sequential",status="unknown")
          do k = 1, bt !min_temp,bin_temp	
                    write(2,*) pres_avg(k),ht_avg(k),temp_avg(k),qv_avg(k),rh_avg(k)
                    write(*,*) pres_avg(k),ht_avg(k),temp_avg(k),qv_avg(k),rh_avg(k)  
          enddo
          close(2)
          
           open(2,file='DENSITY_APPRAISE_ACM',form="formatted", access="sequential",status="unknown")
          do k = 1, bt !min_temp,bin_temp	
                    write(2,*) pres_avg(k),ht_avg(k),rho_avg(k)!,temp_avg(k),qv_avg(k),rh_avg(k)
                    !write(*,*) pres_avg(k),ht_avg(k),rho_avg(k)!,temp_avg(k),qv_avg(k),rh_avg(k)  
          enddo
          close(2)

stop
 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2009-02-17_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check
        
       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat




 
	end
