
  
        program hist
	use netcdf
	implicit none
        integer                         :: i,j, t, lifetime,   ist, bt, ew, ns,ist_part
	parameter(ew = 40, ns = 40, bt = 40)
 	integer, allocatable          :: iav(:,:)
	integer                       :: i_ens, nrec, k, is, ik,aa,bb,n,p
	real, allocatable             :: ni(:,:,:,:), RAINNC(:,:,:), tau_vis(:,:,:,:), RAINNC_av(:), rho(:,:),temporary(:,:,:),p_mmhr(:)
	real                          :: RAINNC0, run_day, time, time0, prec(1,1,1,210), ps(1,1,1,210),dt, wrf_hist_interval, sim_start_hour
   	CHARACTER *2   char_smooth
    	CHARACTER *3   char_num, char_buf3 
    	CHARACTER *6   char_buf
    	CHARACTER *7   char_buf7
    	CHARACTER *5   char_buf5
    	CHARACTER *7   char_buf2
    	CHARACTER *19  char_in19
    	CHARACTER *60  char_in
    	character *50  var_name
    	CHARACTER *100 char_in_big

	REAL,dimension(11)            :: sum_1
	logical   	          :: split
	INTRINSIC 	          :: TRIM, REAL, ABS

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)

!
!==========================================================================================
!			precipitation_rate_mc3e
!==========================================================================================
!

	allocate(RAINNC(ew,ns,ist), ni(ew,ns,bt,ist), tau_vis(ew,ns,bt,ist), RAINNC_av(ist), rho(40, ist),p_mmhr(ist))	

		call read_wrf3d_output('RAINNC', 6 , RAINNC)

	DO is=1,ist
	  RAINNC_av(is) = 0.; ik = 0;
	    do i=1,ew
	      do j=1,ns
	          RAINNC_av(is) = RAINNC_av(is) + RAINNC(i,j,is)
	          ik = ik + 1
	      enddo
	    enddo
	      if(ik > 0) then
	        RAINNC_av(is) = RAINNC_av(is)/real(ik) 
	      else
	        RAINNC_av(is) = 0. 
	      endif
	ENDDO
          
          wrf_hist_interval = 10.
          sim_start_hour    = 47.
          p_mmhr = 0.
          dt = wrf_hist_interval/60.                ! minutes to hours
	open(2,file='P_mmhr_appraise')
	    do is = 1, ist
	          if (is > 1 .and. is < ist) then
	                    p_mmhr(is) = (rainnc_av(is+1)-rainnc_av(is-1))/(2.*dt)
	          else
	                    if(is == 1) p_mmhr(is) = (rainnc_av(is+1)-rainnc_av(is))/dt
	                    if(is == ist) p_mmhr(is) = (rainnc_av(is)-rainnc_av(is-1))/dt	                    
	          endif
	      !print*,'p_mmhr',p_mmhr(is),is,real(is)*wrf_hist_interval/(24.*60.)+sim_start_hour,is
	      write(2,*)p_mmhr(is),real(is)*wrf_hist_interval/(24.*60.) + sim_start_hour
	      write(*,*)p_mmhr(is),is,real(is)*wrf_hist_interval/(24.*60.) + sim_start_hour
	    enddo 
	close(2)
	
	open(2,file='P_accumulated_appraise')
	     do is = 1, ist
	          write(2,*)rainnc_av(is),real(is)*wrf_hist_interval/(24.*60.) + sim_start_hour
	    enddo 
	close(2)

	stop 
	

        CONTAINS
        SUBROUTINE read_wrf3d_output(var, nvar, WRFVAR)
                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2009-02-17_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf3d_output



       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check


	end
