 program hist 

	use netcdf

        implicit none

        integer                :: i,j, t, lifetime,   ist, bt, ew, ns,tt,n_temp_bin, ITC, ITC_STOP, is_start, is_end
        real                   :: eps, diff_es, w_crit, L_ice, L_water, Rv, Rd, c_ice, g_gravity, k_coeff_heat, D_coeff_diff, &
                                  rho_ice, pie, Cp, mean_rad_ice, rho_snow, rho_graup, c_graup,                               &
                                  fact_A_i_1, fact_A_i_2, fact_A_i_3, fact_A_i_4, fact_A_i_5, fact_A_i_6, fact_B_i_1,         &
                                  fact_B_i_2, fact_a2_i_1, fact_a2_i_2, fact_a2_i_3, fact_a2_i_4, fact_a0_i_1, fact_a0_i_2,   &
                                  fact_a0_i_3, fact_a0_i_4,                                                                   &
                                  fact_A_s_1, fact_A_s_2, fact_A_s_3, fact_A_s_4, fact_A_s_5, fact_A_s_6, fact_B_s_1,         &
                                  fact_B_s_2, fact_a2_s_1, fact_a2_s_2, fact_a2_s_3, fact_a2_s_4, fact_a0_s_1, fact_a0_s_2,   &
                                  fact_a0_s_3, fact_a0_s_4,                                                                   &
                                  fact_A_g_1, fact_A_g_2, fact_A_g_3, fact_A_g_4, fact_A_g_5, fact_A_g_6, fact_B_g_1,         &
                                  fact_B_g_2, fact_a2_g_1, fact_a2_g_2, fact_a2_g_3, fact_a2_g_4, fact_a0_g_1, fact_a0_g_2,   &
                                  fact_a0_g_3, fact_a0_g_4, f_a_1, f_a_2, f_a_3, fact_n_crit_1, fact_n_crit_2, fact_n_crit_3, &
                                  fact_n_crit_4, fact_n_crit_5, fact_n_crit_6
                                  
          parameter( bt=40, ew=40, ns=40, eps = 0.622, L_ice = 2.83e6, L_water = 2.50e6, Rv = 461., Rd = 287., c_ice = 0.5,   &
                     c_graup = 1., g_gravity = 9.8, k_coeff_heat = 2.40E-2, D_coeff_diff = 2.21e-5, Cp = 1005.,               &
                     rho_ice = 800., pie = 3.14, mean_rad_ice = 5.e-5, rho_snow = 100., rho_graup = 400.)
                     
                     !====================================================================================!
                     ! rho_ice - bulk density of cloudice (kg/m3)
                     ! c_ice   - ice particle shape factor characterising capacitance ( 0 < c <= 1)
                     ! Rd      - gas constant of dry air (Jk-1kg-1)
                     ! Rv      - gas constant of water vapor (Jk-1kg-1)
                     ! r_moist - gas constant of moist air (Jk-1kg-1)
                     ! eps     - Rd/Rv
                     ! mean_rad_ice - Half of a maximum linear dimension of an ice particle (m)
                     ! L_water - latent heat of water evaporation (Jkg-1)
                     ! L_ice   - latent heat of water evaporation (Jkg-1) 
                     ! k_coeff_heat - coefficient of air heat conductivity (Jm-1s-1K-1)
                     ! D_coeff_diff - coefficient of water vapor diffusion in the air (m2s-1)
                     ! Cp      - specific heat capacity at constant pressure (Jk-1kg-1)
                     !====================================================================================!
                     	
        real, dimension(bt)    :: model_z, ni_ave_int, obs_z
        integer, allocatable   :: iav(:,:), critical_point_tot_flag(:,:,:,:)
        integer 	           :: i_ens, nrec, k, is, ik,grid,cloud,ntest,bin_temp,min_temp
        real 		 :: ni_grid_tot, ni_grid_av(80), ni_grid,temp_ord(22),ni_av_t(22), q_snow_av_t(22), q_ice_av_t(22),   &
                                  q_graup_av_t(22), ni200_av_t(22), temp_tt(22), q_cld_av_t(22),                                    &
                                  n_ice_av_t(22), n_graup_av_t(22), n_snow_av_t(22), n_act_inp_av_t(22), ie_ratio_av_t(22),         &
                                  ni_hom_av_t(22), n_tot_ice_crit_av_t(22), n_ice_crit_av_t(22), n_snow_crit_av_t(22),              &
                                  n_graup_crit_av_t(22),fact_snow_av_t(22), fact_graup_av_t(22), Temp_c, fa_1_esw
       
          double precision :: GGESW, ESW_new_Pa, T_K, T_degC, ESI_new_Pa
      	INTRINSIC:: LOG, DEXP                    
        real, allocatable      :: RRB(:,:,:,:), W(:,:,:,:), HEIGHT(:,:,:,:), TEMP(:,:,:,:), NI200UM(:,:,:,:), &
                                  NSNOW200UM(:,:,:,:), NGRAUP200UM(:,:,:,:), NI(:,:,:,:), NSNOW(:,:,:,:), NGRAUP(:,:,:,:),         &
                                  QSNOW(:,:,:,:), QGRAUP(:,:,:,:), QCLOUD(:,:,:,:), QICE(:,:,:,:), tot_cld(:,:,:,:),               &
                                  N_BC_ACT(:,:,:,:), N_BIO_ACT(:,:,:,:), N_DUST_ACT(:,:,:,:), N_ICE_hom(:,:,:,:),                  &
                                  PB(:,:,:,:), QVAPOR(:,:,:,:), eta_corelev(:,:,:,:),                          &
                                  D_CI(:,:,:,:), n_ice(:,:,:,:), n_tot_ice_crit(:,:,:,:), RELHUM(:,:,:,:), temp_crit(:,:,:,:),     &
                                  e_vapor(:,:,:,:), R_G_A(:,:,:,:), fact_A_ice(:,:,:,:), TEMP_K(:,:,:,:),                          &
                                  xie_factor(:,:,:,:), fact_B_ice(:,:,:,:), fact_a2(:,:,:,:), factor_b_ice(:,:,:,:),               &
                                  fact_a0(:,:,:,:), r_moist(:,:,:,:), D_SNOW(:,:,:,:), D_GRAUP(:,:,:,:),                           & 
                                  factor_b_snow(:,:,:,:), factor_b_graup(:,:,:,:), factor_A_snow(:,:,:,:),                         &
                                  factor_A_graup(:,:,:,:), fact_B_snow(:,:,:,:), fact_B_graup(:,:,:,:),                            &
                                  fact_A_snow(:,:,:,:), fact_A_graup(:,:,:,:), fact_B_total(:,:,:,:), factor_b_total(:,:,:,:),     &
                                  diam_ice_snow_graup(:,:,:,:), critical_point_snow_flag(:,:,:,:),                                 &
                                  critical_point_graup_flag(:,:,:,:), n_ice_crit(:,:,:,:), n_snow_crit(:,:,:,:),                   &
                                  n_graup_crit(:,:,:,:), critical_point_ice_flag(:,:,:,:), size_cld_ice(:,:,:,:),                  &
                                  size_snow(:,:,:,:), size_graup(:,:,:,:), common_factor(:,:,:,:), fact_snow(:,:,:,:),             &
                                  fact_graup(:,:,:,:), tot_qcld(:,:,:,:), tot_qice(:,:,:,:)
            double precision, allocatable ::   e_sat_w (:,:,:,:), e_sat_ice(:,:,:,:)

	n_temp_bin = 30
	bin_temp = 1.
	min_temp = 30. !-20 

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10) 
 

		
        allocate( RRB(ew,ns,bt,ist), W(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist), TEMP(ew,ns,bt,ist), NI200UM(ew,ns,bt,ist),                    &
                  NSNOW200UM(ew,ns,bt,ist), NGRAUP200UM(ew,ns,bt,ist), NI(ew,ns,bt,ist), NSNOW(ew,ns,bt,ist), NGRAUP(ew,ns,bt,ist),       &
                  QSNOW(ew,ns,bt,ist), QICE(ew,ns,bt,ist), QGRAUP(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist),             &
                  N_BC_ACT(ew,ns,bt,ist), N_BIO_ACT(ew,ns,bt,ist), N_DUST_ACT(ew,ns,bt,ist), N_ICE_hom(ew,ns,bt,ist),                     &
                  PB(ew,ns,bt,ist), QVAPOR(ew,ns,bt,ist), e_sat_w(ew,ns,bt,ist), e_sat_ice(ew,ns,bt,ist), eta_corelev(ew,ns,bt,ist),      &
                  D_CI(ew,ns,bt,ist), n_ice(ew,ns,bt,ist), n_tot_ice_crit(ew,ns,bt,ist), RELHUM(ew,ns,bt,ist), temp_crit(ew,ns,bt,ist),   &
                  e_vapor(ew,ns,bt,ist), R_G_A(ew,ns,bt,ist), fact_A_ice(ew,ns,bt,ist), TEMP_K(ew,ns,bt,ist),                             &
                  xie_factor(ew,ns,bt,ist), fact_B_ice(ew,ns,bt,ist), fact_a2(ew,ns,bt,ist), factor_b_ice(ew,ns,bt,ist),                  &
                  fact_a0(ew,ns,bt,ist), r_moist(ew,ns,bt,ist), critical_point_tot_flag(ew,ns,bt,ist), D_SNOW(ew,ns,bt,ist),              &
                  D_GRAUP(ew,ns,bt,ist), factor_b_snow(ew,ns,bt,ist), factor_b_graup(ew,ns,bt,ist), factor_A_snow(ew,ns,bt,ist),          &   
                  factor_A_graup(ew,ns,bt,ist), fact_B_snow(ew,ns,bt,ist), fact_B_graup(ew,ns,bt,ist), fact_A_snow(ew,ns,bt,ist),         &
                  fact_A_graup(ew,ns,bt,ist), fact_B_total(ew,ns,bt,ist), factor_b_total(ew,ns,bt,ist),                                   &
                  diam_ice_snow_graup(ew,ns,bt,ist), critical_point_ice_flag(ew,ns,bt,ist), critical_point_snow_flag(ew,ns,bt,ist),       & 
                  critical_point_graup_flag(ew,ns,bt,ist), n_ice_crit(ew,ns,bt,ist), n_snow_crit(ew,ns,bt,ist),                           &
                  n_graup_crit(ew,ns,bt,ist), size_cld_ice(ew,ns,bt,ist), size_snow(ew,ns,bt,ist), size_graup(ew,ns,bt,ist),              &
                  common_factor(ew,ns,bt,ist), fact_snow(ew,ns,bt,ist), fact_graup(ew,ns,bt,ist), tot_qcld(ew,ns,bt,ist), tot_qice(ew,ns,bt,ist) ) 
                         
        call read_wrf4d_output('RRB',3 , RRB)
        call read_wrf4d_output('W', 1 , W)
        call read_wrf4d_output('PB',2 , PB)
        call read_wrf4d_output('TEMP',4 , TEMP)
        call read_wrf4d_output('NI200UM',7,NI200UM)
        call read_wrf4d_output('NSNOW200UM',10,NSNOW200UM)
        call read_wrf4d_output('NGRAUP200UM',11,NGRAUP200UM)
        call read_wrf4d_output('NI',2,NI)
        call read_wrf4d_output('NSNOW',5,NSNOW)
        call read_wrf4d_output('NGRAUP',6,NGRAUP)
        call read_wrf4d_output('QICE',4 , QICE)
        call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
        call read_wrf4d_output('QGRAUP',6 ,QGRAUP)
        call read_wrf4d_output('QVAPOR',6 ,QVAPOR)
        call read_wrf4d_output('D_CI',4 ,D_CI)                              ! Mean cloud-ice diameter       
        call read_wrf4d_output('D_SNOW',6 ,D_SNOW)                          ! Mean cloud-ice diameter
        call read_wrf4d_output('D_GRAUP',7 ,D_GRAUP)                        ! Mean cloud-ice diameter
        call read_wrf4d_output('RELHUM', 6 , RELHUM) 
        call read_wrf4d_output('R_G_A', 5 , R_G_A)
	
temp_ord  = (/ 20.,16.,12.,      &
               8.,4.,0.,         &
              -4.,-8.,-12.,      &
              -16.,-20.,-24.,    &
              -28.,-32.,-36.,-40.,-44.,-48.,-52.,-56.,-60.,-64. /)
              
           do is = 1, ist
                    do i = 1, ew
                              do j = 1, ns
                                        do k = 1, bt
                                                  tot_cld(i,j,k,is)  = rrb(i,j,k,is)*(QCLOUD(i,j,k,is)+QICE(i,j,k,is))
                                                  tot_qcld(i,j,k,is) = rrb(i,j,k,is)*(QCLOUD(i,j,k,is))
                                                  tot_qice(i,j,k,is) = rrb(i,j,k,is)*(QICE(i,j,k,is))
                                        enddo
                              enddo
                    enddo
          enddo
 
 
 !========================================================= Ref: Korolev & Mazin, 2003 Eqn. 12 ====================================================
 ! In mixed phase clouds, the droplets would stay in euqilibrium (i.e. they will neither grow nor evaporate) if Sw=0. supersaturation w.r.t. water 
 !                                                Sqw = (ao*uz-bi*Ni*ri)/(bw*Nw*rw+bi*Ni*ri)                                                       
 !                                      For exact water saturation with respect to liquid (i.e. Sqw = 0.)                                          
 !                                          then, Eqn 12. for Ni can be written as, Ni = ao*uz/bi*ri                                               
 !=================================================================================================================================================
 
 !==================================================================! 
 ! ao = [g/(Rd*T)]*[((L*Rd)/(cp*Rv*T))-1]                           
 ! Sw = (E-Ew)/Ew;                                                  
 ! E-water vapor pressure,                                          
 ! Ew-saturated vapor pressure;                                      
 ! T - Temperature (kelvin)                                         
 ! q = epis*(E/P), P-Pressure;                                      
 ! Uz* = bi*Ni*ri/ao;                                               
 ! bi  = a2*Bi;                                                     
 ! a2  = (1/qv)+(Lw*Li/(Cp*Rv*T**2))                                
 ! Bi  = 4*pi*rho_i*c*(RH-1)*Ai/rho_a                               
 ! Ai  = [(rho_i*Li**2/k*Rv*T**2)+(rho_i*Rv*T/(Ei*D))]-1            
 ! k     - coefficient of heat conductivity (J/msK)                 
 ! Ei    - Saturation vapor pressure w.r.t. ice (Pa)                
 ! Ew    - Saturation vapor pressure w.r.t. water (Pa)               
 ! D     - Coefficient of water vapor diffusion                     
 ! rho_i - density of ice (kgm-3)                                   
 ! rho_w - density of water (kgm-3)                                 
 ! c_ice - Ice particle shape factor characterising capacitance     
 ! RH    - Ew/Ei                                                    
 ! Lw = latent heat for liquid water evaporation (2.5e6 Jkg-1)      
 ! Li = latent heat for ice sublimation (2.83e6 Jkg-1)              
 ! Rv = 461 J/kkg                                                   
 ! Rd = 287 J/kkg                                                   
 ! k  = coefficient of air heat conductivity (0.025 J/msK)          
 ! D  = coefficient of water vapor diffusion in air (2.42e-5 m2s-1) 
 ! 0 < c_ice <= 1 ( 1 for sphere)                                   
 ! uz - updraft velocity                                            
 ! Ni - Ice particle concentration (m-3)                            
 ! ri - Half of a maximum linear dimension of an ice particle(m)     
 ! qv - Water vapor mixing ratio (kg/kg)                             
 !==================================================================

 !================================================================!
 !============= Calculating fact_snow and fact_graupel ===========!
 !==== Such that N_s = fact_snow*N_i and N_g = fact_graup*N_i ====!
 !================================================================!
is_start = 1200; is_end = 1700;
           do is = 1, ist
                     do i = 1, ew
                              do j = 1, ns
                                        do k = 1, bt 
                                                  if (NSNOW(i,j,k,is) >= 0. .and. NI(i,j,k,is) > 0.) then
                                                            fact_snow(i,j,k,is) = NSNOW(i,j,k,is)/NI(i,j,k,is)
                                                  else
                                                            fact_snow(i,j,k,is) = -999.
                                                  endif
                                                  
                                                  if (NGRAUP(i,j,k,is) >= 0. .and. NI(i,j,k,is) > 0.) then
                                                            fact_graup(i,j,k,is) = NGRAUP(i,j,k,is)/NI(i,j,k,is)
                                                  else
                                                            fact_graup(i,j,k,is) = -999.
                                                  endif
                                        enddo
                              enddo
                     enddo
           enddo 
                       
 !======================================================================================================!
 !============ Calculating vapor pressure and saturation vapor pressure w.r.t. water and ice ===========!
 !======================================================================================================!
 !-----------Initialization for variables ESIT,ESWT,DESWT, DESIT & temp_K ---------------
   	 

	 
temp_c = 0. ; T_K = 0.;
 do is = is_start, is_end!1, ist
           do i = 1, ew
                    do j = 1, ns
                              do k = 1, bt
                                                 TEMP_K(i,j,k,is) = TEMP(i,j,k,is) + 273.15                           ! TEMP in Kelvin
                                                              T_K = TEMP_K(i,j,k,is)
                                                              
                                           e_sat_w(i,j,k,is) = ESW_new_Pa(T_K)
                                         e_sat_ice(i,j,k,is) = ESI_new_Pa(T_k)
                                           !e_sat_w(i,j,k,is) = 100.*(6.112*exp(17.67*TEMP(i,j,k,is)/(TEMP(i,j,k,is)+243.5)))    ! Rogers and Yau eq. 2.17        ! mb to Pa
                                         !e_sat_ice(i,j,k,is) = e_sat_w(i,j,k,is)*(((TEMP_K(i,j,k,is))/273.)**2.66)              ! Rogers and Yau eq. 2.16        ! Pa
                                        xie_factor(i,j,k,is) = e_sat_w(i,j,k,is)/e_sat_ice(i,j,k,is)
                                        !if (TEMP(i,j,k,is) < -4. .and. TEMP(i,j,k,is) > -6.)print*,e_sat_w(i,j,k,is),e_sat_ice(i,j,k,is),TEMP(i,j,k,is)
                                        !if (TEMP(i,j,k,is) < -4. .and. TEMP(i,j,k,is) > -6.)stop 98
                                                    if(QVAPOR(i,j,k,is) > 0.)then
                                                            e_vapor(i,j,k,is) = QVAPOR(i,j,k,is)*PB(i,j,k,is)/eps
                                                            r_moist(i,j,k,is) = Rd*(1+(0.6*QVAPOR(i,j,k,is)))                                                     ! Pa  
                                                    else
                                                            e_vapor(i,j,k,is) = -999.
                                                            r_moist(i,j,k,is) = -999. 
                                                    endif
                                                    if (r_moist(i,j,k,is) /= -999. .and. r_moist(i,j,k,is) < 0.) print*,QVAPOR(i,j,k,is),r_moist(i,j,k,is)
                                                    if (r_moist(i,j,k,is) /= -999. .and. r_moist(i,j,k,is) < 0.) stop 888
                              enddo
                    enddo
           enddo
 enddo
 print*,'HERE :: 1'

 !========================================================================================!
 !============= Calculating a0  = [g/(Rd*T)]*[((L*Rd)/(cp*Rv*T))-1]  =====================!
 !========================================================================================!
 fact_a0_i_1 = 0.; fact_a0_i_2 = 0.; fact_a0_i_3 = 0.;  fact_a0_i_4 = 0.; fact_a0 = 0.; 
 do is = is_start, is_end!1, ist
           do i = 1, ew
                    do j = 1, ns
                              do k = 1, bt
                                        if (r_moist(i,j,k,is) /= -999.) then
                                                  fact_a0_i_1 = g_gravity/(r_moist(i,j,k,is)*TEMP_k(i,j,k,is))
                                                  fact_a0_i_2 = L_water*r_moist(i,j,k,is)
                                        else
                                                  fact_a0_i_1 = -999. 
                                                  fact_a0_i_2 = -999.
                                        endif
                                        
                                        fact_a0_i_3 = Cp*Rv*TEMP_k(i,j,k,is)
                                        
                                        if (fact_a0_i_1 /= -999. .or. fact_a0_i_2 /= -999.) fact_a0_i_4 = (fact_a0_i_2/fact_a0_i_3)-1.
                                        if (fact_a0_i_1 == -999. .or. fact_a0_i_2 == -999.) fact_a0_i_4 = -999.  
                                        if (fact_a0_i_4 /= -999.) then
                                                  fact_a0(i,j,k,is) = fact_a0_i_1*fact_a0_i_4
                                        else
                                                  fact_a0(i,j,k,is) = -999.           
                                        endif
                                        if(fact_a0(i,j,k,is) /= -999. .and. fact_a0(i,j,k,is) < 0.) stop 130400
                              enddo
                    enddo
           enddo
 enddo
 print*,'HERE :: 2' 
  
 !========================================================================================!
 !=========== Calculating a2  = [(1/qvapor)+((Lw**2)/(Cp*Rv*T**2))]  =====================!
 !========================================================================================! 
 fact_a2_i_1 = 0.; fact_a2_i_2 = 0.; fact_a2_i_3 = 0.;  fact_a2_i_4 = 0.; fact_a2 = 0.;
 do is = is_start, is_end!1, ist
           do i = 1, ew
                    do j = 1, ns
                              do k = 1, bt
                                        if (QVAPOR(i,j,k,is) > 0.) then 
                                                  fact_a2_i_1 = 1./QVAPOR(i,j,k,is)
                                        else
                                                  fact_a2_i_1 = -999. 
                                        endif 
                                        fact_a2_i_2 = L_water*L_ice
                                        fact_a2_i_3 = Cp*Rv*(TEMP_K(i,j,k,is)**2.)
                                        fact_a2_i_4 = fact_a2_i_2/fact_a2_i_3
                                        if (fact_a2_i_1 /= -999.) then
                                                  fact_a2(i,j,k,is) = fact_a2_i_1+fact_a2_i_4
                                        else
                                                  fact_a2(i,j,k,is) = -999.
                                        endif
                                        if (fact_a2(i,j,k,is) /= -999. .and. fact_a2(i,j,k,is) < 0.) stop 130401
                              enddo
                    enddo
           enddo
 enddo
 print*,'HERE :: 3'
 
 !========================================================================================!
 !=========== Calculating Ai  = [(rho_i*Li**2/k*Rv*T**2)+(rho_i*Rv*T/(Ei*D))]-1  =========!
 !========================================================================================!
 fact_A_i_1 = 0.; fact_A_i_2 = 0.; fact_A_i_3 = 0.; fact_A_i_4 = 0.; fact_A_i_5 = 0.;  fact_A_i_6 = 0.; fact_A_ice = 0.;
 fact_A_s_1 = 0.; fact_A_s_2 = 0.; fact_A_s_3 = 0.; fact_A_s_4 = 0.; fact_A_s_5 = 0.;  fact_A_s_6 = 0.; fact_A_snow = 0.;
 fact_A_g_1 = 0.; fact_A_g_2 = 0.; fact_A_g_3 = 0.; fact_A_g_4 = 0.; fact_A_g_5 = 0.;  fact_A_g_6 = 0.; fact_A_graup = 0.;
 do is = is_start, is_end!1, ist
           do i = 1, ew
                    do j = 1, ns
                              do k = 1, bt
                                        !========== for cloud-ice
                                        fact_A_i_1 = rho_ice*(L_ice**2.)
                                        fact_A_i_2 = k_coeff_heat*Rv*(TEMP_K(i,j,k,is)**2.)
                                        fact_A_i_3 = rho_ice*Rv*TEMP_K(i,j,k,is)
                                        fact_A_i_4 = e_sat_ice(i,j,k,is)*D_coeff_diff
                                        fact_A_i_5 = (fact_A_i_1/fact_A_i_2)
                                        fact_A_i_6 = (fact_A_i_3/fact_A_i_4)
                                        fact_A_ice(i,j,k,is) = 1./(fact_A_i_5+fact_A_i_6)
                                        if (fact_A_ice(i,j,k,is) < 0.) stop 130402 
                                        !========== for snow
                                        fact_A_s_1 = rho_snow*(L_ice**2.)
                                        fact_A_s_2 = k_coeff_heat*Rv*(TEMP_K(i,j,k,is)**2.)
                                        fact_A_s_3 = rho_snow*Rv*TEMP_K(i,j,k,is)
                                        fact_A_s_4 = e_sat_ice(i,j,k,is)*D_coeff_diff
                                        fact_A_s_5 = (fact_A_s_1/fact_A_s_2)
                                        fact_A_i_6 = (fact_A_s_3/fact_A_s_4)
                                        fact_A_snow(i,j,k,is) = 1./(fact_A_s_5+fact_A_s_6)
                                        if (fact_A_snow(i,j,k,is) < 0.) stop 130403 
                                        !========== for graupel
                                        fact_A_g_1 = rho_graup*(L_ice**2.)
                                        fact_A_g_2 = k_coeff_heat*Rv*(TEMP_K(i,j,k,is)**2.)
                                        fact_A_g_3 = rho_graup*Rv*TEMP_K(i,j,k,is)
                                        fact_A_g_4 = e_sat_ice(i,j,k,is)*D_coeff_diff
                                        fact_A_g_5 = (fact_A_g_1/fact_A_g_2)
                                        fact_A_g_6 = (fact_A_g_3/fact_A_g_4)
                                        fact_A_graup(i,j,k,is) = 1./(fact_A_i_5+fact_A_i_6)
                                        if (fact_A_graup(i,j,k,is) < 0.) stop 130404        
                              enddo
                    enddo
           enddo
 enddo
 print*,'HERE :: 4'
 
 !========================================================================================!
 !=========== Calculating Bi  = [(4*pi*rho_ice*(RH-1)*c*Ai/rho_a)]  ======================!
 !========================================================================================!
 fact_B_i_1 = 0.; fact_B_i_2 = 0.; fact_B_ice = 0.;
 fact_B_s_1 = 0.; fact_B_s_2 = 0.; fact_B_snow = 0.;
 fact_B_g_1 = 0.; fact_B_g_2 = 0.; fact_B_graup = 0.; fact_B_total = 0.;
 do is = is_start, is_end!1, ist
           do i = 1, ew
                    do j = 1, ns
                              do k = 1, bt
                                        !========== for cloud-ice
                                        fact_B_i_1 = 4.*pie*rho_ice/rrb(i,j,k,is)
                                        fact_B_i_2 = c_ice*fact_A_ice(i,j,k,is)*(xie_factor(i,j,k,is)-1)
                                        if (fact_B_i_2 > 0.)  fact_B_ice(i,j,k,is) = fact_B_i_1*fact_B_i_2
                                        if (fact_B_i_2 <= 0.) fact_B_ice(i,j,k,is) = -999.
                                        if (fact_B_ice(i,j,k,is) /= -999. .and. fact_B_ice(i,j,k,is) < 0.) stop 130405
                                        !========== for snow
                                        fact_B_s_1 = 4.*pie*rho_snow/rrb(i,j,k,is)
                                        fact_B_s_2 = c_ice*fact_A_snow(i,j,k,is)*(xie_factor(i,j,k,is)-1)
                                        if (fact_B_s_2 > 0.)  fact_B_snow(i,j,k,is) = fact_B_s_1*fact_B_s_2
                                        if (fact_B_s_2 <= 0.) fact_B_snow(i,j,k,is) = -999.
                                        if (fact_B_snow(i,j,k,is) /= -999. .and. fact_B_snow(i,j,k,is) < 0.) stop 130406
                                        !========== for graupel
                                        fact_B_g_1 = 4.*pie*rho_graup/rrb(i,j,k,is)
                                        fact_B_g_2 = c_ice*fact_A_graup(i,j,k,is)*(xie_factor(i,j,k,is)-1)
                                        if (fact_B_g_2 > 0.)  fact_B_graup(i,j,k,is) = fact_B_g_1*fact_B_g_2
                                        if (fact_B_g_2 <= 0.) fact_B_graup(i,j,k,is) = -999.
                                        if (fact_B_graup(i,j,k,is) /= -999. .and. fact_B_graup(i,j,k,is) < 0.) stop 130407
                              enddo
                    enddo
           enddo
 enddo 
 print*,'HERE :: 5' 
 
 !========================================================================================!
 !=========== Calculating Bi  = [(4*pi*rho_ice*(RH-1)*c*Ai/rho_a)]  ======================!
 !========================================================================================! 
 factor_b_ice = 0.
 do is = is_start, is_end!1, ist
           do i = 1, ew
                    do j = 1, ns
                              do k = 1, bt 
                                        !========== for cloud-ice
                                        if(fact_B_ice(i,j,k,is) /= -999. .and. fact_a2(i,j,k,is) /= -999.) then
                                                  factor_b_ice(i,j,k,is) = fact_a2(i,j,k,is)*fact_B_ice(i,j,k,is)
                                        else
                                                  factor_b_ice(i,j,k,is) = -999.
                                        endif
                                        if (factor_b_ice(i,j,k,is) /= -999. .and. factor_b_ice(i,j,k,is) <= 0.) print*,factor_b_ice(i,j,k,is)
                                        if (factor_b_ice(i,j,k,is) /= -999. .and. factor_b_ice(i,j,k,is) <= 0.) print*,fact_a2(i,j,k,is),fact_B_ice(i,j,k,is) 
                                        if (factor_b_ice(i,j,k,is) /= -999. .and. factor_b_ice(i,j,k,is) <= 0.) stop 130408  
                                        !========== for snow
                                        if(fact_B_snow(i,j,k,is) /= -999. .and. fact_a2(i,j,k,is) /= -999.) then
                                                  factor_b_snow(i,j,k,is) = fact_a2(i,j,k,is)*fact_B_snow(i,j,k,is)
                                        else
                                                  factor_b_snow(i,j,k,is) = -999.
                                        endif
                                        if (factor_b_snow(i,j,k,is) /= -999. .and. factor_b_snow(i,j,k,is) <= 0.) print*,factor_b_snow(i,j,k,is)
                                        if (factor_b_snow(i,j,k,is) /= -999. .and. factor_b_snow(i,j,k,is) <= 0.) print*,fact_a2(i,j,k,is),fact_B_snow(i,j,k,is) 
                                        if (factor_b_snow(i,j,k,is) /= -999. .and. factor_b_snow(i,j,k,is) <= 0.) stop 130409 
                                        !========== for graupel
                                        if(fact_B_graup(i,j,k,is) /= -999. .and. fact_a2(i,j,k,is) /= -999.) then
                                                  factor_b_graup(i,j,k,is) = fact_a2(i,j,k,is)*fact_B_graup(i,j,k,is)
                                        else
                                                  factor_b_graup(i,j,k,is) = -999.
                                        endif
                                        if (factor_b_graup(i,j,k,is) /= -999. .and. factor_b_graup(i,j,k,is) <= 0.) print*,factor_b_graup(i,j,k,is)
                                        if (factor_b_graup(i,j,k,is) /= -999. .and. factor_b_graup(i,j,k,is) <= 0.) print*,fact_a2(i,j,k,is),fact_B_graup(i,j,k,is) 
                                        if (factor_b_graup(i,j,k,is) /= -999. .and. factor_b_graup(i,j,k,is) <= 0.) stop 130410 
                              enddo
                    enddo
           enddo
 enddo 
 print*,'HERE :: 6'  
 
 !===============================================================================!
 !============ Half of a maximum linear dimension of an ice particle(m) =========!
 !===============================================================================! 
 size_cld_ice = 0.; size_snow = 0.; size_graup = 0.; 
           do is = is_start, is_end!1, ist
                    do i = 1, ew
                              do j = 1, ns
                                        do k = 1, bt 
                                                  size_cld_ice(i,j,k,is) = D_CI(i,j,k,is)*0.5
                                                     size_snow(i,j,k,is) = D_SNOW(i,j,k,is)*0.5
                                                    size_graup(i,j,k,is) = D_GRAUP(i,j,k,is)*0.5
                                        enddo
                              enddo
                     enddo
           enddo     
  print*,'HERE :: 7'                                    
 !=============================================================!
 !============ Calculating Ice concentration ==================!
 !=============================================================!
           critical_point_tot_flag  = 0 ; critical_point_ice_flag  = 0 ; critical_point_snow_flag  = 0 ; critical_point_graup_flag  = 0 ;
           n_ice_crit = 0. ; n_snow_crit = 0.; n_graup_crit = 0.; f_a_1 = 0.; f_a_2 = 0.; f_a_3 = 0.; fact_n_crit_1  = 0. ;
           fact_n_crit_2 = 0. ; fact_n_crit_3 = 0. ; fact_n_crit_4 = 0. ; fact_n_crit_5 = 0. ; fact_n_crit_6 = 0. ;
                            
           do is = is_start, is_end!1, ist
                    do i = 1, ew
                              do j = 1, ns
                                        do k = 1, bt
                                                  !================= CLOUD ICE
                                                  !if( W(i,j,k,is) > 3. .and. tot_cld(i,j,k,is) > 1.e-6)then
                                                  if( W(i,j,k,is) > 2. .and. tot_qcld(i,j,k,is) < 1.e-6 .and. tot_qice(i,j,k,is) > 1.e-6)then
                                                            if ( factor_b_ice(i,j,k,is) /= -999. .and. factor_b_snow(i,j,k,is) /= -999. .and. factor_b_graup(i,j,k,is) /= -999. .and. &
                                                                 fact_a0(i,j,k,is) >= 0. .and. fact_snow(i,j,k,is) >= 0. .and. fact_graup(i,j,k,is) >= 0. )then
                                                                      if(size_cld_ice(i,j,k,is) > 0. .or. size_snow(i,j,k,is) > 0. .or. size_graup(i,j,k,is) > 0.) then
                                                                                fact_n_crit_1 = fact_a0(i,j,k,is)*W(i,j,k,is)
                                                                                fact_n_crit_2 = factor_b_ice(i,j,k,is)*size_cld_ice(i,j,k,is)
                                                                                fact_n_crit_3 = factor_b_snow(i,j,k,is)*size_snow(i,j,k,is)*fact_snow(i,j,k,is)
                                                                                fact_n_crit_4 = factor_b_graup(i,j,k,is)*size_graup(i,j,k,is)*fact_graup(i,j,k,is)
                                                                                fact_n_crit_5 = fact_n_crit_2+fact_n_crit_3+fact_n_crit_4
                                                                                n_ice_crit(i,j,k,is) = fact_n_crit_1/fact_n_crit_5       !perm3
                                                                                if (n_ice_crit(i,j,k,is) < 0.) stop 8788
                                                                                critical_point_ice_flag(i,j,k,is) = 1
                                                                      
                                                                      endif
                                                            else
                                                                                    n_ice_crit(i,j,k,is) = -999.
                                                                                n_tot_ice_crit(i,j,k,is) = -999.
                                                                                critical_point_ice_flag(i,j,k,is) = 0
                                                            endif
                                                  !endif
                                                  endif   
                                        enddo
                              enddo
                    enddo
           enddo
 print*,'HERE :: 9'
 !==========================================================================!
 !============ Calculating snow and graupel concentration ==================!
 !==========================================================================!
           n_tot_ice_crit = 0.;
           do is = is_start, is_end!1, ist
                    do i = 1, ew
                              do j = 1, ns
                                        do k = 1, bt
                                                  !================= CLOUD ICE
                                                  if(critical_point_ice_flag(i,j,k,is) == 1)then
                                                                                 n_snow_crit(i,j,k,is) = fact_snow(i,j,k,is)*n_ice_crit(i,j,k,is)
                                                                                n_graup_crit(i,j,k,is) = fact_graup(i,j,k,is)*n_ice_crit(i,j,k,is)
                                                                                n_tot_ice_crit(i,j,k,is) = n_ice_crit(i,j,k,is) + n_snow_crit(i,j,k,is) + n_graup_crit(i,j,k,is)
                                                                                if (n_ice_crit(i,j,k,is) < 0.) stop 8788
                                                                                if (n_tot_ice_crit(i,j,k,is) < 0.) print*,fact_snow(i,j,k,is),fact_graup(i,j,k,is)
                                                                                if (n_tot_ice_crit(i,j,k,is) < 0.) print*,n_ice_crit(i,j,k,is),n_snow_crit(i,j,k,is),n_graup_crit(i,j,k,is)
                                                                                if (n_tot_ice_crit(i,j,k,is) < 0.) stop 98787
                                                  else
                                                                                    n_ice_crit(i,j,k,is) = -999.
                                                                                n_tot_ice_crit(i,j,k,is) = -999.
                                                  endif
                                                            if(critical_point_ice_flag(i,j,k,is) == 1 .and. n_tot_ice_crit(i,j,k,is) < 0.) print*,n_ice_crit,n_snow_crit(i,j,k,is),n_graup_crit(i,j,k,is)
                                                            if(critical_point_ice_flag(i,j,k,is) == 1 .and. n_tot_ice_crit(i,j,k,is) < 0.) stop 130411   
                                        enddo
                              enddo
                    enddo
           enddo
 print*,'HERE :: 10'           
!=======================================================================!
!======================== Temperature Dependency =======================!
!=======================================================================!

!================ CLOUD ICE
          do tt = 1,21 !min_temp,bin_temp
                     n_ice_crit_av_t(tt) = 0.; ik = 0; temp_tt(tt) = 0; 
                              do is = is_start, is_end!1, ist
                                        do i = 1, ew
                                                  do j = 1, ns
                                                            do k = 1, bt
                                                                      if (critical_point_ice_flag(i,j,k,is) == 1) then
                                                                                if (TEMP(i,j,k,is) < temp_ord(tt) .and. TEMP(i,j,k,is) > temp_ord(tt+1)) then
                                                                                       n_ice_crit_av_t(tt) = n_ice_crit_av_t(tt)+n_ice_crit(i,j,k,is)
                                                                                               temp_tt(tt) = temp_tt(tt)  + temp_crit(i,j,k,is)
                                                                                                        ik = ik + 1
                                                                                endif
                                                                      endif
                                                            enddo
                                                  enddo
                                        enddo
                              enddo

                              if(ik > 0) then
                                       n_ice_crit_av_t(tt) = n_ice_crit_av_t(tt)/real(ik)
                                               temp_tt(tt) = temp_tt(tt)/real(ik)
                              else
                                       n_ice_crit_av_t(tt) = -999.  
                                              temp_tt(tt)  = -999.
                              endif
          enddo

          open(2,file='CRITICAL_CLD_ICE_CONC_percm3',form="formatted", access="sequential",status="unknown")
                    do tt = 1,21 !min_temp,bin_temp	
                              write(2,*) n_ice_crit_av_t(tt)/(1.e6),temp_ord(tt) - bin_temp*0.5 ! perm2 to percm3 
                              write(*,*) n_ice_crit_av_t(tt)/(1.e6),temp_ord(tt) - bin_temp*0.5 ! perm2 to percm3 
                    enddo
          close(2)
print*,'HERE :: 11'

!================ TOTAL ICE
          do tt = 1,21 !min_temp,bin_temp
                     n_tot_ice_crit_av_t(tt) = 0.; ik = 0; temp_tt(tt) = 0; 
                              do is = is_start, is_end!1, ist
                                        do i = 1, ew
                                                  do j = 1, ns
                                                            do k = 1, bt
                                                                      if (TEMP(i,j,k,is) < temp_ord(tt) .and. TEMP(i,j,k,is) > temp_ord(tt+1)) then
                                                                                if (critical_point_ice_flag(i,j,k,is) == 1) then
                                                                                       n_tot_ice_crit_av_t(tt) = n_tot_ice_crit_av_t(tt)+n_tot_ice_crit(i,j,k,is)
                                                                                               temp_tt(tt) = temp_tt(tt) + temp_crit(i,j,k,is)
                                                                                                        ik = ik + 1
                                                                                endif
                                                                      endif
                                                            enddo
                                                  enddo
                                        enddo
                              enddo

                              if(ik > 0) then
                                       n_tot_ice_crit_av_t(tt) = n_tot_ice_crit_av_t(tt)/real(ik)
                                               temp_tt(tt) = temp_tt(tt)/real(ik)
                              else
                                       n_tot_ice_crit_av_t(tt) = -999.  
                                              temp_tt(tt)  = -999.
                              endif
          enddo

          open(2,file='CRITICAL_TOT_ICE_CONC_percm3',form="formatted", access="sequential",status="unknown")
                    do tt = 1,21 !min_temp,bin_temp	
                              write(2,*) n_tot_ice_crit_av_t(tt)/(1.e6),temp_ord(tt) - bin_temp*0.5 ! perm2 to percm3 
                              write(*,*) n_tot_ice_crit_av_t(tt)/(1.e6),temp_ord(tt) - bin_temp*0.5 ! perm2 to percm3 
                    enddo
          close(2)
print*,'HERE :: 12'
                                    
        CONTAINS
        
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2011-05-10_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output
        

        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check
           end 

        
          DOUBLE PRECISION FUNCTION ESW_new_Pa(T)
          !IMPLICIT NONE
          DOUBLE PRECISION :: T
          DOUBLE PRECISION :: ESW_new_Pa_332,GGESW
          INTRINSIC:: LOG, TANH, DEXP
          !		Murphy and Koop (2005)
          !
          !     ESI     SATURATION VAPOR PRESSURE  (Pa)
          !     T       TEMP  (KELVIN)
          !

          IF(T < 123.) STOP 1232
          IF(T > 332.) THEN 

          ESW_new_Pa_332 = 18914.20515978354

          ESW_new_Pa = 100.*GGESW(T) * ESW_new_Pa_332/(100.*GGESW(332.D0))

          ELSE	 
          ESW_new_Pa = 53.878 - 1331.22/T - 9.44523*LOG(T ) + 0.014025*T
          ESW_new_Pa = 54.842763 - 6763.22/T - 4.210*LOG(T) + 0.000367*T &
          + TANH(0.0415*(T - 218.8))*ESW_new_Pa
          ESW_new_Pa = DEXP(ESW_new_Pa)
          ENDIF
          RETURN
          END FUNCTION ESW_new_Pa

          DOUBLE PRECISION FUNCTION GGESW(TA)
          !IMPLICIT NONE 
          DOUBLE PRECISION, INTENT(IN) :: TA
          DOUBLE PRECISION :: TS, F5, E1, E2, F1, F2, F3, F4, F
          !
          !     SATURATION VAPOR PRESSURE OVER WATER
          !          (GOFF AND GRATCH)
          !
          !     TA IS TEMPERATURE IN DEG KELVIN
          !     ES IS SATURATION VAPOR PRESSURE IN MB
          !
          DATA TS/373.16/F5/3.0057149/

          !       GGESW = 2.53e11*EXP(-5420./TA)/100.
          ! RETURN

          E1 = 11.344*(1.0 - TA/TS)
          E2 = -3.49149*(TS/TA - 1.0)
          F1 = -7.90298*(TS/TA - 1.0)
          F2 = 5.02808*DLOG10(TS/TA)
          F3 = -1.3816E-7*(10.0**E1 -1.0)
          F4 = 8.1328E-3*(10.0**E2 - 1.0)
          F = F1 + F2 + F3 + F4 + F5
          GGESW = 10.0**F
          RETURN
          END FUNCTION GGESW

          DOUBLE PRECISION FUNCTION ESI_new_Pa(T)
          IMPLICIT NONE
          DOUBLE PRECISION :: T
          INTRINSIC:: LOG, DEXP
          !		Murphy and Koop (2005)
          !
          !     ESI     SATURATION VAPOR PRESSURE  (Pa)
          !     T       TEMP  (KELVIN)
          !
          IF(T < 110.) STOP 1234

          ESI_new_Pa = DEXP(9.550426 - 5723.265/T + 3.53068*log(T) - 0.00728332*T)
          RETURN
          END FUNCTION ESI_new_Pa
