
  
        program hist

	use netcdf

        implicit none

        integer                  :: i, j, k, is, ew, ns, bt, ist, ik, jk, ij, is_start, is_end
	parameter(ew = 40, ns = 40, bt = 40)
        real, dimension(bt)      :: model_z, ni_ave_int, obs_z
        real                     :: n_dust_act_perm3, n_dust_unact_perm3, n_bc_act_perm3, n_bc_unact_perm3,  &
                                    n_totice_perm3, w_snow_mean, w_rain_mean
                                    
        real, allocatable        :: RRB(:,:,:,:), PB(:,:,:,:), W(:,:,:,:), HEIGHT(:,:,:,:), TEMP(:,:,:,:),        &
                                    QSNOW(:,:,:,:), QICE(:,:,:,:), QCLOUD(:,:,:,:), QGRAUP(:,:,:,:),              &
                                    NW(:,:,:,:), NI(:,:,:,:), NSNOW(:,:,:,:), NGRAUP(:,:,:,:),                    &
                                    NRAIN(:,:,:,:), N_DUST_ACT(:,:,:,:), N_BC_ACT(:,:,:,:),                       &
                                    N_FNG_ACT(:,:,:,:), N_BCT_ACT(:,:,:,:), N_DTS_ACT(:,:,:,:),                   &
                                    N_ALG_ACT(:,:,:,:), N_PLN_ACT(:,:,:,:), N_BIO_ACT(:,:,:,:),                   &
                                    N_sO_IN_ACT(:,:,:,:), N_DUST_UNACT(:,:,:,:), N_BC_UNACT(:,:,:,:),             &
                                    tot_cld(:,:,:,:), N_DUST_IMM(:,:,:,:), N_BC_IMM(:,:,:,:), ZREFL(:,:,:,:),     &
                                    qcloud_avg(:,:), qice_avg(:,:), qsnow_avg(:,:), qgraup_avg(:,:),              &
                                    nice_avg(:,:), nsnow_avg(:,:), ngraup_avg(:,:), ntotice_avg(:,:),             &
                                    flux_totice_avg(:,:), flux_dust_act(:,:), flux_dust_unact(:,:),               &
                                    ndustact_avg(:,:), ndustunact_avg(:,:), flux_bc_act(:,:), flux_bc_unact(:,:), &
                                    nbcact_avg(:,:), nbcunact_avg(:,:), zrefl_avg(:,:), ht_avg(:), temp_avg(:),   &
                                    pres_avg(:), Q_DUST_CLD(:,:,:,:), Q_DUST_AIR(:,:,:,:), Q_DUST_PREC(:,:,:,:),  &
                                    qdust_cld(:,:), qdust_air(:,:), qdust_prec(:,:), flux_qdust_cld(:,:),         &
                                    flux_qdust_air(:,:), flux_qdust_prec(:,:), flux_ntotice_up_avg(:,:),          &
                                    flux_ndust_up_act(:,:), flux_ndust_up_unact(:,:), flux_nbc_up_act(:,:),       &
                                    flux_nbc_up_unact(:,:), flux_qdust_up_cld(:,:), flux_qdust_up_air(:,:),       &
                                    flux_qdust_up_prec(:,:), flux_ntotice_down_avg(:,:), flux_ndust_down_act(:,:),&
                                    flux_ndust_down_unact(:,:), flux_nbc_down_act(:,:), flux_nbc_down_unact(:,:), &
                                    flux_qdust_down_cld(:,:), flux_qdust_down_air(:,:), flux_qdust_down_prec(:,:), &
                                    VTS3D(:,:,:,:), VTR3D(:,:,:,:), QRAIN(:,:,:,:), qrain_avg(:,:), nw_avg(:,:),   &
                                    nrain_avg(:,:), N_ICE_hm(:,:,:,:), N_SNOW_hm(:,:,:,:), N_ICE_sbf(:,:,:,:),     &
                                    N_SNOW_sbf(:,:,:,:), N_ICE_BREAK(:,:,:,:), N_SNOW_BREAK(:,:,:,:),              &
                                    N_ICE_rf(:,:,:,:), N_SNOW_rf(:,:,:,:), ntotice_hm_avg(:,:), ntotice_sb_avg(:,:), &
                                    ntotice_mb_avg(:,:), ntotice_rf_avg(:,:), w_avg(:,:)
                                    
                                  
        INTRINSIC 	             :: TRIM, REAL, ABS

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)

	open(10,file='is_start_end',status="unknown")
	read(10,*) is_start, is_end
	close (10)

!
!==========================================================================================
!		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!
          allocate(RRB(ew,ns,bt,ist), PB(ew,ns,bt,ist), W(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist), TEMP(ew,ns,bt,ist),         &
                   QSNOW(ew,ns,bt,ist), QICE(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), QGRAUP(ew,ns,bt,ist),                    &
                   NW(ew,ns,bt,ist), NI(ew,ns,bt,ist), NSNOW(ew,ns,bt,ist), NGRAUP(ew,ns,bt,ist), NRAIN(ew,ns,bt,ist),     &
                   N_DUST_ACT(ew,ns,bt,ist), N_BC_ACT(ew,ns,bt,ist), N_FNG_ACT(ew,ns,bt,ist), N_BCT_ACT(ew,ns,bt,ist),     &
                   N_DTS_ACT(ew,ns,bt,ist), N_ALG_ACT(ew,ns,bt,ist), N_PLN_ACT(ew,ns,bt,ist), N_BIO_ACT(ew,ns,bt,ist),     &
	         N_sO_IN_ACT(ew,ns,bt,ist), N_DUST_UNACT(ew,ns,bt,ist), N_BC_UNACT(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist), &
	         N_DUST_IMM(ew,ns,bt,ist), N_BC_IMM(ew,ns,bt,ist), ZREFL(ew,ns,bt,ist), qcloud_avg(bt,ist),              &
	         qice_avg(bt,ist), qsnow_avg(bt,ist), qgraup_avg(bt,ist), nice_avg(bt,ist), nsnow_avg(bt,ist),           &
	         ngraup_avg(bt,ist), ntotice_avg(bt,ist), flux_totice_avg(bt,ist), flux_dust_act(bt,ist),                &
	         flux_dust_unact(bt,ist), ndustact_avg(bt,ist), ndustunact_avg(bt,ist), flux_bc_act(bt,ist),             &
	         flux_bc_unact(bt,ist), nbcact_avg(bt,ist), nbcunact_avg(bt,ist), zrefl_avg(bt,ist), ht_avg(bt),         &
	         temp_avg(bt), pres_avg(bt), Q_DUST_CLD(ew,ns,bt,ist), Q_DUST_AIR(ew,ns,bt,ist),                         &
	         Q_DUST_PREC(ew,ns,bt,ist), qdust_cld(bt,ist), qdust_air(bt,ist), qdust_prec(bt,ist),                    &
	         flux_qdust_cld(bt,ist), flux_qdust_air(bt,ist), flux_qdust_prec(bt,ist), flux_ntotice_up_avg(bt,ist),   &
                   flux_ndust_up_act(bt,ist), flux_ndust_up_unact(bt,ist), flux_nbc_up_act(bt,ist),                        &
                   flux_nbc_up_unact(bt,ist), flux_qdust_up_cld(bt,ist), flux_qdust_up_air(bt,ist),                        &
                   flux_qdust_up_prec(bt,ist), flux_ntotice_down_avg(bt,ist), flux_ndust_down_act(bt,ist),                 &
                   flux_ndust_down_unact(bt,ist), flux_nbc_down_act(bt,ist), flux_nbc_down_unact(bt,ist),                  &
                   flux_qdust_down_cld(bt,ist), flux_qdust_down_air(bt,ist), flux_qdust_down_prec(bt,ist),                 &
                   VTS3D(ew,ns,bt,ist), VTR3D(ew,ns,bt,ist), QRAIN(ew,ns,bt,ist), qrain_avg(bt,ist), nw_avg(bt,ist),       &
                   nrain_avg(bt,ist), N_ICE_hm(ew,ns,bt,ist), N_SNOW_hm(ew,ns,bt,ist), N_ICE_sbf(ew,ns,bt,ist),            &
                   N_SNOW_sbf(ew,ns,bt,ist), N_ICE_BREAK(ew,ns,bt,ist), N_SNOW_BREAK(ew,ns,bt,ist),                        &
                   N_ICE_rf(ew,ns,bt,ist), N_SNOW_rf(ew,ns,bt,ist), ntotice_hm_avg(bt,ist), ntotice_sb_avg(bt,ist),        &
                   ntotice_mb_avg(bt,ist), ntotice_rf_avg(bt,ist), w_avg(bt,ist))
	         
                         
        call read_wrf4d_output('RRB',3 , RRB)
        call read_wrf4d_output('PB',2 , PB)
        call read_wrf4d_output('W', 1 , W)
        call read_wrf4d_output('HEIGHT',6 , HEIGHT)
        call read_wrf4d_output('TEMP',4 , TEMP)
        call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
        call read_wrf4d_output('QICE',4 , QICE)
        call read_wrf4d_output('QSNOW',5 , QSNOW)
        call read_wrf4d_output('QGRAUP',6 ,QGRAUP)
        call read_wrf4d_output('QRAIN',5 , QRAIN)
        
        call read_wrf4d_output('NW',2 , NW)
        call read_wrf4d_output('NI',2 , NI)
        call read_wrf4d_output('NSNOW',5 , NSNOW)
        call read_wrf4d_output('NGRAUP',6 ,NGRAUP)
        call read_wrf4d_output('NSNOW',5 , NSNOW)
        call read_wrf4d_output('NRAIN',5 , NRAIN)
        
        call read_wrf4d_output('N_ICE_sbf',9 , N_ICE_sbf)
        call read_wrf4d_output('N_SNOW_sbf',10 , N_SNOW_sbf)
        call read_wrf4d_output('N_ICE_rf',8 , N_ICE_hm)
        call read_wrf4d_output('N_SNOW_rf',9 , N_SNOW_rf)
        call read_wrf4d_output('N_ICE_hm',8 , N_ICE_hm)
        call read_wrf4d_output('N_SNOW_hm',9 , N_SNOW_hm)
        call read_wrf4d_output('N_ICE_BREAK',11 , N_ICE_BREAK)
        call read_wrf4d_output('N_SNOW_BREAK',12 , N_SNOW_BREAK)
                

          !!=================== Number concentration (m⁻³) and flux = rho*W*n       m⁻² s⁻¹
          n_dust_act_perm3 = 0.; n_dust_unact_perm3 = 0.; 
          n_bc_act_perm3 = 0.; n_bc_unact_perm3 = 0.; n_totice_perm3 = 0.;
          do k = 1, bt
                    do is = 1, ist
                             nw_avg(k,is) = 0.; nice_avg(k,is) = 0.; nsnow_avg(k,is) = 0.; ngraup_avg(k,is) = 0.; 
                             ntotice_avg(k,is) = 0.; nrain_avg(k,is) = 0.; ntotice_sb_avg(k,is) = 0.; 
                             ntotice_rf_avg(k,is) = 0.; ntotice_hm_avg(k,is) = 0.; ntotice_mb_avg(k,is) = 0.; w_avg(k,is) = 0.;
                             ik = 0;
                              do i = 1, ew
                                        do j = 1, ns
                                                     n_totice_perm3 = RRB(i,j,k,is)*(NI(i,j,k,is)+NSNOW(i,j,k,is)+NGRAUP(i,j,k,is))
                                                     tot_cld(i,j,k,is) = QCLOUD(i,j,k,is)+QICE(i,j,k,is)
                                                     nw_avg(k,is) = nw_avg(k,is)+RRB(i,j,k,is)*NW(i,j,k,is)
                                                     nice_avg(k,is)    = nice_avg(k,is)+RRB(i,j,k,is)*NI(i,j,k,is)
                                                     nsnow_avg(k,is)   = nsnow_avg(k,is)+RRB(i,j,k,is)*NSNOW(i,j,k,is)
                                                     ngraup_avg(k,is)  = ngraup_avg(k,is)+RRB(i,j,k,is)*NGRAUP(i,j,k,is)
                                                     ntotice_avg(k,is) = nice_avg(k,is)+nsnow_avg(k,is)+ngraup_avg(k,is)
                                                     nrain_avg(k,is)   = nrain_avg(k,is)+RRB(i,j,k,is)*NRAIN(i,j,k,is)
                                                     ntotice_sb_avg(k,is) = ntotice_sb_avg(k,is)+RRB(i,j,k,is)*(N_ICE_sbf(i,j,k,is)+N_SNOW_sbf(i,j,k,is))
                                                     ntotice_rf_avg(k,is) = ntotice_rf_avg(k,is)+RRB(i,j,k,is)*(N_ICE_rf(i,j,k,is)+N_SNOW_rf(i,j,k,is))
                                                     ntotice_hm_avg(k,is) = ntotice_hm_avg(k,is)+RRB(i,j,k,is)*(N_ICE_hm(i,j,k,is)+N_SNOW_hm(i,j,k,is))
                                                     ntotice_mb_avg(k,is) = ntotice_mb_avg(k,is)+RRB(i,j,k,is)*(N_ICE_break(i,j,k,is)+N_SNOW_break(i,j,k,is))
                                                     w_avg(k,is) = w_avg(k,is) + W(i,j,k,is)
                                                  
                                                      ik = ik+1
                                        enddo
                              enddo
                              if(ik > 0)then
                                                 nw_avg(k,is) = nw_avg(k,is)/real(ik)
                                            nice_avg(k,is)    = nice_avg(k,is)/real(ik)
                                            nsnow_avg(k,is)   = nsnow_avg(k,is)/real(ik)
                                            ngraup_avg(k,is)  = ngraup_avg(k,is)/real(ik)
                                            nrain_avg(k,is)   = nrain_avg(k,is)/real(ik)
                                            ntotice_avg(k,is) = nice_avg(k,is)/real(ik)
                                            ntotice_sb_avg(k,is) = ntotice_sb_avg(k,is)/real(ik)
                                            ntotice_rf_avg(k,is) = ntotice_rf_avg(k,is)/real(ik)
                                            ntotice_hm_avg(k,is) = ntotice_hm_avg(k,is)/real(ik)
                                            ntotice_mb_avg(k,is) = ntotice_mb_avg(k,is)/real(ik)
                                                     w_avg(k,is) = w_avg(k,is)/real(ik)
                              else
                                                 nw_avg(k,is) = -999.
                                            nice_avg(k,is)    = -999.
                                            nsnow_avg(k,is)   = -999.
                                            ngraup_avg(k,is)  = -999.
                                            nrain_avg(k,is)   = -999.
                                            ntotice_avg(k,is) = -999.
                                            ntotice_sb_avg(k,is) = -999.
                                            ntotice_rf_avg(k,is) = -999.
                                            ntotice_hm_avg(k,is) = -999.
                                            ntotice_mb_avg(k,is) = -999.
                                                     w_avg(k,is) = -999.
                              
                              endif
                    enddo
          enddo
          
          !!====== Water content g/m3
          do k = 1, bt
                    do is = 1, ist
                             qcloud_avg(k,is) = 0.; qice_avg(k,is) = 0.; qsnow_avg(k,is) = 0.; 
                             qgraup_avg(k,is) = 0.; qrain_avg(k,is) = 0.; ik = 0;
                              do i = 1, ew
                                        do j = 1, ns
                                                  qcloud_avg(k,is) = qcloud_avg(k,is)+RRB(i,j,k,is)*QCLOUD(i,j,k,is)
                                                  qice_avg(k,is)   = qice_avg(k,is)+RRB(i,j,k,is)*QICE(i,j,k,is)
                                                  qsnow_avg(k,is)  = qsnow_avg(k,is)+RRB(i,j,k,is)*QSNOW(i,j,k,is)
                                                  qgraup_avg(k,is) = qgraup_avg(k,is)+RRB(i,j,k,is)*QGRAUP(i,j,k,is)
                                                  qrain_avg(k,is)  = qrain_avg(k,is)+RRB(i,j,k,is)*QRAIN(i,j,k,is)
                                                  ik = ik+1
                                        enddo
                              enddo
                    enddo
                    if(ik > 0)then
                         qcloud_avg(k,is) = qcloud_avg(k,is)/real(ik)
                         qice_avg(k,is)   = qice_avg(k,is)/real(ik)
                         qsnow_avg(k,is)  = qsnow_avg(k,is)/real(ik)
                         qgraup_avg(k,is) = qgraup_avg(k,is)/real(ik)
                         qrain_avg(k,is)  = qrain_avg(k,is)/real(ik)
                    else
                        qcloud_avg(k,is)  = -999.
                        qice_avg(k,is)    = -999.
                        qsnow_avg(k,is)   = -999.
                        qgraup_avg(k,is)  = -999.
                         qrain_avg(k,is)  = -999. 
                    endif
          enddo
          
          !!========= Radar reflectivity dBZ
          do k = 1, bt
                    ht_avg(k)= 0.; temp_avg(k) = 0.; pres_avg(k) = 0.; ik = 0.; 
                    do is = 1, ist
                              do i = 1, ew
                                        do j = 1, ns
                                                  ht_avg(k)   = ht_avg(k) + HEIGHT(i,j,k,is)
                                                  temp_avg(k) = temp_avg(k) + TEMP(i,j,k,is)
                                                  pres_avg(k) = pres_avg(k) + PB(i,j,k,is)
                                                  ik = ik + 1
                                        enddo
                              enddo               
                    enddo
                    if(ik > 1)then
                              ht_avg(k)   = ht_avg(k)/real(ik)
                              pres_avg(k) = pres_avg(k)/real(ik)
                              temp_avg(k) = temp_avg(k)/real(ik)
                    else
                              ht_avg(k)   = -999.
                              pres_avg(k) = -999.
                              temp_avg(k) = -999.
                    endif
          enddo
          
                    open(12,file='CDNC_TIME_HT_MC3E_perm3',form="formatted", access="sequential",status="unknown")
                    open(22,file='NCLDICE_TIME_HT_MC3E_perm3',form="formatted", access="sequential",status="unknown")
                    open(32,file='NSNOW_TIME_HT_MC3E_perm3',form="formatted", access="sequential",status="unknown")
                    open(42,file='NGRAUP_TIME_HT_MC3E_perm3',form="formatted", access="sequential",status="unknown")
                    open(52,file='NRAIN_TIME_HT_MC3E_perm3',form="formatted", access="sequential",status="unknown")
                    open(62,file='NTOTICE_TIME_HT_MC3E_perm3',form="formatted", access="sequential",status="unknown")
                    open(72,file='QCLDLIQ_TIME_HT_MC3E_kgperm3',form="formatted", access="sequential",status="unknown")
                    open(82,file='QCLDICE_TIME_HT_MC3E_kgperm3',form="formatted", access="sequential",status="unknown")
                    open(92,file='QSNOW_TIME_HT_MC3E_kgperm3',form="formatted", access="sequential",status="unknown")
                    open(102,file='QGRAUP_TIME_HT_MC3E_kgperm3',form="formatted", access="sequential",status="unknown")
                    open(112,file='QRAIN_TIME_HT_MC3E_kgperm3',form="formatted", access="sequential",status="unknown")
                    open(122,file='QTOT_CLD_ICE_SNOW_GRAUP_TIME_HT_MC3E_kgperm3',form="formatted", access="sequential",status="unknown")
                    
                    open(132,file='NTOTICE_SB_TIME_HT_MC3E_perm3',form="formatted", access="sequential",status="unknown")
                    open(142,file='NTOTICE_RF_TIME_HT_MC3E_perm3',form="formatted", access="sequential",status="unknown")
                    open(152,file='NTOTICE_HM_TIME_HT_MC3E_perm3',form="formatted", access="sequential",status="unknown")
                    open(162,file='NTOTICE_MB_TIME_HT_MC3E_perm3',form="formatted", access="sequential",status="unknown")
                    open(172,file='W_TIME_HT_MC3E_mpers',form="formatted", access="sequential",status="unknown")
                    
                              do k = 1, bt
                                        do is = 1, ist
                                                  write(12,*)nw_avg(k,is)
                                                  write(22,*)nice_avg(k,is)
                                                  write(32,*)nsnow_avg(k,is)
                                                  write(42,*)ngraup_avg(k,is)
                                                  write(52,*)nrain_avg(k,is)
                                                  write(62,*)ntotice_avg(k,is)
                                                  write(72,*)qcloud_avg(k,is)
                                                  write(82,*)qice_avg(k,is)
                                                  write(92,*)qsnow_avg(k,is)
                                                  write(102,*)qgraup_avg(k,is)
                                                  write(112,*)qrain_avg(k,is)
                                                  write(122,*)qice_avg(k,is)+qsnow_avg(k,is)+qgraup_avg(k,is)
                                                  
                                                  write(132,*)ntotice_sb_avg(k,is)
                                                  write(142,*)ntotice_rf_avg(k,is)
                                                  write(152,*)ntotice_hm_avg(k,is)
                                                  write(162,*)ntotice_mb_avg(k,is)
                                                  write(172,*)w_avg(k,is)
                                        enddo
                              enddo
                    
                    

          open(2,file='MEAN_HT_PRES_TEMP_MC3E',form="formatted", access="sequential",status="unknown")

          do k = 1, bt	
                    write(2,*) ht_avg(k), pres_avg(k), temp_avg(k)
          enddo
          close(2)
           
          open(2,file='TIME_HRS_MC3E',form="formatted", access="sequential",status="unknown")

          do is = 1, ist	
                    write(2,*) 130.+is*10./(24.*60.)
                    write(*,*) 130.+is*10./(24.*60.)
          enddo
          close(2)
                    
90 format(f9.3,2x,f9.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3,2x,e12.3)



        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2011-05-10_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output

       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	do 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check


 
	end
