
  
        program hist

	use netcdf

        implicit none

        integer                :: i,j, k, is, t, ik, lifetime, ist, bt, ew, ns, jk
	parameter(ew = 40, ns = 40, bt = 40)

        real, allocatable      :: nw(:,:,:,:), NI100UM(:,:,:,:), NSNOW200um(:,:,:,:), NGRAUP200um(:,:,:,:),        &
                                  NI(:,:,:,:), NSNOW(:,:,:,:), NGRAUP(:,:,:,:), tau_vis(:,:,:,:), ni_av(:),        &
                                  rho(:,:), RRB(:,:,:,:), QCLOUD(:,:,:,:), w(:,:,:,:), HEIGHT(:,:,:,:),            &
			    QICE(:,:,:,:), tot_cld(:,:,:,:), TEMP(:,:,:,:), temp_tt(:), D_CI(:,:,:,:),       &
                                  D_SNOW(:,:,:,:), D_GRAUP(:,:,:,:), ht_bin(:), w_vert_shear(:), ht_avg(:)

        INTRINSIC 	         :: TRIM, REAL, ABS
        

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)
 

!
!==========================================================================================
!		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!

        allocate(nw(ew,ns,bt,ist), NI100UM(ew,ns,bt,ist), NSNOW200um(ew,ns,bt,ist), NGRAUP200um(ew,ns,bt,ist),   &
                 NI(ew,ns,bt,ist), NSNOW(ew,ns,bt,ist), NGRAUP(ew,ns,bt,ist), tau_vis(ew,ns,bt,ist), ni_av(bt),  &
                 rho(bt,ist), RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), w(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist),    &
                 QICE(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist),TEMP(ew,ns,bt,ist), temp_tt(bt), D_CI(ew,ns,bt,ist), &
                 D_SNOW(ew,ns,bt,ist), D_GRAUP(ew,ns,bt,ist), w_vert_shear(bt), ht_avg(bt))

        call read_wrf4d_output('NSNOW200UM',10,NSNOW200UM)
        call read_wrf4d_output('NGRAUP200UM',11,NGRAUP200UM) 
        call read_wrf4d_output('NI',2,NI) 
        call read_wrf4d_output('NSNOW',5,NSNOW)
        call read_wrf4d_output('NGRAUP',6,NGRAUP)
        call read_wrf4d_output('TAU_VIS',7 ,TAU_VIS)
        call read_wrf4d_output('RRB',3 , RRB)
!        call read_wrf4d_output('NW',2 , nw)
        call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
        call read_wrf4d_output('QICE', 4 , QICE)
        call read_wrf4d_output('W', 1 , W)
        call read_wrf4d_output('HEIGHT',6 , HEIGHT)
        call read_wrf4d_output('TEMP',4 , TEMP)
        call read_wrf4d_output('D_CI', 4 , D_CI)
        call read_wrf4d_output('D_SNOW',6 , D_SNOW)
        call read_wrf4d_output('D_GRAUP',7 , D_GRAUP)

!
!=======================================================================
!			Temperature Dependency
!		Output Data written in NI100UM_T_percm3
!=======================================================================
!

          do k=1,bt-1
          w_vert_shear(k) = 0.; ht_avg(k) = 0.; 
          temp_tt(k) = 0.; ik = 0; jk = 0;
                              do is= 1, ist
                                        do i=1,ew
                                                  do j=1,ns
                                                            tot_cld(i,j,k,is) = rrb(i,j,k,is)*(QCLOUD(i,j,k,is)+QICE(i,j,k,is))
                                                            if(tot_cld(i,j,k,is) > 1.e-6) then
                                                                      w_vert_shear(k)  = w_vert_shear(k)+(W(i,j,k+1,is)-W(i,j,k,is))/(HEIGHT(i,j,k+1,is)-HEIGHT(i,j,k,is))
                                                                      jk = jk+1
                                                            endif
                                                                      temp_tt(k)  = temp_tt(k)  + TEMP(i,j,k,is)
                                                                      ht_avg(k)   = ht_avg(k) + HEIGHT(i,j,k,is)
                                                                      ik = ik + 1
                                                  enddo
                                        enddo
                              enddo
          
                    if(ik > 0) then
                              if(jk > 0)w_vert_shear(k) = w_vert_shear(k)/REAL(jk)
                              if(jk <= 0)w_vert_shear(k) = -999.
                              temp_tt(k)      = temp_tt(k)/real(ik)
                              ht_avg(k)       = ht_avg(k)/real(ik)
                    else
                              w_vert_shear(k)  = -999.
                              temp_tt(k)       = -999.
                              ht_avg(k)        = -999. 
                    endif
          enddo

!stop 97867


          open(2,file='vertical_wind_shear_persec',form="formatted", access="sequential",status="unknown")
          do k = 1,bt	
                    write(2,*) temp_tt(k),ht_avg(k),w_vert_shear(k)
                    write(*,*) temp_tt(k),ht_avg(k),w_vert_shear(k)	   
          enddo
          close(2)

 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2011-05-10_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check
        
       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat




 
	end
