

          program hist

          use netcdf

          implicit none

          integer                  :: i,j, t, lifetime,   ist, bt, ew, ns,tt,n_temp_bin, n_bin_tt
          parameter(bt=40, ew=40, ns=40, n_bin_tt = 22)
          real, dimension(bt)      :: model_z, ni_ave_int, obs_z
          integer, allocatable     :: iav(:,:)
          integer 	               :: i_ens, nrec, k, is, ik,grid,cloud,ntest,bin_temp,min_temp
          real,dimension(n_bin_tt) :: temp_ord,ni_av_t, q_snow_av_t, q_ice_av_t, &
                                      q_graup_av_t, ni200_av_t, temp_tt, q_cld_av_t, &
                                      n_ice_av_t, n_graup_av_t, n_snow_av_t, qg_cold_av_t, &
                                      qg_warm_av_t, ng_cold_av_t, ng_warm_av_t!, qg_tot_av_t
                                    
          real, allocatable        :: RRB(:,:,:,:), W(:,:,:,:), HEIGHT(:,:,:,:), TEMP(:,:,:,:), NI200UM(:,:,:,:), &
                                      NSNOW200UM(:,:,:,:), NGRAUP200UM(:,:,:,:), NI(:,:,:,:), NSNOW(:,:,:,:), NGRAUP(:,:,:,:), &
                                      QSNOW(:,:,:,:), QGRAUP(:,:,:,:), QCLOUD(:,:,:,:), QICE(:,:,:,:), tot_cld(:,:,:,:),       &
                                      NG_COLD(:,:,:,:), NG_WARM(:,:,:,:), QG_COLD(:,:,:,:), QG_WARM(:,:,:,:)
                                  
          INTRINSIC 	     :: TRIM, REAL, ABS

          open(10,file='ist',status="unknown")
          read(10,*) ist
          close (10)

          !bin_temp = 3.
          !min_temp = -19 
          !min_temp = min_temp * -1
          n_temp_bin = 30
          bin_temp = 1.
          min_temp = 30. !-20 

          !
          !==========================================================================================
          !		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
          !				with Altitude and Temperature(DegC)
          !==========================================================================================
          !

	          
          allocate( RRB(ew,ns,bt,ist), W(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist), TEMP(ew,ns,bt,ist),            &
                    NI(ew,ns,bt,ist), NSNOW(ew,ns,bt,ist), NGRAUP(ew,ns,bt,ist), QICE(ew,ns,bt,ist),         &
                    QSNOW(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), QGRAUP(ew,ns,bt,ist), QG_COLD(ew,ns,bt,ist),  &
                    QG_WARM(ew,ns,bt,ist), NG_COLD(ew,ns,bt,ist), NG_WARM(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist) ) 
                         
          call read_wrf4d_output('RRB',3 , RRB)
          call read_wrf4d_output('W', 1 , W)
          call read_wrf4d_output('HEIGHT',6 , HEIGHT)
          call read_wrf4d_output('TEMP',4 , TEMP)
          call read_wrf4d_output('NI',2,NI)
          call read_wrf4d_output('NSNOW',5,NSNOW)
          call read_wrf4d_output('NGRAUP',6,NGRAUP)
          call read_wrf4d_output('QSNOW',5 , QSNOW)
          call read_wrf4d_output('QICE',4 , QICE)
          call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
          call read_wrf4d_output('QGRAUP',6 ,QGRAUP)
          call read_wrf4d_output('QG_COLD',7 , QG_COLD)
          call read_wrf4d_output('QG_WARM',7 , QG_WARM)
          call read_wrf4d_output('NG_COLD',7 , NG_COLD)
          call read_wrf4d_output('NG_WARM',7 , NG_WARM)


          !do tt = 1,n_temp_bin,bin_temp
          !	temp_ord(tt) =  -1.*real(tt)
          !	print*,'temp_ord(tt)',temp_ord(tt)
          !enddo

          temp_ord(1:n_bin_tt)  = (/ 20.,16.,12.,      &
                           8.,4.,0.,         &
                          -4.,-8.,-12.,      &
                          -16.,-20.,-24.,    &
                          -28.,-32.,-36.,-40.,-44.,-48.,-52.,-56.,-60.,-64. /)
          do tt = 1, n_bin_tt
          print*,'temp_ord(tt)',temp_ord(tt)
          enddo


          !
          !=======================================================================
          !			Temperature Dependency
          !		Output Data written in NI200um_T_percm3
          !=======================================================================
          !
          do tt = 1, n_bin_tt-1 !min_temp,bin_temp
                     ik = 0; temp_tt(tt) = 0.; n_ice_av_t(tt)  = 0.; n_snow_av_t(tt) = 0.; n_graup_av_t(tt) =  0.;
                     qg_cold_av_t(tt) = 0.; qg_warm_av_t(tt) = 0.; ng_cold_av_t(tt) = 0.; ng_warm_av_t(tt) = 0.;
                     q_graup_av_t(tt) = 0.;
                              do k=1,bt
                                        do is=1,ist
                                                  do i=1,ew
                                                            do j=1,ns
                                                                      tot_cld(i,j,k,is) = rrb(i,j,k,is)*(QCLOUD(i,j,k,is)+QICE(i,j,k,is))
                                                                      if((TEMP(i,j,k,is) < temp_ord(tt)) .and. (TEMP(i,j,k,is) > temp_ord(tt+1))) then
                                                                                if(tot_cld(i,j,k,is) > 1.e-6 .and. (W(i,j,k,is)) > 1. ) then
                                                                                       
                                                                                          n_ice_av_t(tt)  = n_ice_av_t(tt)+ rrb(i,j,k,is)*(NI(i,j,k,is))
                                                                                          n_snow_av_t(tt) = n_snow_av_t(tt)+ rrb(i,j,k,is)*(NSNOW(i,j,k,is))
                                                                                          n_graup_av_t(tt) = n_graup_av_t(tt)+ rrb(i,j,k,is)*(NGRAUP(i,j,k,is))
                                                                                          
                                                                                          q_graup_av_t(tt)  = q_graup_av_t(tt) + rrb(i,j,k,is)*(QGRAUP(i,j,k,is))
                                                                                           
                                                                                          qg_cold_av_t(tt) = qg_cold_av_t(tt) + rrb(i,j,k,is)*QG_COLD(i,j,k,is)
                                                                                          qg_warm_av_t(tt) = qg_warm_av_t(tt) + rrb(i,j,k,is)*QG_WARM(i,j,k,is)
                                                                                          ng_cold_av_t(tt) = ng_cold_av_t(tt) + rrb(i,j,k,is)*NG_COLD(i,j,k,is)
                                                                                          ng_warm_av_t(tt) = ng_warm_av_t(tt) + rrb(i,j,k,is)*NG_WARM(i,j,k,is)
                                                                                          
                                                                                          temp_tt(tt)  = temp_tt(tt)  + TEMP(i,j,k,is)
                                                                                          ik = ik + 1
                                                                                endif
                                                                      endif
                                                            enddo
                                                  enddo
                                        enddo
                              enddo

                              if(ik > 0) then
                                           n_ice_av_t(tt)  = n_ice_av_t(tt)/real(ik);
                                           n_snow_av_t(tt) = n_snow_av_t(tt)/real(ik);
                                          n_graup_av_t(tt) = n_graup_av_t(tt)/real(ik); 
                                          q_graup_av_t(tt) = q_graup_av_t(tt)/real(ik);
                                          qg_cold_av_t(tt) = qg_cold_av_t(tt)/real(ik);
                                          qg_warm_av_t(tt) = qg_warm_av_t(tt)/real(ik);
                                          ng_cold_av_t(tt) = ng_cold_av_t(tt)/real(ik);
                                          ng_warm_av_t(tt) = ng_warm_av_t(tt)/real(ik);
                              else
                                           n_ice_av_t(tt)  = -999.;
                                           n_snow_av_t(tt) = -999.;
                                          n_graup_av_t(tt) = -999.; 
                                          n_graup_av_t(tt) = -999.;
                                          q_graup_av_t(tt) = -999.; 
                                          qg_cold_av_t(tt) = -999.; 
                                          qg_warm_av_t(tt) = -999.;
                                          ng_cold_av_t(tt) = -999.; 
                                          ng_warm_av_t(tt) = -999.;
                              endif
          enddo

          !stop 97867

          open(2,file='Q_N_TOT_GRAUP_gperkg_percm3',form="formatted", access="sequential",status="unknown")
                    do tt = 1, n_bin_tt-1 !min_temp,bin_temp	
                              write(2,*) n_graup_av_t(tt)/1.e6, q_graup_av_t(tt)*1.e3, temp_ord(tt) - bin_temp*0.5 ! percm3
                              write(*,*) n_graup_av_t(tt)/1.e6, q_graup_av_t(tt)*1.e3, temp_ord(tt) - bin_temp*0.5 ! percm3
                    enddo
          close(2)

          open(2,file='Q_COLD_WARM_GRAUP_gperkg',form="formatted", access="sequential",status="unknown")
          open(3,file='N_COLD_WARM_GRAUP_percm3',form="formatted", access="sequential",status="unknown")
                    do tt = 1, n_bin_tt-1 !min_temp,bin_temp	
                              write(2,*) qg_cold_av_t(tt)*1.e3,qg_warm_av_t(tt)*1.e3 ! kgperkg to gperkg
                              write(3,*) ng_cold_av_t(tt)/1.e6,ng_warm_av_t(tt)/1.e6 ! perm3 to percm3	   
                    enddo
          close(2)
          close(3)

          stop
          100            FORMAT (A)
          101            FORMAT (A5,I,A)
          102            FORMAT(F10.4,2X,F8.4)


          CONTAINS
          SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2011-05-10_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

          end subroutine read_wrf4d_output

          SUBROUTINE POLAT(XV, PV, X, P, plev)

          ! INTERPOLATES XV TO PRESSURE P.

          implicit none

          integer, intent(in) :: plev

          real, intent(in) ::&
          p       !
          real, dimension(plev), intent(in) ::&
          XV,    &! DATA AT RESOLUTION N 
          PV      ! PRESSURE AT N LEVELS
          real, intent(out) ::&
          X       ! DATA AT PRESSURE P

          ! Local variables:

          integer ::&
          i, Ne, NM1
          !---------------------------------------------------------------------

          Ne=plev
          NM1=Ne-1

          IF (P .LE. PV(1)) THEN
	          !       WRITE(6,2) P
	          X=(XV(2)-XV(1))/(PV(2)-PV(1))
          X=X*(P-PV(1))+XV(1)
	          GO TO 1
          ENDIF
          IF (P .GE. PV(ne)) THEN
	          !       WRITE(6,2) P
	          X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
	          X=X*(P-PV(ne))+XV(ne)
	          GO TO 1
          ENDIF
          do 10 I=1,NM1

          IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
	          !       WRITE(6,2) P
	          !2     FORMAT(2X,'POLATE P=',E4032.5)
	          !       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
	          X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
	          X=X*(P-PV(I+1))+XV(I+1)
	          GO TO 1
          ENDIF

          10    CONTINUE
          1     CONTINUE

          END subroutine polat


          subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
          end subroutine check



          end
