
  
        program hist

	use netcdf

        implicit none

        integer                :: i,j, t, lifetime,   ist, bt, ew, ns,tt,n_temp_bin, nt, is_start, is_end
	parameter(bt=40, ew=40, ns=40, nt = 16 )
 	real, dimension(bt)  :: model_z, ni_ave_int, obs_z
 	integer, allocatable :: iav(:,:)
        integer 	           :: i_ens, nrec, k, is, ik,grid,cloud,ntest,bin_temp,min_temp
        real 		 :: ni_grid_tot, ni_grid_av(80), ni_grid,temp_ord(16),ni_av_t(16)

        real, allocatable      :: nw(:,:,:,:), NI1000UM(:,:,:,:), tau_vis(:,:,:,:), ni_av(:),rho(:,:),  &
                                  RRB(:,:,:,:), QCLOUD(:,:,:,:), w(:,:,:,:), HEIGHT(:,:,:,:), &
			    QICE(:,:,:,:), tot_cld(:,:,:,:),TEMP(:,:,:,:),ni_av_tt(:),temp_tt(:), &
			    NSNOW1000UM(:,:,:,:),NGRAUP1000UM(:,:,:,:),NRAIN1000UM(:,:,:,:)
  	CHARACTER *2   char_smooth
    	CHARACTER *3   char_nUM, char_buf3
    	CHARACTER *6   char_buf
    	CHARACTER *7   char_buf7
    	CHARACTER *5   char_buf5
    	CHARACTER *7   char_buf2
    	CHARACTER *19  char_in19
    	CHARACTER *60  char_in
    	character *50  var_name
    	CHARACTER *100 char_in_big

        INTRINSIC 	         :: TRIM, REAL, ABS

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)
	
	open(10,file='is_start_end',status="unknown")
	read(10,*) is_start,is_end
	close (10)
	
	!bin_temp = 3.
	!min_temp = -19 
	!min_temp = min_temp * -1
	n_temp_bin = 30
	bin_temp = 1.
	min_temp = 30. !-20 

!
!==========================================================================================
!		Ice NUMber Concentration(#/cm^3) of diameter > 1000. UM for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!

        allocate(nw(ew,ns,bt,ist), NI1000UM(ew,ns,bt,ist), tau_vis(ew,ns,bt,ist), ni_av(bt),rho(bt,ist),  &
                    RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), w(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist),      &
		QICE(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist),TEMP(ew,ns,bt,ist),ni_av_tt(ist),temp_tt(ist), &
		NSNOW1000UM(ew,ns,bt,ist),NGRAUP1000UM(ew,ns,bt,ist),NRAIN1000UM(ew,ns,bt,ist))

        call read_wrf4d_output('NI1000UM',8,NI1000UM)
        call read_wrf4d_output('NSNOW1000UM',11,NSNOW1000UM)
        call read_wrf4d_output('NGRAUP1000UM',12,NGRAUP1000UM)
        call read_wrf4d_output('NRAIN1000UM',11,NRAIN1000UM)
        call read_wrf4d_output('TAU_VIS',7 ,TAU_VIS)
        call read_wrf4d_output('RRB',3 , RRB)
!        call read_wrf4d_output('NW',2 , nw)
        call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
        call read_wrf4d_output('QICE', 4 , QICE)
        call read_wrf4d_output('W', 1 , W)
        call read_wrf4d_output('HEIGHT',6 , HEIGHT)
        call read_wrf4d_output('TEMP',4 , TEMP)

	
	do k=1,bt
		obs_z(k) = 0.25+REAL(k-1)*0.35  ! MARCO FORMENTON 0.35 12/21/2012 FOR STEPS because the atmosphere is more shallow.
		model_z(k) = sUM(HEIGHT(2:ew-1,2:ns-1,k,2:ist-2))/real((ist-3)*(ew-2)*(ns-2)*1000.)
	enddo

	obs_z = obs_z + 0.350			! Deepak 25/06/2020 the ground level is at 0.315 mt for MC3E

        do k = 1, bt
                do is = 1, ist
                        rho(k, is) = sUM(RRB(:,:,k,is))/real(ew*ns)
                end do
        end do
	
	!do tt = 1,n_temp_bin,bin_temp
	!	temp_ord(tt) =  -1.*real(tt)
	!	print*,'temp_ord(tt)',temp_ord(tt)
	!enddo

temp_ord(1:nt)  = (/ 20.,16.,12.,   &
                     8.,4.,0.,      &
                    -4.,-8.,-12.,   &
                    -16.,-20.,-24., &
                    -28.,-32.,-36., &
                    -40. /)
 do tt = 1,nt
 print*,'temp_ord(tt)',temp_ord(tt)
 enddo
 
!
!=======================================================================
!			Altitude Dependency
!		Output Data written in NI1000UM_I_percm3
!=======================================================================
!
if (2==3) then
	DO k=1,bt
	     ni_av(k) = 0.
	     ik = 0
	       do is=1,ist
	         do i=1,ew
	           do j=1,ns
	             tot_cld(i,j,k,is) = (QCLOUD(i,j,k,is) + QICE(i,j,k,is)) * RRB(i,j,k,is)	!From kg/kg to kg/m3
	                  if(NI1000UM(i,j,k,is) > 1. .AND. tot_cld(i,j,k,is) > 1.e-6 .and. (W(i,j,k,is)) > 2.) then 
	                   ni_av(k) = ni_av(k) + (NI1000UM(i,j,k,is)+NSNOW1000UM(i,j,k,is)+NGRAUP1000UM(i,j,k,is)+NRAIN1000UM(i,j,k,is))*rrb(i,j,k,is)
	                   ik = ik + 1
	                  endif
	           enddo
	         enddo
	       enddo

	    if(ik > 0) then
              ni_av(k) = ni_av(k)/REAL(ik)
	    else
	      ni_av(k) = 0.
	    endif
		!print*,ni_av(k)/1.e6, ik
	ENDDO

	open(1,file='NI1000UM_I_percm3',form="formatted", access="sequential",status="unknown")

	do k=1,bt
         call POLAT(ni_av, model_z, ni_ave_int(k), obs_z(k), bt)
	    write(1,*) ni_ave_int(k)/1.e6, obs_z(k)
            write(*,102) ni_ave_int(k)/1.e6, obs_z(k) - 0.5
	enddo
	close(1)
endif

!
!=======================================================================
!			Temperature Dependency
!		Output Data written in NI1000UM_T_percm3
!=======================================================================
!
          do tt = 1,nt-1 !min_temp,bin_temp
                    ni_av_t(tt) = 0.
                    ik = 0
                              do is=is_start, is_end !1,ist
                                        do i=1,ew
                                                  do j=1,ns
                                                            do k = 1, bt
                                                                      tot_cld(i,j,k,is) = rrb(i,j,k,is)*(QCLOUD(i,j,k,is)+QICE(i,j,k,is))
                                                                      if(TEMP(i,j,k,is) < temp_ord(tt) .and. TEMP(i,j,k,is) > temp_ord(tt+1)) then
                                                                                if(tot_cld(i,j,k,is) > 1.e-6)then
                                                                                          if(W(i,j,k,is) > 2. ) then
                                                                                                    ni_av_t(tt)  = ni_av_t(tt)  + &
                                                                                                                   (NI1000UM(i,j,k,is)+NSNOW1000UM(i,j,k,is)+NGRAUP1000UM(i,j,k,is)+NRAIN1000UM(i,j,k,is))* &
                                                                                                                   rrb(i,j,k,is)
                                                                                                    temp_tt(tt)  = temp_tt(tt)  + TEMP(i,j,k,is)
                                                                                                    ik = ik + 1
                                                                                          endif
                                                                                endif
                                                                      endif
                                                            enddo
                                                  enddo
                                        enddo
                              enddo

                              if(ik > 0) then
                                        ni_av_t(tt)  = ni_av_t(tt)/REAL(ik)
                                        temp_tt(tt)  = temp_tt(tt)/real(ik)
                              else
                                        ni_av_t(tt)  = -999.
                                        temp_tt(tt)  = -999.
                              endif
          enddo

!stop 97867


	open(2,file='N_TOT_ICE1000um_T_percm3',form="formatted", access="sequential",status="unknown")
	DO tt = 1,nt !min_temp,bin_temp	
	   write(2,*) ni_av_t(tt)/1.e6,temp_ord(tt) - bin_temp*0.5
	   write(*,*) ni_av_t(tt)/1.e6,temp_ord(tt) - bin_temp*0.5	   
	enddo
	close(2)

	!DO tt = 1,61 !min_temp,bin_temp	
	!  write(*,*) ni_av_t(tt)/1.e6,temp_tt(tt)
	!enddo

stop
 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2011-05-10_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output

       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check


 
	end
