
  
        program hist

	use netcdf

        implicit none

        integer                :: i,j, k, is, t, ik, lifetime, ist, bt, ew, ns, tt, nt, is_start, is_end
	parameter(ew = 40, ns = 40, bt = 40, nt = 34)!18)
        real                   :: temp_ord(nt), ni200_av_t(nt), ni_tot_av_t(nt),bin_temp

        real, allocatable      :: nw(:,:,:,:), NI200um(:,:,:,:), NSNOW200um(:,:,:,:), NGRAUP200um(:,:,:,:),        &
                                  NI(:,:,:,:), NSNOW(:,:,:,:), NGRAUP(:,:,:,:), tau_vis(:,:,:,:), ni_av(:),        &
                                  rho(:,:), RRB(:,:,:,:), QCLOUD(:,:,:,:), w(:,:,:,:), HEIGHT(:,:,:,:),            &
			    QICE(:,:,:,:), tot_cld(:,:,:,:), TEMP(:,:,:,:), temp_tt(:)

        INTRINSIC 	         :: TRIM, REAL, ABS
        
	bin_temp = 1.

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)
 
!
!==========================================================================================
!		Ice Number Concentration(#/cm^3) of diameter > 200. um for MC3E
!				with Altitude and Temperature(DegC)
!==========================================================================================
!

        allocate(nw(ew,ns,bt,ist), NI200um(ew,ns,bt,ist), NSNOW200um(ew,ns,bt,ist), NGRAUP200um(ew,ns,bt,ist),   &
                 NI(ew,ns,bt,ist), NSNOW(ew,ns,bt,ist), NGRAUP(ew,ns,bt,ist), tau_vis(ew,ns,bt,ist), ni_av(bt),  &
                 rho(bt,ist), RRB(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist), w(ew,ns,bt,ist), HEIGHT(ew,ns,bt,ist),    &
                 QICE(ew,ns,bt,ist), tot_cld(ew,ns,bt,ist),TEMP(ew,ns,bt,ist), temp_tt(nt))

        call read_wrf4d_output('NI200UM',7,NI200UM) 
        call read_wrf4d_output('NSNOW200UM',10,NSNOW200UM)
        call read_wrf4d_output('NGRAUP200UM',11,NGRAUP200UM) 
        call read_wrf4d_output('NI',2,NI) 
        call read_wrf4d_output('NSNOW',5,NSNOW)
        call read_wrf4d_output('NGRAUP',6,NGRAUP)
        call read_wrf4d_output('TAU_VIS',7 ,TAU_VIS)
        call read_wrf4d_output('RRB',3 , RRB)
!        call read_wrf4d_output('NW',2 , nw)
        call read_wrf4d_output('QCLOUD', 6 , QCLOUD)
        call read_wrf4d_output('QICE', 4 , QICE)
        call read_wrf4d_output('W', 1 , W)
        call read_wrf4d_output('HEIGHT',6 , HEIGHT)
        call read_wrf4d_output('TEMP',4 , TEMP)


!temp_ord(1:nt)  = (/ 20.,16.,12.,      &
!                     8.,4.,0.,         &
!                    -4.,-8.,-12.,      &
!                    -16.,-20.,-24.,    &
!                    -28.,-32.,-36.,-40., -44., -48. /)


temp_ord(1:nt)  = (/ 20., 18., 16., 14., 12., &
                     10., 8., 6., 4., 2.,     &
                     0., -2., -4., -6., -8.,  &
                    -10., -12., -14., -16., -18., &
                    -20., -22., -24., -26., -28., &
                    -30., -32., -34., -36., -38., &
                    -40., -42., -44., -48. /)
                    
 do tt = 1,nt
 print*,'temp_ord(tt)',temp_ord(tt)
 enddo

 is_start = 144;             ! equivalent to 131.625 == 11 May 15 UTC --- to match the simulation time to flight time
 is_end   = 288;             ! equivalent to 132.875 == 11 May 21 UTC --- to match the simulation time to flight time 
!
!=======================================================================
!			Temperature Dependency
!		Output Data written in NI200um_T_percm3
!=======================================================================
!
          do tt = 1,nt-1 !min_temp,bin_temp
          ni200_av_t(tt) = 0.; ni_tot_av_t(tt)  = 0.; ik = 0;
                    do k=1,bt
                              do is=is_start, is_end !1,ist
                                        do i=1,ew
                                                  do j=1,ns
                                                            tot_cld(i,j,k,is) = rrb(i,j,k,is)*(QCLOUD(i,j,k,is)+QICE(i,j,k,is))
                                                            if((TEMP(i,j,k,is) .lt. temp_ord(tt)) .and. (TEMP(i,j,k,is) .gt. temp_ord(tt + 1))) then
                                                                      if(tot_cld(i,j,k,is) > 1.e-6)then! .and. NI200um(i,j,k,is) < 30. .or. NSNOW200UM(i,j,k,is) < 30. .or. NGRAUP200UM(i,j,k,is) < 30.)then 
                                                                                !if((W(i,j,k,is)) > 1. .and. (W(i,j,k,is)) < 6.)then
                                                                                if(W(i,j,k,is) > 2.)then
                                                                                          ni200_av_t(tt)  = ni200_av_t(tt)  + rrb(i,j,k,is)*(NI200UM(i,j,k,is)+NSNOW200UM(i,j,k,is)+NGRAUP200UM(i,j,k,is))
                                                                                         ni_tot_av_t(tt)  = ni_tot_av_t(tt) + rrb(i,j,k,is)*(NI(i,j,k,is)+NSNOW(i,j,k,is)+NGRAUP(i,j,k,is))
                                                                                          temp_tt(tt)  = temp_tt(tt)  + TEMP(i,j,k,is)
                                                                                          ik = ik + 1
                                                                                endif
                                                                      endif
                                                            endif
                                                  enddo
                                        enddo
                              enddo
                    enddo

                    if(ik > 0) then
                              ni200_av_t(tt) = ni200_av_t(tt)/REAL(ik)
                             ni_tot_av_t(tt) = ni_tot_av_t(tt)/REAL(ik)
                              temp_tt(tt)    = temp_tt(tt)/real(ik)
                    else
                              ni200_av_t(tt) = -999.
                             ni_tot_av_t(tt) = -999.
                              temp_tt(tt)    = -999.
                    endif
          enddo

!stop 97867


          open(2,file='N_ICE_200um_T_percm3',form="formatted", access="sequential",status="unknown")
          do tt = 1,nt-1 !min_temp,bin_temp	
                    write(2,*) ni200_av_t(tt)/1.e6,temp_ord(tt) - bin_temp*0.5
                    write(*,*) ni200_av_t(tt)/1.e6,temp_ord(tt) - bin_temp*0.5	   
          enddo
          close(2)

          open(2,file='N_ICE_TOT_T_percm3',form="formatted", access="sequential",status="unknown")
          do tt = 1,nt-1 !min_temp,bin_temp	
                    write(2,*) ni_tot_av_t(tt)/1.e6,temp_ord(tt) - bin_temp*0.5
                    write(*,*) ni_tot_av_t(tt)/1.e6,temp_ord(tt) - bin_temp*0.5	   
          enddo
          close(2)
	!DO tt = 1,61 !min_temp,bin_temp	
	!  write(*,*) ni200_av_t(tt)/1.e6,temp_tt(tt)
	!enddo

if(0==1)then	
          do tt = 1,nt-1 !min_temp,bin_temp
          ni200_av_t(tt) = 0.; ik = 0;
                    do k=1,bt
                              do is=is_start, is_end !1,ist
                                        do i=1,ew
                                                  do j=1,ns
                                                            tot_cld(i,j,k,is) = rrb(i,j,k,is)*(QCLOUD(i,j,k,is)+QICE(i,j,k,is))
                                                            if((TEMP(i,j,k,is) .lt. temp_ord(tt)) .and. (TEMP(i,j,k,is) .gt. temp_ord(tt + 1))) then
                                                                      if(tot_cld(i,j,k,is) > 1.e-6)then! .and. NI200um(i,j,k,is) > 10. .or. NSNOW200UM(i,j,k,is) > 10. .or. NGRAUP200UM(i,j,k,is) > 10.)then 
                                                                                !if((W(i,j,k,is)) > 1. .and. (W(i,j,k,is)) < 6.)then
                                                                                if(W(i,j,k,is) > 2.)then
                                                                                          ni200_av_t(tt)  = ni200_av_t(tt)  + rrb(i,j,k,is)*(NI200UM(i,j,k,is))!+NSNOW200UM(i,j,k,is)+NGRAUP200UM(i,j,k,is))
                                                                                          temp_tt(tt)  = temp_tt(tt)  + TEMP(i,j,k,is)
                                                                                          ik = ik + 1
                                                                                endif
                                                                      endif
                                                            endif
                                                  enddo
                                        enddo
                              enddo
                    enddo

                    if(ik > 0) then
                              ni200_av_t(tt) = ni200_av_t(tt)/REAL(ik)
                              temp_tt(tt)    = temp_tt(tt)/real(ik)
                    else
                              ni200_av_t(tt) = -999.
                              temp_tt(tt)    = -999.
                    endif
          enddo
          
          open(2,file='N_ICE_CRYSTAL_200um_T_percm3',form="formatted", access="sequential",status="unknown")
          do tt = 1,nt-1 !min_temp,bin_temp	
                    write(2,*) ni200_av_t(tt)/1.e6,temp_ord(tt) - bin_temp*0.5
                    write(*,*) ni200_av_t(tt)/1.e6,temp_ord(tt) - bin_temp*0.5	   
          enddo
          close(2)
endif
stop
 100            FORMAT (A)
 101            FORMAT (A5,I,A)
 102            FORMAT(F10.4,2X,F8.4)


        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)

                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2011-05-10_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check
        
       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat




 
	end
