        program hist
        use netcdf
        
	implicit none
	
	integer               ::  i, j, t, lifetime, ist, bt, ew, ns, ist_part, is_start, is_end
	parameter(bt = 40, ew = 40, ns = 40)
 	real, dimension(bt)   ::  model_z, dbz_ave_int, obs_z
 	integer, allocatable  ::  iav(:,:)
	integer               ::  i_ens, nrec, k, is, ik, grid, cloud, ntest, ijk
	real                  ::  ni_grid_tot, ni_grid_av(80), ni_grid, raw_Z(80*40*100) 
	real, allocatable     ::  ni(:,:,:,:), tau_vis(:,:,:,:), dbz_av(:), w(:,:,:,:), QICE(:,:,:,:), 	 &
			      RRB(:,:,:,:), rho(:,:), HEIGHT(:,:,:,:), ZREFL(:,:,:,:), tot_cld(:,:,:,:), &
			      QCLOUD(:,:,:,:)
				     
   	CHARACTER *2   char_smooth
    	CHARACTER *3   char_num, char_buf3 
   	CHARACTER *6   char_buf
    	CHARACTER *7   char_buf7
    	CHARACTER *5   char_buf5
    	CHARACTER *7   char_buf2
    	CHARACTER *19  char_in19
    	CHARACTER *60  char_in
    	character *50  var_name
    	CHARACTER *100 char_in_big
    	
	INTRINSIC :: TRIM, REAL, ABS, sum

	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)
	
	open(10,file='is_start_end',status="unknown")
	read(10,*) is_start,is_end
	close (10)

!
!==========================================================================================
!			CLOUD-WATER MIXING RATIO
!==========================================================================================
!

	allocate(ni(ew,ns,bt,ist), tau_vis(ew,ns,bt,ist), dbz_av(bt), W(ew,ns,bt,ist),QICE(ew,ns,bt,ist), QCLOUD(ew,ns,bt,ist),	&
			RRB(ew,ns,bt,ist), rho(bt,ist), HEIGHT(ew,ns,bt,ist),ZREFL(ew,ns,bt,ist),tot_cld(ew,ns,bt,ist))
		



  	  	call read_wrf4d_output('RRB',3 , RRB)
  	  	call read_wrf4d_output('ZREFL', 5 , ZREFL)
		call read_wrf4d_output('HEIGHT',6 , HEIGHT)
		call read_wrf4d_output('W',1 , W)
  	  	call read_wrf4d_output('QICE', 4 , QICE)
		call read_wrf4d_output('QCLOUD',6 , QCLOUD)

	do k=1,40
		obs_z(k) = 0.25+REAL(k-1)*0.35		! MARCO FORMENTON 0.35 12/21/2012 FOR STEPS because the atmosphere is more shallow.
		model_z(k) = sum(HEIGHT(2:ew-1,2:ns-1,k,2:ist-2))/real((ist-3)*(ew-2)*(ns-2)*1000.)
	enddo

	obs_z = obs_z + 0.315		! Deepak 01/09/2020 the ground level is at 0.315 mt for mc3e!!!

	do k = 1, bt
		do is = 1, ist
			rho(k, is) = sum(RRB(:,:,k,is))/real(ew*ns)
		end do
	end do

	ijk = 1
	do k=1,bt
		dbz_av(k) = 0.;
		 ik = 0;
		do is=is_start, is_end !1,ist    
			do i=1,ew
				do j=1,ns
				          tot_cld(i,j,k,is) = RRB(i,j,k,is)*(QCLOUD(i,j,k,is)+QICE(i,j,k,is))
					if(ZREFL(i,j,k,is) > -20.)then! .and. ZREFL(i,j,k,is) < 40. .and. tot_cld(i,j,k,is) > 1.E-06 ) then 
						dbz_av(k) = dbz_av(k) + ZREFL(i,j,k,is)  
						ik = ik + 1
							
					endif
				enddo
			enddo
		enddo
		if(ik > 0)then
			dbz_av(k) = (dbz_av(k)/REAL(ik))
		else
			dbz_av(k) = 0.
		endif
		
	enddo
	!if(ijk == 1) stop 911

	print*,'points total number =',ik

	!open(1,file='Refl_raw',form="formatted", access="sequential",status="unknown")
	do i = 1, ijk-1
		!print *, raw_Z(i)
		!write(1,*)raw_Z(i) 
	enddo
	!close(1)

	open(1,file='Refl_average_mc3e',form="formatted", access="sequential",status="unknown")

	do k=1,bt
         	call POLAT(dbz_av, model_z, dbz_ave_int(k), obs_z(k), bt)
		!if (k> 0 .and. dbz_ave_int(k) .ne. 0.) 
		write(1,102) dbz_ave_int(k), obs_z(k)
		!if (k> 0 .and. dbz_ave_int(k) .ne. 0.) write(*,102) dbz_ave_int(k), obs_z(k)
	enddo
	close(1)


	stop 10900
	
 100    	FORMAT (A)
 101		FORMAT (A5,I,A)
 102		FORMAT(F10.4,2X,F8.4)

	CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)
                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2011-05-10_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat


  	subroutine check(status)
    		integer, intent ( in) :: status
    
    		if(status /= nf90_noerr) then 
      			print *, trim(nf90_strerror(status))
      			stop "Stopped"
    		end if
  	end subroutine check
	end
