
  
        program hist
	use netcdf
	implicit none
        integer                :: i, j, t, lifetime,   ist, bt, ew, ns
	parameter (bt = 40, ew= 40, ns=40)
	real, dimension(bt)  :: model_z,vert_cld_frac_int,obs_z
	real                 :: h,time_dummy(25), toa_net_sw, toa_net_lw
	integer              :: i_ens, nrec, k, is, ik_cld, ik, it, jk
	real, allocatable    :: FLW(:,:,:,:), FLWUP(:,:,:,:), FSW(:,:,:,:),   FSWDN(:,:,:,:),  &
		              RRB(:,:,:,:),   HEIGHT(:,:,:,:), time(:), toa_sw_net_av(:), toa_lw_net_av(:), &
		              toa_lw_up_av(:), toa_lw_dn_av(:), toa_sw_dn_av(:), toa_sw_up_av(:), toa_net_sw_avg(:), &
		              toa_net_lw_avg(:), surf_sw_net_av(:), surf_lw_net_av(:), &
		              surf_lw_up_av(:), surf_lw_dn_av(:), surf_sw_dn_av(:), surf_sw_up_av(:), surf_net_sw_avg(:), &
		              surf_net_lw_avg(:), TAU_VIS(:,:,:,:), toa_opt_depth_av(:), surf_opt_depth_av(:)

	INTRINSIC :: TRIM, REAL, ABS
	
	open(10,file='ist',status="unknown")
	read(10,*) ist
	close (10)


!
!==========================================================================================
!			TOA_LONGWAVE, SHORTWAVE Radiation
!==========================================================================================
!

	allocate(FLW(ew,ns,bt,ist), FLWUP(ew,ns,bt,ist),FSW(ew,ns,bt,ist), FSWDN(ew,ns,bt,ist), toa_sw_net_av(ist), &
		RRB(ew,ns,bt, ist), HEIGHT(ew,ns,bt,ist), time(ist), toa_lw_net_av(ist), toa_lw_up_av(ist),       &
		toa_lw_dn_av(ist), toa_sw_dn_av(ist), toa_sw_up_av(ist), toa_net_sw_avg(ist), toa_net_lw_avg(ist),&
		surf_sw_net_av(ist), surf_lw_net_av(ist), surf_lw_up_av(ist), surf_lw_dn_av(ist),                 &
		surf_sw_dn_av(ist), surf_sw_up_av(ist), surf_net_sw_avg(ist), surf_net_lw_avg(ist),               &
		TAU_VIS(ew,ns,bt,ist), toa_opt_depth_av(ist), surf_opt_depth_av(ist))	

        	call read_wrf4d_output('FLW',3 , FLW)             ! NET Longwave radiative flux (Upward positive) 
        	call read_wrf4d_output('FLWUP',5 , FLWUP)         ! Upward component of Longwave radiative flux
        	call read_wrf4d_output('FSWDN',5 , FSWDN)         ! Downward component of Shortwave radiative flux         	
        	call read_wrf4d_output('RRB',3 , RRB)
        	call read_wrf4d_output('HEIGHT',6 , HEIGHT)
        	call read_wrf4d_output('TAU_VIS',7 , TAU_VIS)
        	call read_wrf4d_output('FSW',3 , FSW)             ! NET Shortwave radiative flux (Upward positive)

!============================================================!
!====== Creating dummy array of julian time(3hrly) as,=======!
!================ observation is on 3hr =====================!
!============================================================!
	
time_dummy = (/130.00,130.125,130.250,130.375,130.500,130.625,130.750,130.875, &
               131.00,131.125,131.250,131.375,131.500,131.625,131.750,131.875, &
               132.00,132.125,132.250,132.375,132.500,132.625,132.750,132.875, &
               133.00/)


!!================ TOA radiative fluxes =================!!
	do is=1,ist
	    toa_sw_net_av(is) = 0.; toa_lw_net_av(is) = 0.; toa_lw_up_av(is) = 0.; toa_sw_dn_av(is) = 0.; 
	    toa_opt_depth_av(is) = 0.; ik=0;
		do i=1,ew
			do j = 1,ns
                                        do k = bt,bt        ! top of the atmosphere
                                                  toa_sw_net_av(is)     = toa_sw_net_av(is) + FSW(i,j,k,is)
                                                  toa_lw_net_av(is)     = toa_lw_net_av(is) + FLW(i,j,k,is)  
                                                   toa_lw_up_av(is)     = toa_lw_up_av(is) + FLWUP(i,j,k,is)
                                                   toa_sw_dn_av(is)     = toa_sw_dn_av(is) + FSWDN(i,j,k,is) 
                                                   toa_opt_depth_av(is) = toa_opt_depth_av(is) + TAU_VIS(i,j,k,is)
                                                  ik = ik+1 
                                        enddo
			enddo
		enddo
	      if(ik > 0) then
                    toa_sw_net_av(is)    = toa_sw_net_av(is)/real(ik) 
                    toa_lw_net_av(is)    = toa_lw_net_av(is)/real(ik) 
                    toa_lw_up_av(is)     = toa_lw_up_av(is)/real(ik)
                    toa_sw_dn_av(is)     = toa_sw_dn_av(is)/real(ik)
                    toa_opt_depth_av(is) = toa_opt_depth_av(is)/real(ik) 
	      else
                    toa_sw_net_av(is)    = 0. 
                    toa_lw_net_av(is)    = 0.
                    toa_lw_up_av(is)     = 0.
                    toa_sw_dn_av(is)     = 0. 
                    toa_opt_depth_av(is) = -999.
	      endif
	enddo

!!================ Surface radiative fluxes =================!!	
	do is=1,ist
	    surf_sw_net_av(is) = 0.; surf_lw_net_av(is) = 0.; surf_lw_up_av(is) = 0.; surf_sw_dn_av(is) = 0.; ik=0;
		do i=1,ew
			do j = 1,ns
                                        do k = 1,1        ! surface of the atmosphere
                                                  surf_sw_net_av(is) = surf_sw_net_av(is) + FSW(i,j,k,is)
                                                  surf_lw_net_av(is) = surf_lw_net_av(is) + FLW(i,j,k,is)  
                                                   surf_lw_up_av(is) = surf_lw_up_av(is) + FLWUP(i,j,k,is)
                                                   surf_sw_dn_av(is) = surf_sw_dn_av(is) + FSWDN(i,j,k,is) 
                                                   surf_opt_depth_av(is) = surf_opt_depth_av(is) + TAU_VIS(i,j,k,is)
                                                  ik = ik+1 
                                        enddo
			enddo
		enddo
	      if(ik > 0) then
                    surf_sw_net_av(is) = surf_sw_net_av(is)/real(ik) 
                    surf_lw_net_av(is) = surf_lw_net_av(is)/real(ik) 
                    surf_lw_up_av(is)  = surf_lw_up_av(is)/real(ik)
                    surf_sw_dn_av(is)  = surf_sw_dn_av(is)/real(ik) 
                    surf_opt_depth_av(is) = surf_opt_depth_av(is)/real(ik)
	      else
                    surf_sw_net_av(is) = 0. 
                    surf_lw_net_av(is) = 0.
                    surf_lw_up_av(is)  = 0.
                    surf_sw_dn_av(is)  = 0. 
                    surf_opt_depth_av(is) = -999.
	      endif
	enddo

!================== SWnet = SWdn - SWup
!================== LWnet = LWdn - LWup
!================== Qnet  = SWnet + LWnet         ! Net radiation balance
          !!================= TOA radiative fluxes
          ik = 0.; jk = 0.;
          do is = 1, ist
                    toa_sw_up_av(is) = toa_sw_dn_av(is)-toa_sw_net_av(is)
                    toa_lw_dn_av(is) = toa_lw_net_av(is)+toa_lw_up_av(is)
                    if(toa_sw_net_av(is) /= 0.)then
                              toa_net_sw_avg(ik) = toa_sw_net_av(is)
                              ik = ik + 1;
                    endif
                    if(toa_lw_net_av(is) /= 0.)then
                              toa_net_lw_avg(jk) = toa_lw_net_av(is)
                              jk = jk + 1;
                    endif
          enddo
          !!================= SURFACE radiative fluxes
          ik = 0.; jk = 0.;
          do is = 1, ist
                    surf_sw_up_av(is) = surf_sw_dn_av(is)-surf_sw_net_av(is)
                    surf_lw_dn_av(is) = surf_lw_net_av(is)+surf_lw_up_av(is)
                    if(surf_sw_net_av(is) /= 0.)then
                              surf_net_sw_avg(ik) = surf_sw_net_av(is)
                              ik = ik + 1;
                    endif
                    if(surf_lw_net_av(is) /= 0.)then
                              surf_net_lw_avg(jk) = surf_lw_net_av(is)
                              jk = jk + 1;
                    endif
          enddo

   open(1,file='toa_sw_lw_acm',form="formatted", access="sequential",status="unknown")
      do is = 1, ist
          do j = 1, 25
                time(is) = (real(is)*2./(24*60)) + 130.   ! real(is)*1/(24*60) converts 'is' into day fraction, 1 denotes the history_interval in minutes, &
                                                          ! 130 is theJulian day factor for 10th May
                if ( time(is) .le. 130.00694 ) then       ! Selecting 00 UTC (130.00) data 
                    time(is) = 130
                endif         
                if ( time(is) .eq. time_dummy(j) ) then
                    write(1,*)  time(is),toa_sw_net_av(is),toa_lw_net_av(is)
	          write(*,*)  time(is),toa_sw_net_av(is),toa_lw_net_av(is),toa_opt_depth_av(is)
	          !write(1,*)  time(is),toa_sw_dn_av(is),toa_lw_up_av(is)
	          !write(*,*)  time(is),toa_sw_dn_av(is),toa_lw_up_av(is)!,toa_lw_dn_av(is),toa_sw_up_av(is)	          
	      endif
	enddo
      enddo
   close(1)

          toa_net_sw = sum(toa_sw_net_av(:))/real(ist)
          toa_net_lw = sum(toa_lw_net_av(:))/real(ist)
          print*,''
          print*,'TOA VISIBLE OPTICAL DEPTH     ::',sum(toa_opt_depth_av(:))/real(ist)

          print*,''
          print*,'TOA SW DOWNWARD COMPONENT     ::',sum(toa_sw_dn_av(:))/real(ist)
          print*,'TOA SW UPWARD COMPONENT       ::',sum(toa_sw_up_av(:))/real(ist)

          print*,''
          print*,'TOA LW DOWNWARD COMPONENT     ::',sum(toa_lw_dn_av(:))/real(ist)
          print*,'TOA LW UPWARD COMPONENT       ::',sum(toa_lw_up_av(:))/real(ist)

          print*,''
          print*,'TOA NET SW (Wm-2)             ::',sum(toa_sw_net_av(:))/real(ist)
          print*,'TOA NET LW (Wm-2)             ::',sum(toa_lw_net_av(:))/real(ist) 

          print*,''
          print*,'TOA NET RADIATIVE FLUX (SWnet - LWnet) ::', (sum(toa_sw_net_av(:))+sum(toa_lw_net_av(:)))/ist

          if(0==0)then
                    print*,''
                    print*,'SURFACE NET SW (Wm-2)         ::',sum(surf_sw_net_av(:))/real(ist)
                    print*,'SURFACE NET LW (Wm-2)         ::',sum(surf_lw_net_av(:))/real(ist)
                    print*,''
                    print*,'SURFACE SW DOWNWARD COMPONENT ::',sum(surf_sw_dn_av(:))/real(ist)
                    print*,'SURFACE SW UPWARD COMPONENT   ::',sum(surf_sw_up_av(:))/real(ist)

                    print*,''
                    print*,'SURFACE LW DOWNWARD COMPONENT ::',sum(surf_lw_dn_av(:))/real(ist)
                    print*,'SURFACE LW UPWARD COMPONENT   ::',sum(surf_lw_up_av(:))/real(ist)

                    print*,'SURFACE VISIBLE OPTICAL DEPTH ::',sum(surf_opt_depth_av(:))/real(ist)
          endif
          
          open(12,file='SW_LW_TOA_SIM_AVG',status='unknown',action='write')
                    write(12,*)toa_net_sw, toa_net_lw
          close(12)
stop 


 100          	FORMAT (A)
 101		FORMAT (A5,I,A)
 102		FORMAT(F10.4,2X,F8.4)

        CONTAINS
        SUBROUTINE read_wrf4d_output(var, nvar, WRFVAR)
                character  (len = *), parameter :: &
                        wrfout_file="wrfout_d01_2011-05-10_00:00:00"
                integer, intent(in) ::  nvar
                character *nvar :: var
                real , Dimension(ew,ns,bt,ist):: WRFVAR
                integer :: wrf_ncid, wrf_varid

                print*, wrfout_file//'_'//var//'.nc'
                ! Open the file. NF90_NOWRITE tells netCDF we want read-only access to
                ! the file.
                call check( nf90_open(wrfout_file//'_'//var//'.nc', NF90_NOWRITE, wrf_ncid) )

                print*, var
                ! Get the varid of the data variable, based on its name.
                call check( nf90_inq_varid(wrf_ncid, var, wrf_varid) )

                ! Read the data.
                print*, "reading::", var
                call check( nf90_get_var(wrf_ncid, wrf_varid, WRFVAR) )

        end subroutine read_wrf4d_output


        
       SUBROUTINE POLAT(XV, PV, X, P, plev)

	! INTERPOLATES XV TO PRESSURE P.

   	implicit none

   	integer, intent(in) :: plev

   	real, intent(in) ::&
     	p       !
   	real, dimension(plev), intent(in) ::&
      	XV,    &! DATA AT RESOLUTION N 
     	PV      ! PRESSURE AT N LEVELS
   	real, intent(out) ::&
      	X       ! DATA AT PRESSURE P

	! Local variables:

   	integer ::&
      	i, Ne, NM1
	!---------------------------------------------------------------------
   
   	Ne=plev
   	NM1=Ne-1

       IF (P .LE. PV(1)) THEN
		!       WRITE(6,2) P
          	X=(XV(2)-XV(1))/(PV(2)-PV(1))
         	X=X*(P-PV(1))+XV(1)
          	GO TO 1
       	ENDIF
      	IF (P .GE. PV(ne)) THEN
		!       WRITE(6,2) P
          	X=(XV(ne)-XV(nm1))/(PV(ne)-PV(nm1))
          	X=X*(P-PV(ne))+XV(ne)
          	GO TO 1
       	ENDIF
       	DO 10 I=1,NM1

       	IF ((P .LE. PV(i+1)) .AND. (P .GE. PV(I))) THEN
		!       WRITE(6,2) P
 		!2     FORMAT(2X,'POLATE P=',E4032.5)
		!       write(6,*) 'i,xv(i),xv(i+1)= ',i,xv(i),xv(i+1)
          	X=(XV(I+1)-XV(I))/(PV(I+1)-PV(I))
          	X=X*(P-PV(I+1))+XV(I+1)
          	GO TO 1
       	ENDIF

 	10    CONTINUE
 	1     CONTINUE

	END subroutine polat



        subroutine check(status)
                integer, intent ( in) :: status

                if(status /= nf90_noerr) then
                        print *, trim(nf90_strerror(status))
                        stop "Stopped"
                end if
        end subroutine check


	end
