program hist
 implicit none
 integer :: i, j, k, FRAGMENT_GG, FRAGMENT_HH, nkr
 real    :: pie
 parameter(pie = 3.1415,FRAGMENT_GG = 1, FRAGMENT_HH = 1, nkr = 33)
 real   :: dn_fg_by_dt,dn_fh_by_dt, coll_kernel_gg(20,20,20), mu_graupel, rho_a,lambda_g, N_0g, turb_fac_gg,dD_graupel(nkr)
 real   :: v_diff, eff_mass, cke_dummy, mass_1, mass_2, n_graup_1, n_graup_2,temp_dummy(1), diam_g_1, diam_g_2, &
	 diam_g_sphere_1, diam_g_sphere_2, dNij_tot,dNij_tot_dummy, dD_graupel_1, dD_graupel_2 ! Deepak 24/05/2021
 

 diam_g_1 = 5.e-4; diam_g_2 = 4.e-3
 diam_g_sphere_1 = 4.980135e-4; diam_g_sphere_2 = 3.947681e-3
 mu_graupel = 1.; rho_a = 1.
 lambda_g = 8695.265; N_0g = 2.8825539E+08
 turb_fac_gg = 1.; coll_kernel_gg(16,6,1) = 7.4042415E-05!1. 
 dD_graupel_1 = 1.0805947E-04; dD_graupel_2 = 8.2019484E-04;
 dn_fg_by_dt = 0.
 dn_fh_by_dt = 0.
 
 v_diff = 1.
 mass_1 = 900.*(4./3.)*PIE*((0.5*diam_g_1)**3.)
 mass_2 = 900.*(4./3.)*PIE*((0.5*diam_g_2)**3.)
 eff_mass = (mass_1*mass_2)/(mass_1+mass_2)
 cke_dummy = (1/2.)*(eff_mass)*(v_diff**2.)
 n_graup_1 = dD_graupel_1*N_0g*((diam_g_1)**mu_graupel)*EXP(-lambda_g*diam_g_1)/rho_a
 n_graup_2 = dD_graupel_2*N_0g*((diam_g_2)**mu_graupel)*EXP(-lambda_g*diam_g_2)/rho_a       
 dNij_tot = coll_kernel_gg(16,6,1) * turb_fac_gg*n_graup_2*n_graup_1*rho_a
 dNij_tot_dummy = dNij_tot
 
 print*,'mass_1,mass_2,v_diff',eff_mass,mass_1,mass_2
 print*,'eff_mass,v_diff',eff_mass,v_diff
 print*,'dNij_tot,cke_dummy',dNij_tot,cke_dummy
 
  temp_dummy = 273.16-10.
          !do i = 1, 40
                    !temp_dummy(i) = 273.16-1.*real(i)
	          CALL Breakup_GG_HH( FRAGMENT_GG,FRAGMENT_HH,temp_dummy,PIE,diam_g_1, &
	                              diam_g_2,diam_g_sphere_1,diam_g_sphere_2, &
		                    cke_dummy,dNij_tot_dummy,dn_fg_by_dt,dn_fh_by_dt)
             
		          
		          print*,'temp_dummy_C,dn_fg_by_dt',temp_dummy-273.16,dn_fg_by_dt
	          !if(MECHANICAL_BREAKUP == 1) then
	          !	IF(FRAGMENT_GG == 1) THEN
	          !		NI_fragments_GG = dn_fg_by_dt 			
	          !		PI_fragments_GG = 920. * (4./3.)*PIE*(10.E-6**3)
	          !		PI_fragments_GG = PI_fragments_GG * NI_fragments_GG
	          !		if(PI_fragments_GG > QGK/dt) then
	          !			PI_fragments_GG = QGK/dt
	          !			NI_fragments_GG = PI_fragments_GG/(920. * (4./3.)*PIE*(10.E-6**3))
	          !		endif
	          !	ENDIF
                    !
	          !	IF(FRAGMENT_HH == 1) THEN
	          !		NI_fragments_HH = dn_fh_by_dt 			
	          !		PI_fragments_HH = 920. * (4./3.)*PIE*(10.E-6**3)
	          !		PI_fragments_HH = PI_fragments_HH * NI_fragments_HH
	          !		if(PI_fragments_HH > QGK/dt) then
	          !			PI_fragments_HH = QGK/dt
	          !			NI_fragments_HH = PI_fragments_HH/(920. * (4./3.)*PIE*(10.E-6**3))
	          !		endif
	          !	ENDIF
	          !	!print*,'NI_fragments_GG,NI_fragments_HH',NI_fragments_GG,NI_fragments_HH
	          !ENDIF
          !enddo
          stop 

 end program hist
SUBROUTINE Breakup_GG_HH(FRAGMENT_GG,FRAGMENT_HH,T_in,PIE,D_graupel_1,D_graupel_2,D_graup_sphere_1,&
	D_graup_sphere_2,cke_gg_in,dNij_in,dn_fg_by_dt,dn_fh_by_dt)	

	
IMPLICIT NONE
INTEGER :: FRAGMENT_GG,FRAGMENT_HH
REAL, INTENT(in) :: T_in,PIE,D_graupel_1,D_graupel_2,D_graup_sphere_1,D_graup_sphere_2,cke_gg_in,dNij_in
REAL :: a_one,T_zero,alpha,a_zero_g,a_zero_h,A_graup,A_hail,B_graup,B_hail,gamma_g,gamma_h,&
	N_fragments_graup,N_fragments_hail 
PARAMETER(B_graup=6.3E6*3.5e-3,B_hail=3.31E5,gamma_g=0.3,gamma_h=0.54,a_zero_h=4.35E9)
REAL,INTENT(inout) :: dn_fg_by_dt,dn_fh_by_dt
REAL :: D_graupel_input, D_graupel_smaller

T_zero = -15. + 273.15 !K

IF(D_graupel_1 < D_graupel_2) THEN
	alpha = PIE*(D_graup_sphere_1**2.) 				!surface area of smaller particle
	D_graupel_smaller = D_graup_sphere_1
ELSE
	alpha = PIE*(D_graup_sphere_2**2.) 			
	D_graupel_smaller = D_graup_sphere_2
ENDIF
IF(D_graupel_1 .GT. 0.5E-2 .AND. D_graupel_2 .GT. 0.5E-2) THEN  !collisions betn real graupel particles less than 0.5cm 
	IF(FRAGMENT_HH == 1) THEN
		!break-up scheme for hail-hail collisions.....
		a_one = a_zero_h/9.
		A_hail = (a_zero_h/3.) + MAX( ((2.*a_zero_h/3.)-(a_one*ABS(T_in-T_zero))), 0.)	
		N_fragments_hail = alpha * A_hail * ( 1. - EXP(-((B_hail*cke_gg_in)/(alpha*A_hail))**gamma_h) )

		if(N_fragments_hail > 1000.) N_fragments_hail = 1000.

		dn_fh_by_dt = dn_fh_by_dt + (dNij_in * N_fragments_hail)
	ENDIF	
ELSE !collisions betn real hail particles greater than 0.5cm 
	IF(FRAGMENT_GG == 1) THEN
		!break-up scheme for graupel-graupel collisions.....

		D_graupel_input = D_graupel_smaller
		if(D_graupel_smaller > 0.005) D_graupel_input = 0.005
		if(D_graupel_smaller < 0.0005) D_graupel_input = 0.0005

		a_zero_g = 1.26E4 * (1.+ 0.0079/(D_graupel_input**1.5))*3.	!here D is the maximum width of smaller particle
		a_one = a_zero_g/9.	
		A_graup = (a_zero_g/3.) + MAX( ((2.*a_zero_g/3.)-(a_one*ABS(T_in-T_zero))), 0.)
		N_fragments_graup = alpha * A_graup * ( 1. - EXP(-((B_graup*cke_gg_in)/(alpha*A_graup))**gamma_g) )
		if(N_fragments_graup > 1000.) N_fragments_graup = 1000.
		dn_fg_by_dt = dn_fg_by_dt + (dNij_in * N_fragments_graup)
	ENDIF
                    print*,'N_fragments_graup,N_fragments_hail',N_fragments_graup,N_fragments_hail
                    !stop 980

ENDIF
	
END SUBROUTINE Breakup_GG_HH

