program hist
implicit none
integer   :: i, j, k, NEW_RF1_SCHEME, EXTRAPOLATE, nkr
parameter(NEW_RF1_SCHEME = 1, EXTRAPOLATE = 1, nkr = 33)
real      :: ndrop_accreted, tempc, dQ_G_by_dt_bigrain, turb_fac_gr, rho_a, delta_n, delta_n_big, delta_n_tiny, mass_RF1, mass_RF1_big, pie, dt, &
             dn_I_by_dt_RACG_RF1, dQ_I_by_dt_RACG_RF1, dE_I_by_dt_RACG_RF1, dn_G_by_dt_RACG_RF1
parameter(pie = 3.14, rho_a = 1.0, dt = 10.)
real,dimension(nkr,nkr,40) :: coll_kernel_gr
real,dimension(nkr) :: n_graupel, n_rain, m_rain, d_rain, m_graupel

open(12,file='coll_kernel_graupel_AC',status='old',action='read')

          do k = 1, 40
                    do i = 1,nkr
                              do j = 1,nkr 
                                        read(12,*)coll_kernel_gr(i,j,k)
                              enddo
                    enddo
          enddo

dn_I_by_dt_RACG_RF1 = 0.; dQ_I_by_dt_RACG_RF1 = 0.; delta_n = 0.; delta_n_big = 0.; delta_n_tiny = 0.;
mass_RF1 = 0.; mass_RF1_big = 0.; dn_G_by_dt_RACG_RF1 = 0.; dQ_G_by_dt_bigrain = 0.;

turb_fac_gr = 10.; !should be less than 100.
n_graupel(1:nkr) = 10.564; n_rain(1:nkr) = 10.13; m_rain(1:nkr) = 0.5; m_graupel(1:nkr) = 0.002; d_rain(1:nkr) = 3.4E-4;
print*,'Enter the number of drops accreted ::'
read(*,*)ndrop_accreted
print*,'Enter Temperature in degC ::'
read(*,*)tempc

          do k = 1, 40
	          do j=1, NKR   ! graupel         
		          do i=1, NKR  ! rain
                                        if(ndrop_accreted > 0.) then
                                                  if(m_graupel(j) < m_rain(i)) then
                                                            if(tempc > 0.) stop 5366
                                                            dQ_G_by_dt_bigrain = dQ_G_by_dt_bigrain + (coll_kernel_gr(j,i,k) *turb_fac_gr* N_graupel(j)*N_rain(i)*M_rain(i)*rho_a) 	
                                                            if(NEW_RF1_SCHEME==1 .and. d_rain(i) > 50.e-6 .and. tempc < 0.) then
                                                                      ! assume all accreted drops are frozen
                                                                      delta_n =  ndrop_accreted*&
                                                                      empirical_RF1fragments_new(tempc, d_rain(i)*1000., EXTRAPOLATE)
                                                                      delta_n_big = ndrop_accreted*&
                                                                      empirical_RF1fragments_big_new(tempc, d_rain(i)*1000.)
                                                                      if(delta_n_big > delta_n)  delta_n_big = delta_n
                                                                      delta_n_tiny = delta_n - delta_n_big

                                                                      mass_RF1 = ((10.e-6**3.) * 4. * PIE / 3.)*900.
                                                                      mass_RF1_big = m_rain(i)/2.5

                                                                      if( m_rain(i) - (mass_RF1*delta_n_tiny + mass_RF1_big* &
                                                                      delta_n_big)/ndrop_accreted < 0. .and. n_rain(i) > 0.) then
                                                                                mass_RF1_big = (m_rain(i)*ndrop_accreted - &
                                                                                mass_RF1*delta_n_tiny)/delta_n_big
                                                                      endif

                                                                      dn_I_by_dt_RACG_RF1 =  dn_I_by_dt_RACG_RF1 + delta_n_tiny / dt
                                                                      dQ_I_by_dt_RACG_RF1 =  dQ_I_by_dt_RACG_RF1 + &
                                                                      delta_n_tiny *mass_RF1 / dt
                                                                      !dE_I_by_dt_RACG_RF1 =  dE_I_by_dt_RACG_RF1 + &
                                                                      !EQR_bin(i)*(delta_n_tiny *mass_RF1 / dt)/m_rain(i)

                                                                      dn_G_by_dt_RACG_RF1 =  dn_G_by_dt_RACG_RF1 + delta_n_big / dt
                                                            endif
                                                  endif
                                        endif
                              enddo
                    enddo
          enddo	

print*, dn_I_by_dt_RACG_RF1, dQ_I_by_dt_RACG_RF1, dn_G_by_dt_RACG_RF1
stop




contains
real function empirical_RF1fragments_new(T_degC, diam_mm, EXTRAPOLATE_RF1)
implicit none
real :: D_0 = 0.05, DeltaD = 0.01, DeltaT = 3., T_start = 3.
integer, intent(IN) :: EXTRAPOLATE_RF1
real, intent(IN):: T_degC, diam_mm
real :: alpha_D1, alpha_D2, alpha_D3, alpha_D4, alpha_D5, n_param1, n_param2, n_param3, n_param4, n_param5, Lor_width, Lor_ctr, &
	grad_D, Lor_const, Lor_offset, n_param, grad_T, zeta, diam,  T_degC_in, diam_mm_in !, zeta_fnc 


T_degC_in = T_degC
if(T_degC_in > 0.) T_degC_in = 0.
if(T_degC_in < -35.)  T_degC_in = -35.


diam_mm_in = diam_mm
if(diam_mm_in < 0.06)  diam_mm_in = 0.06
if(diam_mm_in > 1.6)  diam_mm_in = 1.6

! grad_T = -0.1256*(log10(diam_mm_in)**4.)   -0.3965 *(log10(diam_mm_in)**3.)  -0.4462*(log10(diam_mm_in)**2.)   -0.2108*log10(diam_mm_in)   -0.0348

if(diam_mm_in < 0.4) then
grad_T = 0.

else
!  -0.1839   -0.2017   -0.0512
grad_T = -0.1839 *(log10(diam_mm_in)**2.)   -0.2017 *log10(diam_mm_in)  -0.0512



endif
!  0.1242   -0.2316   -0.9874   -0.0827
Lor_width =   0.1242  *(log10(diam_mm_in)**3.) +  -0.2316*(log10(diam_mm_in)**2.) + -0.9874 *log10(diam_mm_in) -0.0827  
Lor_width = 10.**Lor_width


! Lor_offset = -0.0367*diam_mm_in  +  0.0693
! 3.3708    1.4051   -3.0748   -2.4456

Lor_offset = 3.3708*(log10(diam_mm_in)**3.)  + 1.4051 *(log10(diam_mm_in)**2.)  -3.0748*log10(diam_mm_in)   -2.4456
Lor_offset = 10.**Lor_offset 
!  -1.3999   -5.3285   -3.9847  -15.0332
Lor_ctr =     -1.3999 *(log10(diam_mm_in)**3.)  +   -5.3285*(log10(diam_mm_in)**2.) +  -3.9847  *log10(diam_mm_in) -15.0332

!   -0.5332   -2.9613    1.0606



! 2.4268    3.3274    2.0783    1.2927
zeta =   2.4268*(log10(diam_mm_in)**3.)  +   3.3274 *(log10(diam_mm_in)**2.) + 2.0783*log10(diam_mm_in) +  1.2927
zeta = 10.**zeta 

!


! grad_T = 7.3564204E-04
! print *, 'zeta', zeta
! print *, 'width =', Lor_width
! print *, '1st term =', MAX(Lor_offset + grad_T*T_degC_in,0.)
! print *, ' top of 2nd term', zeta*(Lor_width**2.)
! print *, 'Lor_offset',Lor_offset  
! print *, 'grad_T', grad_T

n_param = MAX(grad_T*T_degC_in,0.)  + zeta*(Lor_width**2.)/(( (T_degC_in - Lor_ctr)**2. + Lor_width**2.))
n_param = n_param *zeta_fnc(diam_mm,D_0, D_0+deltaD, 0., 1.) *zeta_fnc(-T_degC_in, T_start, T_start + deltaT, 0., 1.)
if(diam_mm > 1.6 .and. EXTRAPOLATE_RF1 == 1) then 
	n_param = n_param * diam_mm/1.6 
endif
empirical_RF1fragments_new = n_param 
if (empirical_RF1fragments_new < 0.) empirical_RF1fragments_new = 0.
return 
end function empirical_RF1fragments_new		

real function empirical_RF1fragments_big_new(T_degC, diam_mm)
implicit none
real :: D_0 = 0.05, DeltaD = 0.01, DeltaT = 3., T_start = 3.
real, intent(IN):: T_degC, diam_mm

real :: alpha_D1, alpha_D2, alpha_D3, alpha_D4, alpha_D5, n_param1, n_param2, n_param3, n_param4, n_param5, Lor_width, Lor_ctr, &
	grad_D, Lor_const, Lor_offset, n_param, grad_T,  diam, zeta, T_degC_in, diam_mm_in !, zeta_fnc 


T_degC_in = T_degC
if(T_degC_in > 0.) T_degC_in = 0.
if(T_degC_in < -35.)  T_degC_in = -35.


diam_mm_in = diam_mm
if(diam_mm_in < 0.06)  diam_mm_in = 0.06
if(diam_mm_in > 1.6)  diam_mm_in = 1.6

!  5.7638    7.7373    2.0588   -1.2587

Lor_offset = 5.7638  *(log10(diam_mm_in)**3.)  +   7.7373*(log10(diam_mm_in)**2.) + 2.0588*log10(diam_mm_in) -1.2587  
Lor_offset = 10.**Lor_offset 

!  -0.0118   -0.0072    0.0115    0.0026   -0.0009

! grad_T =  -0.0118 *(log10(diam_mm_in)**4.)  -0.0072  *(log10(diam_mm_in)**3.)  + 0.0115 *(log10(diam_mm_in)**2.) + 0.0026 *log10(diam_mm_in)  -0.0009

grad_T = 0.

!   13.3588   15.7432   -2.6543  -18.4875

Lor_ctr =     13.3588*(log10(diam_mm_in)**3.)  +   15.7432  *(log10(diam_mm_in)**2.) + -2.6543*log10(diam_mm_in) -18.4875



!  28.5888   49.8504   22.4873    8.0481

Lor_width =     28.5888*(log10(diam_mm_in)**3.)  +    49.8504  *(log10(diam_mm_in)**2.) + 22.4873*log10(diam_mm_in) + 8.0481


!  -0.4651   -1.1072   -0.4539    0.5137

zeta =   -0.4651 *(log10(diam_mm_in)**3.)  +      -1.1072 *(log10(diam_mm_in)**2.) +   -0.4539   *log10(diam_mm_in)  + 0.5137

! if(diam_mm_in < 0.4) then
!	zeta =   7.2261  *(log10(diam_mm_in)**3.)  +     17.7403 *(log10(diam_mm_in)**2.) +  13.6818 *log10(diam_mm_in)  + 3.6136
!else
!  -1.9661   -1.2498    0.3370
!	zeta =    -1.9661  *(log10(diam_mm_in)**2.)   -1.2498 *log10(diam_mm_in)  +  0.3370
if(zeta < 0.) stop 5355



n_param =  zeta*(Lor_width**2.)/(( (T_degC_in - Lor_ctr)**2. + Lor_width**2.))

n_param = n_param *zeta_fnc(diam_mm,D_0, D_0+deltaD, 0., 1.)*zeta_fnc(-T_degC_in, T_start, T_start+deltaT, 0., 1.)

empirical_RF1fragments_big_new = n_param 
if (empirical_RF1fragments_big_new < 0.) empirical_RF1fragments_big_new = 0.

return 
end function empirical_RF1fragments_big_new	

real function zeta_fnc(X, X_1, X_2, Hlo, Hhi)
real, intent(in) :: Hlo, Hhi, X, X_1, X_2
real :: a_0, a_1, a_2, a_3, A, B

if(X >= X_2) zeta_fnc = Hhi
if(X <= X_1) zeta_fnc = Hlo 
if(X > X_1 .and. X < X_2) then
	A = 6.*(Hlo - Hhi)/(X_2**3. - X_1**3. + 3.*(X_2*X_1*X_1 - X_1*X_2*X_2) )
	a_3 = (A/3.)
	a_2 = -(A/2.)*(X_1 + X_2)
	a_1 = A*X_2*X_1
	B = Hlo + A*(X_1**3.)/6. - A*X_1*X_1*X_2/2.	
	a_0 = B
	zeta_fnc = a_0 + a_1*X + a_2*X*X + a_3*X*X*X
endif

if( X_2 <= X_1) stop 91919

return 
end function zeta_fnc		

end program
